*realformat "%16.6f"
*intformat "%6i"
*set var quadraticElements=0
*set var quadraticLine=0
*set var quadraticTriangle=0
*set var quadraticQuadrilateral=0
*set var quadraticTetrahedra=0
*set var quadraticHexahedra=0
*set var quadraticPrisma=0
*set var oneDElement=0
*set var twoDElement=0
*set var threeDElement=0
*set var ntria=0
*set var nquad=0 
*set var ntetr=0
*set var nhexa=0
*set var npris=0
*set var nline=0
*set elems(Line)
*loop elems
*set var nline=nline+1
*if(*IsQuadratic)
*set var quadraticLine=1
*endif
*end
*set elems(Triangle)  
*loop elems
*set var ntria=ntria+1
*if(*IsQuadratic)
*set var quadraticTriangle=1
*endif
*end
*set elems(Quadrilateral)  
*loop elems
*set var nquad=nquad+1
*if(*IsQuadratic)
*set var quadraticQuadrilateral=1
*endif
*end
*set elems(Tetrahedra)
*loop elems
*set var ntetr=ntetr+1
*if(*IsQuadratic)
*set var quadraticTetrahedra=1
*endif
*end
*set elems(Hexahedra)  
*loop elems
*set var nhexa=nhexa+1
*if(*IsQuadratic)
*set var quadraticHexahedra=1
*endif
*end
*set elems(Prisma)  
*loop elems
*set var npris=npris+1
*if(*IsQuadratic)
*set var quadraticPrisma=1
*endif
*end
*set var nboun=0
*set var nskew=0
*set var nslav=0
*set var ngive=0
$------------------------------------------------------------
*set elems(Linear)
*add elems(Triangle)  
*add elems(Quadrilateral)
*add elems(Tetrahedra)
*add elems(Hexahedra)
*add elems(Prisma)
DIMENSIONS
NODAL_POINTS=           *npoin
*set var nessl=0
*if(strcasecmp(GenData(Remeshing_strategy),"On")==0 && strcasecmp(GenData(Remeshing_algorithm),"Shear_slip_layer")==0)
*if(ndime==2)
*set Cond DOMAIN_shear_slip_2D   *elems
*else
*set Cond DOMAIN_shear_slip_3D   *elems 
*endif
*loop elems *onlyincond *canrepeat
*set var nessl=nessl+1
*end elems
*set var nessl=nessl/2
  SSL_ELEMENTS=       *nessl
*set var nsssl=0
*set Cond DOMAIN_shear_slip_starting_point
*loop nodes *onlyincond
*set var nsssl=nsssl+1
*end
*set Cond DOMAIN_shear_slip_starting_line
*loop nodes *onlyincond
*set var nsssl=nsssl+1
*end
*if(ndime==3)
*set var nsssl=nsssl/2
*endif
  SSL_STARTING_POINTS=    *nsssl
*endif
*set var kelem=nelem+nessl
  ELEMENTS=             *kelem
  SPACE_DIMENSIONS=     *ndime
*set var NodPerElm1=0
*set var NodPerElm2=0
*set var NodPerElm3=0
*set var NodPerElm4=0
*set var NodPerElm5=0
*set var NodPerElm6=0
*set var NodesLine=2
*set var NodesLineQ=3
*set var NodesTria=3
*set var NodesTriaQ=6
*set var NodesQuad=4
*set var NodesQuadQ=9
*set var NodesHexa=8
*set var NodesHexaQ=20
*set var NodesTetr=4
*set var NodesTetrQ=10
*set var NodesPris=6
*set var NodesPrisQ=0
*set var ElementDimension=0
*set var ntype=0
*set var TypeElement1=0
*set var TypeElement2=0
*set var TypeElement3=0
*set var TypeElement4=0
*set var TypeElement5=0
*set var TypeElement6=0
*set var TypeLine=1
*set var TypeTriangle=2
*set var TypeQuadrilateral=3
*set var TypeTetrahedra=4
*set var TypePrism=5
*set var TypeHexahedra=6
*if(nline>=1)
*set var ntype=ntype+1
*set var ElementDimension=1
*set var oneDElement=1
*set var TypeElement1=TypeLine
*if(quadraticLine==1)
*set var NodPerElm1=NodesLineQ
*else
*set var NodPerElm1=NodesLine
*endif
*endif
*if(ntria>=1)
*set var ntype=ntype+1
*set var ElementDimension=2
*set var twoDElement=1
*if(ntype==2)
*set var TypeElement2=TypeTriangle
*if(quadraticTriangle==1)
*set var NodPerElm2=NodesTriaQ
*else
*set var NodPerElm2=NodesTria
*endif
*endif
*if(ntype==1)
*set var TypeElement1=TypeTriangle
*if(quadraticTriangle==1)
*set var NodPerElm1=NodesTriaQ
*else
*set var NodPerElm1=NodesTria
*endif
*endif
*endif
*if(nquad>=1)
*set var ntype=ntype+1
*set var ElementDimension=2
*set var twoDElement=1
*if(ntype==3)
*set var TypeElement3=TypeQuadrilateral
*if(quadraticQuadrilateral==1)
*set var NodPerElm3=NodesQuadQ
*else
*set var NodPerElm3=NodesQuad
*endif
*endif
*if(ntype==2)
*set var TypeElement2=TypeQuadrilateral
*if(quadraticQuadrilateral==1)
*set var NodPerElm2=NodesQuadQ
*else
*set var NodPerElm2=NodesQuad
*endif
*endif
*if(ntype==1)
*set var TypeElement1=TypeQuadrilateral
*if(quadraticQuadrilateral==1)
*set var NodPerElm1=NodesQuadQ
*else
*set var NodPerElm1=NodesQuad
*endif
*endif
*endif
*if(ntetr>=1)
*set var ntype=ntype+1
*set var ElementDimension=3
*set var threeDElement=1
*if(ntype==4)
*set var TypeElement4=TypeTetrahedra
*if(quadraticTetrahedra==1)
*set var NodPerElm4=NodesTetrQ
*else
*set var NodPerElm4=NodesTetr
*endif
*endif
*if(ntype==3)
*set var TypeElement3=TypeTetrahedra
*if(quadraticTetrahedra==1)
*set var NodPerElm3=NodesTetrQ
*else
*set var NodPerElm3=NodesTetr
*endif
*endif
*if(ntype==2)
*set var TypeElement2=TypeTetrahedra
*if(quadraticTetrahedra==1)
*set var NodPerElm2=NodesTetrQ
*else
*set var NodPerElm2=NodesTetr
*endif
*endif
*if(ntype==1)
*set var TypeElement1=TypeTetrahedra
*if(quadraticTetrahedra==1)
*set var NodPerElm1=NodesTetrQ
*else
*set var NodPerElm1=NodesTetr
*endif
*endif
*endif
*if(npris>=1)
*set var ntype=ntype+1
*set var ElementDimension=3
*set var threeDElement=1
*if(ntype==5)
*set var TypeElement5=TypePrism
*if(quadraticPrisma==1)
*set var NodPerElm5=NodesPrisQ
*else
*set var NodPerElm5=NodesPris
*endif
*endif
*if(ntype==4)
*set var TypeElement4=TypePrism
*if(quadraticPrisma==1)
*set var NodPerElm4=NodesPrisQ
*else
*set var NodPerElm4=NodesPris
*endif
*endif
*if(ntype==3)
*set var TypeElement3=TypePrism
*if(quadraticPrisma==1)
*set var NodPerElm3=NodesPrisQ
*else
*set var NodPerElm3=NodesPris
*endif
*endif
*if(ntype==2)
*set var TypeElement2=TypePrism
*if(quadraticPrisma==1)
*set var NodPerElm2=NodesPrisQ
*else
*set var NodPerElm2=NodesPris
*endif
*endif
*if(ntype==1)
*set var TypeElement1=TypePrism
*if(quadraticPrisma==1)
*set var NodPerElm1=NodesPrisQ
*else
*set var NodPerElm1=NodesPris
*endif
*endif
*endif
*if(nhexa>=1)
*set var ntype=ntype+1
*set var ElementDimension=3
*set var threeDElement=1
*if(ntype==6)
*set var TypeElement6=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm6=NodesHexaQ
*else
*set var NodPerElm6=NodesHexa
*endif
*endif
*if(ntype==5)
*set var TypeElement5=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm5=NodesHexaQ
*else
*set var NodPerElm5=NodesHexa
*endif
*endif
*if(ntype==4)
*set var TypeElement4=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm4=NodesHexaQ
*else
*set var NodPerElm4=NodesHexa
*endif
*endif
*if(ntype==3)
*set var TypeElement3=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm3=NodesHexaQ
*else
*set var NodPerElm3=NodesHexa
*endif
*endif
*if(ntype==2)
*set var TypeElement2=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm2=NodesHexaQ
*else
*set var NodPerElm2=NodesHexa
*endif
*endif
*if(ntype==1)
*set var TypeElement1=TypeHexahedra
*if(quadraticHexahedra==1)
*set var NodPerElm1=NodesHexaQ
*else
*set var NodPerElm1=NodesHexa
*endif
*endif
*endif
*if(threeDElement==1)
*if(nhexa>=1)
     HEXAEDRA_ELEMENTS= *nhexa
*endif
*if(npris>=1)
     PRISMA_ELEMENTS=   *npris
*endif
*if(ntetr>=1)
     TETRAEDRA_ELEMENTS=*ntetr
*endif
*endif
*if(twoDElement==1)
*if(nquad>=1)
     QUADRILAT_ELEMENTS=*nquad
*endif
*if(ntria>=1)
     TRIANGLE_ELEMENTS= *ntria
*endif
*endif 
*if(oneDElement==1)
*if(nline>=1)
     LINE_ELEMENTS=     *nline
*endif
*endif
*if(ntype==6)
  NODES_PER_ELEMENT=    *NodPerElm6,*NodPerElm5,*NodPerElm4,*NodPerElm3,*NodPerElm2,*NodPerElm1
*endif
*if(ntype==5)
  NODES_PER_ELEMENT=    *NodPerElm5,*NodPerElm4,*NodPerElm3,*NodPerElm2,*NodPerElm1
*endif
*if(ntype==4)
  NODES_PER_ELEMENT=    *NodPerElm4,*NodPerElm3,*NodPerElm2,*NodPerElm1
*endif
*if(ntype==3)
  NODES_PER_ELEMENT=    *NodPerElm3,*NodPerElm2,*NodPerElm1
*endif
*if(ntype==2)
  NODES_PER_ELEMENT=    *NodPerElm2,*NodPerElm1
*endif
*if(ntype==1)
  NODES_PER_ELEMENT=    *NodPerElm1
*endif
*if(ntype==6)
  TYPE_OF_ELEMENT=      *TypeElement6,*TypeElement5,*TypeElement4,*TypeElement3,*TypeElement2,*TypeElement1
*endif
*if(ntype==5)
  TYPE_OF_ELEMENT=      *TypeElement5,*TypeElement4,*TypeElement3,*TypeElement2,*TypeElement1
*endif
*if(ntype==4)
  TYPE_OF_ELEMENT=      *TypeElement4,*TypeElement3,*TypeElement2,*TypeElement1
*endif
*if(ntype==3)
  TYPE_OF_ELEMENT=      *TypeElement3,*TypeElement2,*TypeElement1
*endif
*if(ntype==2)
  TYPE_OF_ELEMENT=      *TypeElement2,*TypeElement1
*endif
*if(ntype==1)
  TYPE_OF_ELEMENT=      *TypeElement1
*endif
  BOUNDARIES=        AUTOMATIC
  SKEW_SYSTEMS=         *nskew
END_DIMENSIONS
$------------------------------------------------------------
STRATEGY
  INTEGRATION_RULE:          *GenData(Integration_rule)  
  DOMAIN_INTEGRATION_POINTS: *GenData(Integration_points)  
  ELEMENT_DATA_STRUCTURES:   *GenData(Use_ElementDataStructures)
*if(strcasecmp(GenData(Scaling_of_Geometry),"On")==0)
  SCALE_FACTORS: X_SCALE:    *GenData(X_Scale) Y_SCALE: *GenData(Y_Scale) Z_SCALE: *GenData(Z_Scale)
*endif
*if(strcasecmp(GenData(Translation_of_Geometry),"On")==0)
  TRANSLATIONS: X_TRANSLATION:    *GenData(X_Translation) Y_TRANSLATION: *GenData(Y_Translation) Z_TRANSLATION: *GenData(Z_Translation)
*endif
  OUTPUT MESH_DATA:          *GenData(Output_mesh_data)    
*if(strcasecmp(GenData(PBC_ForcePeriodicMesh),"On")==0)  
  PERIODIC_BC=               *GenData(PeriodicBC) *GenData(PBCx) *GenData(PBCy) *GenData(PBCz) FORCE_PERIODIC_MESH TOLERANCE_ForPerMesh *GenData(PBC_TolForcePeriodicMesh)
*else
  PERIODIC_BC=               *GenData(PeriodicBC) *GenData(PBCx) *GenData(PBCy) *GenData(PBCz)
*endif
  TEST_COMMUNICATIONS=       *GenData(Test_Communications)
*if(strcasecmp(GenData(Mesh_Read_Strategy),"Default")==0)
  READ_STRATEGY=             *GenData(Mesh_Read_Strategy) 
*elseif(strcasecmp(GenData(Mesh_Read_Strategy),"Manufactured")==0)
  READ_STRATEGY=             *GenData(Mesh_Read_Strategy) NPOIN *GenData(Mesh_Manufactured_Npoin) TYPE *GenData(Mesh_Manufactured_Type)
*endif  
  SECOND_NEIGHBOUR_GRAPH:    *GenData(Second_Neighbour_Graph)
  STORE INTERNAL FACES:      *GenData(Store_Internal_Faces)  
  LOCAL_COORDINATES          *GenData(Local_Coordinates)  
END_STRATEGY
$-------------------------------------------------------------
*if(strcasecmp(GenData(Axisymmetry),"On")==0)
GEOMETRY, GID, AXISYMMETRIC
*else
GEOMETRY, GID
*endif
 INCLUDE  *tcl(FemussProblemName).geo.dat
 INCLUDE  *tcl(FemussProblemName).dom.fix
END_GEOMETRY  
$-------------------------------------------------------------
