*if(strcasecmp(GenData(NSTINC_problem),"Off")!=0)
*#####################################################
*#NAVIERSTOKES MODULE PREFIXES: nsi NSTINC *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINITION  
 TEMPORAL_DERIVATIVES: *GenData(NSI_temporal_derivatives)  
 CONVECTIVE_TERM:      *GenData(NSI_convective_term)  
 VISCOUS_TERM:         *GenData(NSI_viscous_term)  
*if(strcasecmp(GenData(NSI_Gravity_acceleration),"Off")==0) 
 GRAVITY:              NORM: 0.0, GX: 0.0, GY: 0.0,  GZ: 0.0  
*else
 GRAVITY:              NORM: *GenData(NSI_Norm_gravity), \
		       GX:   *GenData(NSI_X_gravity), \
		       GY:   *GenData(NSI_Y_gravity), \
		       GZ:   *GenData(NSI_Z_gravity)  
*endif
FRAME_OF_REFERENCE:   *GenData(NSI_FrameOfReference_acceleration)   FUNTY: *GenData(NSI_FOR_Funty) *GenData(NSI_FOR_PARA1) *GenData(NSI_FOR_PARA2) *GenData(NSI_FOR_PARA3) *GenData(NSI_FOR_PARA4) *GenData(NSI_FOR_PARA5) *GenData(NSI_FOR_PARA6)  ACCELERATION: *GenData(NSI_X_FOR) *GenData(NSI_Y_FOR) *GenData(NSI_Z_FOR)
*if(strcasecmp(GenData(NSI_Axes_rotation),"Off")==0)
 CORIOLIS_FORCE:        OFF
*else
 CORIOLIS_FORCE:        ON  *GenData(NSI_X_omega) *GenData(NSI_Y_omega)  *GenData(NSI_Z_omega)  
*endif
*if(strcasecmp(GenData(NSI_Axes_velocity),"Off")==0)
 AXES_VELOCITY:        NORM: 0.0, VX: 0.0, VY: 0.0,  VZ: 0.0  
*else
 AXES_VELOCITY:        NORM: *GenData(NSI_Velocity_norm),  \
		       VX:   *GenData(NSI_X_velocity),  \
		       VY:   *GenData(NSI_Y_velocity),  \
		       VZ:   *GenData(NSI_Z_velocity) 
*endif
*if(strcasecmp(GenData(NSI_Turbulence_model),"Off")==0) 
 TURBULENCE_MODEL:     Off 
*elseif(strcasecmp(GenData(NSI_Turbulence_model),"Smagorinsky")==0)
 TURBULENCE_MODEL:     LES_MODEL,   SMAGO,   PARAMETER: *GenData(NSI_Para_turbulence) 
*elseif(strcasecmp(GenData(NSI_Turbulence_model),"Wale")==0)
 TURBULENCE_MODEL:     LES_MODEL, WALE, PARAMETER: *GenData(NSI_Para_turbulence) 
*endif   
*if(strcasecmp(GenData(NSI_Temperature_coupling),"Off")==0) 
 TEMPERATURE_COUPLING: Off
*elseif(strcasecmp(GenData(NSI_Temperature_coupling),"Boussinesq")==0)
 TEMPERATURE_COUPLING: Boussinesq, BETA: *GenData(NSI_Beta), T_A: *GenData(NSI_T_reference), GX: *GenData(NSI_BoussinesqX_gravity), GY:   *GenData(NSI_BoussinesqY_gravity), GZ:   *GenData(NSI_BoussinesqZ_gravity)   
*elseif(strcasecmp(GenData(NSI_Temperature_coupling),"Low_Mach")==0)
 TEMPERATURE_COUPLING: Low_Mach, INTHP: *GenData(NSI_Initial_Thermo_pres), R: *GenData(NSI_Ideal_gas_constant), GAMMA: *GenData(NSI_Gamma)  T_R: *GenData(NSI_T_reference)
*elseif(strcasecmp(GenData(NSI_Temperature_coupling),"WilliamsLandelFerry")==0)
 TEMPERATURE_COUPLING: Williams, T0: *GenData(NSI_T_reference), C1: *GenData(NSI_c1), C2: *GenData(NSI_c2)
*elseif(strcasecmp(GenData(NSI_Temperature_coupling),"Arrhenius")==0)
 TEMPERATURE_COUPLING: Arrhenius, T0: *GenData(NSI_T_reference), ALPHA *GenData(NSI_alpha)
*endif
 LOGARITHMIC_FORMULATION: *GenData(NSI_Logarithm_Conformation_Reformulation)  *GenData(NSI_k_factor)        
*if(strcasecmp(GenData(NSI_LevelSet_Coupling),"Off")==0) 
 LEVELSET_COUPLING:    Off 
*elseif(strcasecmp(GenData(NSI_LevelSet_Coupling),"On")==0)
 LEVELSET_COUPLING:    On
*endif
*if(strcasecmp(GenData(NSI_LevelSet_Coupling),"On")==0) 
*if(strcasecmp(GenData(NSI_FreeSurface),"On")==0)
 FREE_SURFACE:         On , *GenData(NSI_FreeExternalProblem), *GenData(NSI_FreeDirichlet), *GenData(NSI_FreeDirMethod), PENPA=*GenData(NSI_FreeDirPenaltyParam), *GenData(NSI_FreeDirPostprocessForces)
 NUMBER_FLUIDS=        2
*elseif(strcasecmp(GenData(NSI_FreeSurface),"Off")==0)
 FREE_SURFACE:         Off, *GenData(NSI_FreeExternalProblem), *GenData(NSI_FreeDirichlet), *GenData(NSI_FreeDirMethod), PENPA=*GenData(NSI_FreeDirPenaltyParam), *GenData(NSI_FreeDirPostprocessForces)
 NUMBER_FLUIDS=        *GenData(NSI_NUMBER_FLUIDS)
 ENRICH_PRESSURE=      *GenData(NSI_EnrichPressure) PRESSURE
*endif
*endif
*if(strcasecmp(GenData(NSI_Interface_model),"Off")==0) 
 INTERFACE_MODEL:      Off 
*elseif(strcasecmp(GenData(NSI_Interface_model),"Heavi")==0)
*if(strcasecmp(GenData(NSI_Continue_after_filled),"On")==0)
 INTERFACE_MODEL:      HEAVI , FILLUP: *GenData(NSI_Fill_up_to) , CONTINUE
*else
 INTERFACE_MODEL:      HEAVI , FILLUP: *GenData(NSI_Fill_up_to) 
*endif 
*elseif(strcasecmp(GenData(NSI_Interface_model),"Smohe")==0)
*if(strcasecmp(GenData(NSI_Continue_after_filled),"On")==0)
 INTERFACE_MODEL:      SMOHE, THICKNESS: *GenData(NSI_Para_interface) , FILLUP: *GenData(NSI_Fill_up_to) , CONTINUE
*else
 INTERFACE_MODEL:      SMOHE, THICKNESS: *GenData(NSI_Para_interface) , FILLUP: *GenData(NSI_Fill_up_to) 
*endif 
*elseif(strcasecmp(GenData(NSI_Interface_model),"Pseudo")==0)
*if(strcasecmp(GenData(NSI_Continue_after_filled),"On")==0)
 INTERFACE_MODEL:      PSEUDO, SLOPE: *GenData(NSI_Para_interface) , FILLUP: *GenData(NSI_Fill_up_to) , CONTINUE
*else
 INTERFACE_MODEL:      PSEUDO, SLOPE: *GenData(NSI_Para_interface) , FILLUP: *GenData(NSI_Fill_up_to) 
*endif 
*endif   
*if(strcasecmp(GenData(NSI_Analytical_solution),"On")==0)
 ANALYTICAL_SOLUTION   *GenData(NSI_Function_number)  *GenData(NSI_Analytical_param1)  *GenData(NSI_Analytical_param2)  *GenData(NSI_Analytical_param3)
*endif
*if(strcasecmp(GenData(NSI_BC_Analytical),"On")==0)
 BOUNDARY_ANALYTICAL   *GenData(NSI_BC_number)  
*endif
 SWITCH_OFF: *GenData(NSI_disconnection_of_elements)  
 RESTRICTIONS:  *GenData(NSI_Restrictions)
*if(strcasecmp(GenData(NSI_Restrictions),"On")==0)
 NREST=            *GenData(NSI_Number_of_restrictions)
 REST1=            *GenData(NSI_Rest1)
 REST2=            *GenData(NSI_Rest2)
 REST3=            *GenData(NSI_Rest3)
 REST4=            *GenData(NSI_Rest4)
 REST5=            *GenData(NSI_Rest5)
*endif
 ELASTIC_BOUNDARY: STIFFNESS *GenData(NSI_ELASTIC_BOUNDARY_STIFFNESS) SHEAR_STIFFNESS *GenData(NSI_ELASTIC_BOUNDARY_SHEAR_STIFFNESS) DENSITY *GenData(NSI_ELASTIC_BOUNDARY_DENSITY) DAMPING *GenData(NSI_ELASTIC_BOUNDARY_DAMPING)
*if(strcasecmp(GenData(NSTINC_Compressibility),"On")==0) 
ISENTROPIC_COMPRESSIBILITY:      *GenData(NSTINC_Compressibility)
   DELAY=           *GenData(NSTINC_COMP_Delay)
   FILTERING_FREQ=  *GenData(NSTINC_Filter_Freq)
   ADIABATIC_CONSTANT=       *GenData(NSTINC_Adiabatic_Constant)
   STAG_DENSITY=       *GenData(NSTINC_Stagnation_Density)
   STAG_PRESSURE=       *GenData(NSTINC_Stagnation_Pressure)
   PML:      *GenData(NSTINC_PML)
   ADD_SOUND_SPEED_TO_STAB:      *GenData(NSTINC_Add_Sound_Speed_To_Stab)
*if(strcasecmp(GenData(NSTINC_PML),"On")==0)
         CENTER=   *GenData(NSTINC_CenterX)  *GenData(NSTINC_CenterY)  *GenData(NSTINC_CenterZ)
         SMALL_RADIUS=     *GenData(NSTINC_Small_Radius)
         BIG_RADIUS=      *GenData(NSTINC_Big_Radius)
   END_PML
*endif
END_ISENTROPIC
*endif
*if(strcasecmp(GenData(NSTINC_TunnelWavePropagation),"On")==0) 
TUNNEL WAVE PROPAGATION: *GenData(NSTINC_TunnelWavePropagation)
   DARCY FRICTION: *GenData(NSTINC_TWP_DARCY_FRICTION)
   DARCY COEFFICIENTS: *GenData(NSTINC_TWP_DARCY_COEFFICIENTS)
   DIAMETERS: *GenData(NSTINC_TWP_DIAMETERS)
   DVOL_MODIFY: *GenData(NSTINC_TWP_DVOL_MODIFY)
   TRAIN_WAVE: *GenData(NSTINC_TWP_TRAIN_WAVE) BOFUN: *GenData(NSTINC_TWP_TRAIN_BOFUN) VELOC: *GenData(NSTINC_TWP_TRAIN_VELOC) LENGTH: *GenData(NSTINC_TWP_TRAIN_LENGTH) AREA: *GenData(NSTINC_TWP_TRAIN_AREA)
   TWAVE_FACTORS: *GenData(NSTINC_TWP_TRAIN_FACTORS)
END_TUNNEL_WAVE_PROPAGATION
*endif

*if(strcasecmp(GenData(NSTINC_TimeAndSpaceDependentForces),"On")==0) 
TIME_AND_SPACE FORCES: *GenData(NSTINC_TimeAndSpaceDependentForces)
   SET: *GenData(NSTINC_TASF_Set)
   FUNCTION: *GenData(NSTINC_TASF_Function)
   AXIS: *GenData(NSTINC_TASF_Axis)
   VELOCITY: *GenData(NSTINC_TASF_Velocity)
   FORCES: *GenData(NSTINC_TASF_Forces)
END_TIME_AND_SPACE_FORCES
*endif

*if(strcasecmp(GenData(NSI_TurbulentInletBoundaryConditions),"On")==0)
INLET_TURBU_BC:   *GenData(NSI_TurbulentInletBoundaryConditions)
   LENGTH_SCALES:         *GenData(NSI_TIBC_LENGTH_SCALE) *GenData(NSI_TIBC_LENGTH_SCALE) *GenData(NSI_TIBC_LENGTH_SCALE)             
   U0:            *GenData(NSI_TIBC_U0)
*if(strcasecmp(GenData(NSI_TIBC_DATA_TYPE),"REYNOLDS_STRESSES")==0)
   REYNOLDS_STRESS *GenData(NSI_TIBC_R11) *GenData(NSI_TIBC_R12) *GenData(NSI_TIBC_R13) *GenData(NSI_TIBC_R21) *GenData(NSI_TIBC_R22) *GenData(NSI_TIBC_R23) *GenData(NSI_TIBC_R31) *GenData(NSI_TIBC_R32) *GenData(NSI_TIBC_R33)     
*else
   INTENSITY_TURBULENCE: *GenData(NSI_TIBC_INTENSITY_TURBULENCE)
*endif   
   DELTA:         *GenData(NSI_TIBC_DELTA)  
*if(strcasecmp(GenData(NSI_TIBC_FLOW_TYPE),"PrescribedY_s")==0)
*set var N=GenData(NSI_TIBC_PRESCRIBED_YS,int)
   TYPE:          *GenData(NSI_TIBC_FLOW_TYPE) *N 
*for(i=1;i<=N;i=i+1)
*GenData(NSI_TIBC_PRESCRIBED_YS,*i)  
*end for
 END_TRACKING
*else
   TYPE:          *GenData(NSI_TIBC_FLOW_TYPE) moc
*endif  
END_INLET_TURBU_BC
*endif
*if(strcasecmp(GenData(NSI_TurbulentBodyForces),"On")==0)
TUR_BODY_FORCES: *GenData(NSI_TurbulentBodyForces)
   TX0  : *GenData(NSI_TBF_tx0)
   TY0  : *GenData(NSI_TBF_ty0)
   TXSC : *GenData(NSI_TBF_txsc)
   TYSC : *GenData(NSI_TBF_tysc)   
   TAMPT: *GenData(NSI_TBF_tampt)      
   TDT  : *GenData(NSI_TBF_tdt)
   ZDT  : *GenData(NSI_TBF_zdt)
   XWIDTH  : *GenData(NSI_TBF_xwidth)
   YWIDTH  : *GenData(NSI_TBF_ywidth)
END_TUR_BODY_FORCES
*endif
*if(strcasecmp(GenData(NSI_ExitBodyForces),"On")==0)
EXIT_BODY_FORCES: *GenData(NSI_ExitBodyForces)
   TX0  : *GenData(NSI_EBF_tx0)
   TXSC : *GenData(NSI_EBF_txsc)
   TAMPT: *GenData(NSI_EBF_tampt)      
   OBJECTIVE_VELOC: *GenData(NSI_EBF_OBJECTIVE_VELOC_X) *GenData(NSI_EBF_OBJECTIVE_VELOC_Y) *GenData(NSI_EBF_OBJECTIVE_VELOC_Z)   
END_EXIT_BODY_FORCES
*endif
*if(strcasecmp(GenData(NSI_PorousMedia),"On")==0)
PORUS: *GenData(NSI_PorousMedia)
   MINX  : *GenData(NSI_PME_minX)
   MAXX  : *GenData(NSI_PME_maxX)
   MINY : *GenData(NSI_PME_minY)
   MAXY : *GenData(NSI_PME_maxY)   
   DIST: *GenData(NSI_PME_Dis)      
   PERM1  : *GenData(NSI_PME_perm1)
   PERM2  : *GenData(NSI_PME_perm2)
ENDPR
*endif
*if(strcasecmp(GenData(NSI_PlasmaActuator),"On")==0)
PLASM: *GenData(NSI_PlasmaActuator)
   XINI  : *GenData(NSI_PAC_Xini)
   YINI : *GenData(NSI_PAC_Yini)  
   ZINI: *GenData(NSI_PAC_Zini)      
   ZEND  : *GenData(NSI_PAC_Zend)
   ALENG  : *GenData(NSI_PAC_Length)
   BWIDT  : *GenData(NSI_PAC_Width)
   DISS  : *GenData(NSI_PAC_Distance)
   VOLT : *GenData(NSI_PAC_Voltage)
   RUC : *GenData(NSI_PAC_Ruc)   
   ECC: *GenData(NSI_PAC_ec)      
   EBB  : *GenData(NSI_PAC_Eb)
   DELT  : *GenData(NSI_PAC_Delta)
   ALFA  : *GenData(NSI_PAC_Alfa)
   ACFRE  : *GenData(NSI_PAC_ACfreq)
ENDPL
*endif

*if(strcasecmp(GenData(NSI_EXTRA_INITIAL_VISCOSITY),"On")==0)
EXTRA VISCOSITY:  *GenData(NSI_EXTRA_INITIAL_VISCOSITY)  *GenData(NSI_EIV_VISCO) *GenData(NSI_EIV_NSTEPS)
*endif

*if(strcasecmp(GenData(NSI_SpanwiseForcingBox),"On")==0)
SPANWISE_FORCING_BOX: *GenData(NSI_SpanwiseForcingBox) *GenData(NSI_SFBC_Amplitude)  *GenData(NSI_SFBC_Frequency)  *GenData(NSI_SFBC_Wavelength)  *GenData(NSI_SFBC_Coordinate)  *GenData(NSI_SFBC_Box)  
*endif

*if(strcasecmp(GenData(NSI_COARSE_MESH_TRAINING),"On")==0)
COARSE_MESH_TRAINING: 1
   L2_Projection: *GenData(NSTINC_CM_L2PROJECTION)
   MODEL: *GenData(NSTINC_CM_MODEL)
   INPUT: *GenData(NSTINC_CM_INPUT_DOFS)
   OUTPUT: *GenData(NSTINC_CM_OUTPUT_DOFS)
   TRAINING BOX: *GenData(NSTINC_CM_TRAINING_BOX)
   DELAY: *GenData(NSTINC_CM_DELAY)
 END_CM_TRAINING  
*endif

END_PROBLEM_DEFINITION  
$------------------------------------------------------------
*if(strcasecmp(GenData(NSI_Materials),"Fluid_Solid")==0) 
PROPERTIES, MATERIALS=2
*else
PROPERTIES 
*endif
*if(strcasecmp(GenData(NSI_Materials),"Fluid")==0)
*if(strcasecmp(GenData(NSI_F1_Law_density),"Constant")==0) 
  DENSITY=            *GenData(NSI_F1_Density)
*elseif(strcasecmp(GenData(NSI_F1_Law_density),"twofluid")==0) 
  DENSITY=            *GenData(NSI_F1_Density)
*elseif(strcasecmp(GenData(NSI_F1_Law_density),"Ideal_gas")==0)
  DENSITY=            *GenData(NSI_F1P_Density) *GenData(NSI_F1R_Density)
*endif
  VISCOSITY=          *GenData(NSI_F1_Viscosity)   
  PERMEABILITY=       *GenData(NSI_F1_Permeability)
  LAW_DENSITY:        *GenData(NSI_F1_Law_density)   
*if(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Constant")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Power_Law")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_m_ConsIndex) *GenData(NSI_F1_n_PowerLawIndex)   
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Carreau")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_mu0_Viscosity) *GenData(NSI_F1_n_PowerLawIndex) *GenData(NSI_F1_muInf_Viscosity) *GenData(NSI_F1_lambda) *GenData(NSI_F1_a)
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Oldroyd_B")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Giesekus")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) *GenData(NSI_F1_eps) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"PTT")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) *GenData(NSI_F1_eps) 
*endif
*endif
*if(strcasecmp(GenData(NSI_Materials),"Two_Fluids")==0)
  MATERIAL 1
  DENSITY=            *GenData(NSI_F1_Density)
  VISCOSITY=          *GenData(NSI_F1_Viscosity)   
  PERMEABILITY=       *GenData(NSI_F1_Permeability)
*if(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Constant")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Power_Law")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_m_ConsIndex) *GenData(NSI_F1_n_PowerLawIndex)   
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Carreau")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_mu0_Viscosity) *GenData(NSI_F1_n_PowerLawIndex) *GenData(NSI_F1_muInf_Viscosity) *GenData(NSI_F1_lambda) *GenData(NSI_F1_a)
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Oldroyd_B")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Giesekus")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) *GenData(NSI_F1_eps) 
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"PTT")==0)
  LAW_VISCOSITY:      *GenData(NSI_F1_Law_viscosity) *GenData(NSI_F1_nu0_TotalViscosity) *GenData(NSI_F1_beta) *GenData(NSI_F1_RelaxTime_lambda) *GenData(NSI_F1_eps) 
*endif
  END_MATERIAL 1
    MATERIAL 2
    DENSITY=            *GenData(NSI_F2_Density)
    VISCOSITY=          *GenData(NSI_F2_Viscosity)   
    PERMEABILITY=       *GenData(NSI_F2_Permeability)
*if(strcasecmp(GenData(NSI_F2_Law_Viscosity),"Constant")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) 
*elseif(strcasecmp(GenData(NSI_F2_Law_Viscosity),"Power_Law")==0) 
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) *GenData(NSI_F2_m_ConsIndex) *GenData(NSI_F2_n_PowerLawIndex)   
*elseif(strcasecmp(GenData(NSI_F2_Law_Viscosity),"Carreau")==0)
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) *GenData(NSI_F2_mu0_Viscosity) *GenData(NSI_F2_n_PowerLawIndex) *GenData(NSI_F2_muInf_Viscosity) *GenData(NSI_F2_lambda) *GenData(NSI_F2_a)
*elseif(strcasecmp(GenData(NSI_F2_Law_Viscosity),"Oldroyd_B")==0)
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) *GenData(NSI_F2_nu0_TotalViscosity) *GenData(NSI_F2_beta) *GenData(NSI_F2_RelaxTime_lambda) 
*elseif(strcasecmp(GenData(NSI_F2_Law_Viscosity),"Giesekus")==0)
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) *GenData(NSI_F2_nu0_TotalViscosity) *GenData(NSI_F2_beta) *GenData(NSI_F2_RelaxTime_lambda) *GenData(NSI_F2_eps) 
*elseif(strcasecmp(GenData(NSI_F2_Law_Viscosity),"PTT")==0)
  LAW_VISCOSITY:      *GenData(NSI_F2_Law_viscosity) *GenData(NSI_F2_nu0_TotalViscosity) *GenData(NSI_F2_beta) *GenData(NSI_F2_RelaxTime_lambda) *GenData(NSI_F2_eps) 
*endif
    END_MATERIAL 2
*endif
*if(strcasecmp(GenData(NSI_Materials),"Fluid_Solid")==0) 
*if(ndime==2)
*set elems(Triangle)  
*add elems(Quadrilateral)
*else
*set elems(Tetrahedra)
*add elems(Hexahedra)
*add elems(Prisma)
*endif
  MATERIALS
*loop elems
*if(ElemsMat!=0)
*if(strcasecmp(ElemsMatProp(0),"NSI_SOLID")==0)
   *elemsNum  -1
*endif
*endif
*end
  END_MATERIALS
*endif
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT    
  STABILITY_CONSTANTS:           *GenData(NSI_Tau_1) *GenData(NSI_Tau_2) *GenData(NSI_Tau_3) *GenData(NSI_Tau_4) 
  H_DIFUSION:                    *GenData(NSI_H_DIFUSION) 
*if(strcasecmp(GenData(NSTINC_algorithm),"Monolithic")==0 || strcasecmp(GenData(NSTINC_algorithm),"Total_Fractional_Step")==0)   
*if(strcasecmp(GenData(NSI_Type_of_stabilization),"Split_OSS")==0)
  TYPE_OF_STABILIZATION:         Split OSS
*else
  TYPE_OF_STABILIZATION:         *GenData(NSI_Type_of_stabilization)  
*endif
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Three_Field")==0) 
*if(strcasecmp(GenData(SUP_Type_of_stabilization),"Split_Total")==0)
  TYPE_OF_STABILIZATION:         Split Total
*elseif(strcasecmp(GenData(SUP_Type_of_stabilization),"Split_OSS")==0)
  TYPE_OF_STABILIZATION:         Split OSS
*elseif(strcasecmp(GenData(SUP_Type_of_stabilization),"Split_ALL")==0)
  TYPE_OF_STABILIZATION:         Split ALL
*elseif(strcasecmp(GenData(SUP_Type_of_stabilization),"Total_residual")==0)
  TYPE_OF_STABILIZATION:         TOTAL 
*elseif(strcasecmp(GenData(SUP_Type_of_stabilization),"Residual_projection")==0)
  TYPE_OF_STABILIZATION:         RESID 
*endif
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Three_Field_Pressure_Correction")==0) 
*if(strcasecmp(GenData(SUPFS_Type_of_stabilization),"Split_OSS")==0)
  TYPE_OF_STABILIZATION:         Split OSS
*elseif(strcasecmp(GenData(SUPFS_Type_of_stabilization),"Split_Total")==0)
  TYPE_OF_STABILIZATION:         Split Total
*endif
*endif
  PROJECTION_TYPE=               *GenData(NSI_Projection_Type)
  TEST_FUNCTION_STABILIZATION:   *GenData(NSI_Stabilization_Method)
  TAU_SMOOTHING:                 *GenData(NSI_Tau_Smoothing) *GenData(NSI_TauSmoothNiter)
  FORCE DYNAMIC TAU:             *GenData(NSI_Tau_ForceDynamic)
  ALE_VELOCITY TAU:              *GenData(NSI_ALE_TAU_VELOCITY)
  TRACKING_OF_SUSBSCALES:        *GenData(NSI_Tracking_Subscales)
  BOUNDARIES_PROJECTIONTOZERO:   *GenData(NSI_Boundary_ProjectionToZero)
  RELAXATION_SGS:                *GenData(NSI_Relaxation_SGS)
  ACCURACY_IN_TIME_SGS:          *GenData(NSI_Time_Accuracy_SGS) 
  NON_LINEARITY_SGS:             *GenData(NSI_NonLinear_SGS) ITERATIONS: *GenData(NSI_NonLinearSGS_Iterations) TOLERANCE: *GenData(NSI_NonLinearSGS_Tolerance) *GenData(NSI_IteraScheme_SGS)
*if(strcasecmp(GenData(NSI_Shock_capturing),"Off")==0) 
  SHOCK_CAPTURING:               Off  
*else
  SHOCK_CAPTURING:               *GenData(NSI_Shock_capturing) *GenData(NSI_Value_sh1) *GenData(NSI_Value_sh2)  
*endif
*if(strcasecmp(GenData(NSI_Add_artificial_viscosity),"On")==0)  
  ARTIFICIAL_VISCOSITY:          *GenData(NSI_Artificial_viscosity) ITERATIONS: *GenData(NSI_During_iterations)   
*endif
*if(strcasecmp(GenData(NSI_Penalty_strategy),"Off")==0) 
  PENALTY_STRATEGY:              Off  
*else
  PENALTY_STRATEGY:              *GenData(NSI_Penalty_strategy) *GenData(NSI_Penalty_Parameter)
*endif
  PRES_BY_PARTS:                 *GenData(NSI_Pressure_By_Parts)
  DIRICHLET_DELETE_COLUMNS:      *GenData(NSI_DeleteDirichletColumns)
*if(strcasecmp(GenData(NSI_Subrelax_strategy),"Off")==0) 
  SUBRELAX_STRATEGY:             Off  
*else
  SUBRELAX_STRATEGY:             *GenData(NSI_Subrelax_strategy) *GenData(NSI_Subrelax_value)  
*endif
*if(strcasecmp(GenData(NSI_Incremental_strategy),"Off")==0) 
  INCREMENTAL_STRATEGY:          Off  
*else
  INCREMENTAL_STRATEGY:          *GenData(NSI_Incremental_strategy) *GenData(NSI_Incremental_steps)  *GenData(NSI_lambda_initial)  
*endif
*if(strcasecmp(GenData(NSI_Compute_Exponential_on_Nodes),"On")==0)
  EXPONENTIAL_ON_NODES:          On
*endif
  TEMPORAL_TERM_WEIGHT:          *GenData(NSI_Temporal_weighting)  
  T1_SCHEME:             *GenData(NSI_Time_integration_type)   
  T1_EULER_STEPS:        *GenData(NSI_Euler_steps) 
  SAFETY_FACTOR:         *GenData(NSI_Safety_factor)  
  STEADY_STATE_TOLER:    *GenData(NSI_Steady_state_tolerance)   
  NORM_OF_CONVERGENCE:   *GenData(NSI_Norm_of_convergence)
*if(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Oldroyd_B")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Giesekus")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"PTT")==0)   
*if(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Picard")==0) 
  LINEARIZATION_METHOD_CONVECTIVE:    Picard   
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson")==0) 
  LINEARIZATION_METHOD CONVECTIVE:    Newton-Raphson
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson_Galerkin")==0) 
  LINEARIZATION_METHOD CONVECTIVE:    Newton-Raphson Galerkin 
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson_Stab")==0) 
  LINEARIZATION_METHOD CONVECTIVE:    Newton-Raphson Stabilization  
*endif
*if(strcasecmp(GenData(NSI_Linearization_method_constitutive_terms),"Picard")==0) 
  LINEARIZATION_METHOD CONSTITUTIVE:  Picard   
*elseif(strcasecmp(GenData(NSI_Linearization_method_constitutive_terms),"Newton_Raphson")==0) 
  LINEARIZATION_METHOD CONSTITUTIVE:  Newton-Raphson
*elseif(strcasecmp(GenData(NSI_Linearization_method_constitutive_terms),"Newton_Raphson_Galerkin")==0) 
  LINEARIZATION_METHOD CONSTITUTIVE:  Newton-Raphson Galerkin 
*elseif(strcasecmp(GenData(NSI_Linearization_method_constitutive_terms),"Newton_Raphson_Stab")==0) 
  LINEARIZATION_METHOD CONSTITUTIVE:  Newton-Raphson Stabilization  
*endif
*else
*if(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Picard")==0) 
  LINEARIZATION_METHOD:  Picard   
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson")==0) 
  LINEARIZATION_METHOD:  Newton-Raphson
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson_Galerkin")==0) 
  LINEARIZATION_METHOD:  Newton-Raphson
*elseif(strcasecmp(GenData(NSI_Linearization_method_convective_term),"Newton_Raphson_Stab")==0) 
  LINEARIZATION_METHOD:  Newton-Raphson 
*endif
*endif
  MAXIMUM_NUMBER_OF_IT:  *GenData(NSI_Number_of_internal_iterations)  
  CONVERGENCE_TOLERANCE: *GenData(NSI_Convergence_tolerance)
*if(strcasecmp(GenData(NSI_Coupling_Problem),"On")==0)
  CP_CRITERIA_CONVERGE:  *GenData(NSI_CP_Criteria_convergence)
  CP_CONVERGENCE_TOLERANCE: *GenData(NSI_CP_Convergence_tolerance)
  CP_REGION: *GenData(NSI_CP_Convergence_region)
  FSI_TRANSMISSION_CONDITIONS:	       *GenData(NSI_CP_Transmission_Conditions_Method)	*GenData(NSI_CP_Transmission_Conditions_Strategy)	*GenData(NSI_CP_Penalization_Parameter)
*if(strcasecmp(GenData(NSI_CP_Relax_Pressure),"On")==0)
*if(strcasecmp(GenData(NSI_CP_Pressure_Relaxation_scheme),"Heuristic")==0)
  COUPLING 	PRESSURE 	RELAXATION	On	HEURISTIC
  INITIAL RELAX:  *GenData(NSI_CP_Initial_relaxation_parameter)
  KAPPA INCREASE: *GenData(NSI_CP_Kappa_Increase)
  KAPPA POWER:    *GenData(NSI_CP_Kappa_Power)
  KAPPA MINIM:    *GenData(NSI_CP_Kappa_Minim)
  KAPPA MAXIM:    *GenData(NSI_CP_Kappa_Maxim)
  END_HEURISTIC
*elseif(strcasecmp(GenData(NSI_CP_Pressure_Relaxation_scheme),"Heuristic_PointWise")==0)
  COUPLING 	PRESSURE 	RELAXATION	On	HEUR_POINTWISE
  INITIAL RELAX:  *GenData(NSI_CP_Initial_relaxation_parameter)
  KAPPA INCREASE: *GenData(NSI_CP_Kappa_Increase)
  KAPPA POWER:    *GenData(NSI_CP_Kappa_Power)
  KAPPA MINIM:    *GenData(NSI_CP_Kappa_Minim)
  KAPPA MAXIM:    *GenData(NSI_CP_Kappa_Maxim)
  END_HEURISTIC
*elseif(strcasecmp(GenData(NSI_CP_Pressure_Relaxation_scheme),"Aitken")==0)  
  COUPLING 	PRESSURE 	RELAXATION	On	AITKEN
  INITIAL RELAX:  *GenData(NSI_CP_Initial_relaxation_parameter)
  END_AITKEN
*elseif(strcasecmp(GenData(NSI_CP_Pressure_Relaxation_scheme),"Aitken_PointWise")==0)  
  COUPLING 	PRESSURE 	RELAXATION	On	AITK_POINTWISE
  INITIAL RELAX:  *GenData(NSI_CP_Initial_relaxation_parameter)
  END_AITKEN
*elseif(strcasecmp(GenData(NSI_CP_Pressure_Relaxation_scheme),"Constant")==0)  
  COUPLING 	PRESSURE 	RELAXATION	On	CONSTANT
  INITIAL RELAX:  *GenData(NSI_CP_Relaxation_Parameter)
  END_CONSTANT
*endif	
*endif
*endif
  ERROR_ESTIMATOR:         *GenData(NSI_Error_Estimator), MAX_ERROR: *GenData(NSI_Error_Limits_Max), MIN_ERROR: *GenData(NSI_Error_Limits_Min), CRITERIA: *GenData(NSI_Error_Criteria)    
  FS_STABILIZATION:     *GenData(NSI_FreeStabilization),  *GenData(NSI_FreeParamStabilization), SMOOTH_VELOCITY_AND_H
  ROBIN_BC:     *GenData(NSI_RobinBC),  *GenData(NSI_RobinAlphaValue)  
  INFLOW TOLERANCE: *GenData(NSI_InflowBoundariesTolerance)
  FORCE OUTFLOW PENALTY: *GenData(NSI_ForceOutflowPenalty)
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 PNTBC = *GenData(NSI_pntBC)
 START_POSTPROCES_AT           STEP =*GenData(NSI_Start_postprocess_at_step)
 POSTPROCESS VELOCITY,         STEPS=*GenData(NSI_Postprocess_velocity)
*if(strcasecmp(GenData(NSI_Postprocess_polars_velocity),"On")==0)
 POSTPROCESS POLAR_VELOCITY,   STEPS=*GenData(NSI_Postprocess_velocity) 
*endif
 POSTPROCESS PRESSURE,         STEPS=*GenData(NSI_Postprocess_pressure)
 POSTPROCESS STATISTICS,       STEPS=*GenData(NSI_Postprocess_Statistics), START_TIME=*GenData(NSI_Postprocess_StatStartTime)
 POSTPROCESS STREAMLINES,      STEPS=*GenData(NSI_Postprocess_streamlines)
 POSTPROCESS DENSITY,          STEPS=*GenData(NSI_Postprocess_density)
 POSTPROCESS VISCOSITY,        STEPS=*GenData(NSI_Postprocess_viscosity)
 POSTPROCESS STRESS,           STEPS=*GenData(NSI_Postprocess_stress)
*if(strcasecmp(GenData(NSI_Postprocess_Psi),"On")==0)
*if(strcasecmp(GenData(NSI_Psi_type),"Internal_Variable")==0) 
 POSTPROCESS PSIVAR,           STEPS=*GenData(NSI_Postprocess_stress)
*elseif(strcasecmp(GenData(NSI_Psi_type),"Real_Psi")==0) 
 POSTPROCESS PSIREAL,          STEPS=*GenData(NSI_Postprocess_stress)
*elseif(strcasecmp(GenData(NSI_Psi_type),"Both")==0) 
 POSTPROCESS PSIVAR,           STEPS=*GenData(NSI_Postprocess_stress)
 POSTPROCESS PSIREAL           STEPS=*GenData(NSI_Postprocess_stress)
*endif
*endif
 POSTPROCESS TURBULENT_VISCO,  STEPS=*GenData(NSI_Postprocess_turbulent_viscosity)
 POSTPROCESS NUMERICAL_VISCO,  STEPS=*GenData(NSI_Postprocess_numerical_viscosity)
 POSTPROCESS PERMEABILITY,     STEPS=*GenData(NSI_Postprocess_permeability) 
 POSTPROCESS TAUSMOOTHING,     STEPS=*GenData(NSI_Postprocess_TauSmoothing) 
 POSTPROCESS TAUSTABILIZATION, STEPS=*GenData(NSI_Postprocess_TauStabilization)
 POSTPROCESS BOUNDARY_TRACTIO, STEPS=*GenData(NSI_Postprocess_boundary_traction)
 POSTPROCESS VORTICITY,        STEPS=*GenData(NSI_Postprocess_vorticity)
 POSTPROCESS EXTERNALFORCES,   STEPS=*GenData(NSI_Postprocess_ExternalForces)
 POSTPROCESS QFACTOR,          STEPS=*GenData(NSI_Postprocess_Qfactor)
 POSTPROCESS DIVERGENCE_VEL,   STEPS=*GenData(NSI_Postprocess_divergence)
 POSTPROCESS VeSGS,            STEPS=*GenData(NSI_Postprocess_VeSGS)
 POSTPROCESS DISSIPATION,      STEPS=*GenData(NSI_Postprocess_dissipation)
 POSTPROCESS GPDISSIPATION,    STEPS=*GenData(NSI_Postprocess_GPDissipation)
 POSTPROCESS RESIDUAL,         STEPS=*GenData(NSI_Postprocess_Residual)    
 POSTPROCESS REPRO,            STEPS=*GenData(NSI_Postprocess_Repro)
 POSTPROCESS AVG_VELOC_1D,     STEPS=*GenData(NSI_Postprocess_Avg1DVeloc)
 POSTPROCESS AVG_DISSI_1D,     STEPS=*GenData(NSI_Postprocess_Avg1DDissi)
 POSTPROCESS RELAXTIME,        STEPS=*GenData(NSI_Postprocess_Relaxtime)
 POSTPROCESS EXACT_SOLUTION    STEPS=*GenData(NSI_Postprocess_Exacso)   
 POSTPROCESS NUM_PARAMS: *GenData(NSI_Postprocess_NumPar)
 POSTPROCESS HYDRO_PRESSURE:   *GenData(NSI_Postprocess_Hydro)
 AVG_1D_DIRECTION:             *GenData(NSI_Average_Dimension)
 DIS_COMPUTATION:              *GenData(NSI_Compute_dissipation)
*if(strcasecmp(GenData(NSI_Forces),"On")==0)
 FORCES_AND_MOMENTS:    FX:   *GenData(NSI_X_coeff), \
                        FY:   *GenData(NSI_Y_coeff), \
                        FZ:   *GenData(NSI_Z_coeff), \
                        MX:   *GenData(NSI_X_momen_coeff), \
                        MY:   *GenData(NSI_Y_momen_coeff), \
                        MZ:   *GenData(NSI_Z_momen_coeff), \
                        OX:   *GenData(NSI_X_momen_orig), \
                        OY:   *GenData(NSI_Y_momen_orig), \
                        OZ:   *GenData(NSI_Z_momen_orig)
*endif
*if(*GenData(NSI_Point_Tracking,int))
*set var N=GenData(NSI_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(NSI_Tracking_Coor,*i) *GenData(NSI_Tracking_Coor,*operation(i+1)) *GenData(NSI_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif 
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
*if(strcasecmp(GenData(NSI_fix_pressure_mode),"Yes")==0)
      FIX_PRESSURE=*GenData(NSI_Fix_pressure_on_node), \
*elseif(strcasecmp(GenData(NSI_fix_pressure_mode),"No")==0)
      DONT_FIX_PRESSURE, \
*endif
*if(strcasecmp(GenData(NSI_Weak_Dirichlet),"On")==0)
      WEAK_PENALTY=*GenData(NSI_Weak_Penalty_Constant), \
*endif
*if(strcasecmp(GenData(NSI_Initial_stokes),"On")==0)
      STOKES \
*endif
*if(strcasecmp(GenData(NSI_Restart_Boundaries),"On")==0)
      RESTART_BOUNDARIES \
*endif
*if(strcasecmp(GenData(NSI_Fix_WallLawDeltaForAll),"Yes")==0)
      FIX_WALL_LAW_DELTA_FOR_ALL *GenData(NSI_WallLawDelta) \
*endif
*if(strcasecmp(GenData(NSI_ExchangeLocationWallLaw),"On")==0)
      ExchangeLocationWallLaw \
*endif
  CONTINUE
  INCLUDE *tcl(FemussProblemName).nsi.fix
*if(strcasecmp(GenData(NSI_Initial_function),"3")==0)
      INITIAL_CONDITION: 3 
*endif
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
