*if(strcasecmp(GenData(TEMPER_problem),"on")==0)
*#####################################################
*#TEMPER MODULE PREFIXES: tem TEMPER *this must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------
PROBLEM_DEFINITION
  TEMPORAL_DERIVATIVES:   *GenData(TEM_temporal_derivatives) 
  CONVECTIVE_TERM:        *GenData(TEM_convective_term) , VELOC: *GenData(TEM_convective_from) 
  SOURCE_TERMS:           *GenData(TEM_Source_terms), VALUE: *GenData(TEM_Source_value)  
*if(strcasecmp(GenData(TEM_Source_terms),"user_defined")==0) 
    SPATIAL_PARAMETERS:   *GenData(TEM_Source_spatial1),*GenData(TEM_Source_spatial2),\
                          *GenData(TEM_Source_spatial3),*GenData(TEM_Source_spatial4),\
                          *GenData(TEM_Source_spatial5),*GenData(TEM_Source_spatial6),\
                          *GenData(TEM_Source_spatial7),*GenData(TEM_Source_spatial8),\
                          *GenData(TEM_Source_spatial9),*GenData(TEM_Source_spatia10)
    TIME_FUNCTION:        *GenData(TEM_Time_function_source), \
    PARAMETERS:           *GenData(TEM_Funpar_souce_1),*GenData(TEM_Funpar_souce_2),\ 
                          *GenData(TEM_Funpar_souce_3),*GenData(TEM_Funpar_souce_4),\
                          *GenData(TEM_Funpar_souce_5),*GenData(TEM_Funpar_souce_6)
  END_SOURCE_TERMS
*endif

*if(strcasecmp(GenData(TEM_Source_ThreeField_Coupling),"Off")==0) 
 THREEFIELD_COUPLING:     Off 
*elseif(strcasecmp(GenData(TEM_Source_ThreeField_Coupling),"On")==0)
 THREEFIELD_COUPLING:     On
*endif

*if(strcasecmp(GenData(TEM_Turbulence_model),"Off")==0) 
 TURBULENCE_MODEL:     Off 
*elseif(strcasecmp(GenData(TEM_Turbulence_model),"From_TURBUL")==0)
 TURBULENCE_MODEL:     RANS_DIFFERENTIAL
*elseif(strcasecmp(GenData(TEM_Turbulence_model),"Smagorinsky")==0)
 TURBULENCE_MODEL:     LES_MODEL,   SMAGORINSKY,   PARAMETER: *GenData(TEM_Para_turbulence) 
*elseif(strcasecmp(GenData(TEM_Turbulence_model),"Wale")==0)
 TURBULENCE_MODEL:     LES_MODEL,   WALE,   PARAMETER: *GenData(TEM_Para_turbulence) 
*endif   
*if(strcasecmp(GenData(TEM_Dust_Transport),"Off")==0) 
*else
 DUST_TRANSPORT:      *GenData(TEM_Dust_Transport)    
   PARTICLE SIZE:                *GenData(TEM_DT_Particle_Size)    
   MEDIUM DENSITY:               *GenData(TEM_DT_Medium_Density)    
   MEDIUM DYNAMIC VISCOSITY:     *GenData(TEM_DT_Medium_Dynamic_Viscosity)    
   GRAVITY FORCE:                *GenData(TEM_DT_X_Gravity) *GenData(TEM_DT_Y_Gravity) *GenData(TEM_DT_Z_Gravity)       
 END_DUST_TRANSPORT
*endif
 INTERNAL_BOUNDARIES ENVIRONMENT_TEMPERATURE: *GenData(TEM_Internal_Boundaries_Environment_Temperature)

END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
*if(nmats==0) 
*MessageBox error: No material defined 
*endif
  NUMBER OF MATERIALS: *nmats
  MATERIALS
*loop materials 
   BEGIN_MATERIAL
      IDNUM:            *MatNum
*tcl(FemussWriteTempeDependentProperty DENSITY "Law_Density_Tem" "Density_Tem" "Material_Density_Data_Tem" "      " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty SPECIFIC_HEAT "Law_Specific_Heat_Tem" "Specific_Heat_Tem" "Material_Specific_Heat_Data_Tem" "      " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty THERMAL_COND "Law_Thermal_Cond" "Thermal_Conductivity_Tem" "Material_Thermal_Conductivity_Data_Tem" "      " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty HEAT_TRANSFER "Law_HeatTransferCoefficient_Tem" "HeatTransferCoefficient_Tem" "Material_HeatTransferCoefficient_Data_Tem" "      " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty RADIATION_EMISSIVITY "Law_RadiationEmissivity_Tem" "RadiationEmissivity_Tem" "Material_RadiationEmissivity_Data_Tem" "      " *matprop(0) )
   END_MATERIAL
*end
  END_MATERIALS
  
  VISCOSITY=              *GenData(TEM_Viscosity)  
  TURBULENT_PRANDTL=      *GenData(TEM_Turbulent_Prandtl_number)  
  REACTION=               *GenData(TEM_Reaction)
END_PROPERTIES

$------------------------------------------------------------
END_PHYSICAL_PROBLEM
$------------------------------------------------------------
NUMERICAL_TREATMENT
 STABILITY_CONSTANTS=     *GenData(TEM_Tau_1) *GenData(TEM_Tau_2) *GenData(TEM_Tau_3)
 TYPE_OF_STABILIZATION=   *GenData(TEM_type_of_stabilization)
 PROJECTION_TYPE=         *GenData(TEM_Projection_Type)
 TEST_FUNCTION_STABILIZATION: *GenData(TEM_Stabilization_Method)
 TRACKING_OF_SUSBSCALES=  *GenData(TEM_Tracking_Subscales), RELAXATION: *GenData(TEM_RELAX_SGS), TIME_ACCURACY: *GenData(TEM_TIMEA_SGS) NON_LINEARITY: *GenData(TEM_NONLI_SGS)
 TEMPORAL_TERM_WEIGHTING= *GenData(TEM_Temporal_weighting)  
 SHOCK_CAPTURING=         *GenData(TEM_Shock_capturing), VALUE: *GenData(TEM_Value_sh)  
 T1_SCHEME:               *GenData(TEM_Time_integration_type)   
 T1_EULER_STEPS:          *GenData(TEM_Euler_steps) 
 SAFETY_FACTOR=           *GenData(TEM_Safety_factor)  
 STEADY_STATE_TOLERANCE=  *GenData(TEM_Steady_state_tolerance)  
 NORM_OF_CONVERGENCE:     *GenData(TEM_Norm_of_convergence)   
 MAXIMUM_NUMBER_OF_ITER=  *GenData(TEM_Number_of_internal_iterations)  
 RELAXATION_FACTOR=       *GenData(TEM_Relaxation_factor)
 CONVERGENCE_TOLERANCE=   *GenData(TEM_Convergence_tolerance)  
 ERROR_ESTIMATOR:         *GenData(TEM_Error_Estimator), MAX_ERROR: *GenData(TEM_Error_Limits_Max), MIN_ERROR: *GenData(TEM_Error_Limits_Min), CRITERIA: *GenData(TEM_Error_Criteria)    
 INFLOW TOLERANCE:        *GenData(TEM_InflowBoundariesTolerance)
END_NUMERICAL_TREATMENT

$------------------------------------------------------------
OUTPUT_&_POST_PROCESS_&_INPUT_STRATEGY
 READ_STRATEGY_BOUNDARY_CONDITION:         *GenData(TEM_Boundary_Conditions_Read_Strategy)
*if(strcasecmp(GenData(TEM_Boundary_Conditions_Read_Strategy),"Manufactured")==0)  
 MANUFACTURED_BOUNDARY_CONDITION:     *GenData(TEM_Manufactured_Boundary_Condition) 
*endif
 START_POSTPROCES_AT            STEP =*GenData(TEM_Start_postprocess_at_step)
 POSTPROCESS TEMPER,            STEPS=*GenData(TEM_Postprocess_temperature)
 POSTPROCESS DISSIPATION,       STEPS=*GenData(TEM_Postprocess_dissipation)  
 POSTPROCESS AVG_TEMPE_1D,      STEPS=*GenData(TEM_Postprocess_Avg1DTempe)
 POSTPROCESS AVG_DISSI_1D,      STEPS=*GenData(TEM_Postprocess_Avg1DDissi)
 POSTPROCESS GRADIENT,          STEPS=*GenData(TEM_Postprocess_Gradient)
 POSTPROCESS SHOCK_CAPT_VISCO,  STEPS=*GenData(TEM_Postprocess_ShockCapturingViscosity)
 POSTPROCESS SIGMATERM,         STEPS=*GenData(TEM_Postprocess_SigmaTerm)
 AVG_1D_DIRECTION:             *GenData(TEM_Average_Dimension)
 DIS_COMPUTATION: *GenData(TEM_Compute_dissipation)
 PNTBC:			       *GenData(PNTBC)
 FORCES_AND_MOMENTS: *GenData(TEM_Forces_moments)
 *if(*GenData(TEM_Point_Tracking,int))
*set var N=GenData(TEM_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(TEM_Tracking_Coor,*i) *GenData(TEM_Tracking_Coor,*operation(i+1)) *GenData(TEM_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif 
END_OUTPUT_&_POST-PROCESS
$------------------------------------------------------------
BOUNDARY_CONDITIONS \
      CONSTANT_BOUNDARY_CONDITIONS
 INCLUDE *tcl(FemussProblemName).tem.fix
END_BOUNDARY_CONDITIONS
$------------------------------------------------------------
*endif
