*if(strcasecmp(GenData(OPTICS_problem),"on")==0)
*#####################################################
*#OPTICS MODULE PREFIXES: opt OPTICS *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------
PROBLEM_DEFINITION
  FLOW_FIELD:       *GenData(OPTICS_Flow_Field_from)
  TEMPERATURE: *GenData(OPTICS_Temperature_from)  
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES:
  DENSITY=                *GenData(OPTICS_Density)
  SPECIFIC_HEAT=          *GenData(OPTICS_Specific_heat)  
  THERMAL_COND=           *GenData(OPTICS_Thermal_conductivity)  
  VISCOSITY=              *GenData(OPTICS_Viscosity)  
  TURBULENT_PRANDTL=      *GenData(OPTICS_Turbulent_Prandtl_number)  
  UNITS=                  *GenData(OPTICS_Units)
END_PROPERTIES
$------------------------------------------------------------
END_PHYSICAL_PROBLEM
$------------------------------------------------------------
NUMERICAL_TREATMENT
  DISSIPATION_MODEL=      *GenData(OPTICS_Dissipation_model) *GenData(OPTICS_turbulence_param)
  OBUKHOV_CORRSIN_CT=     *GenData(OPTICS_Obukhov_Constant)
  CONSTANT_HLENGTH=       *GenData(OPTICS_CONSTANT_ELEMENT_LENGTH) *GenData(OPTICS_HLENGTH) 
END_NUMERICAL_TREATMENT
$------------------------------------------------------------
OUTPUT_&_POST_PROCESS
 START_POSTPROCES_AT  STEP =*GenData(OPTICS_Start_postprocess_at_step)
 POSTPROCESS CN2,     STEPS=*GenData(OPTICS_Postprocess_CN2)
 POSTPROCESS CT2,     STEPS=*GenData(OPTICS_Postprocess_CT2)
 
 *if(*GenData(OPTICS_Ray_Tracing,int))
*set var N=GenData(OPTICS_Ray_Coord,int)
*set var numP=operation(N/7)
 NUMBER_OF_RAYS *numP
*for(i=1;i<=N;i=i+7)
*GenData(OPTICS_Ray_Coord,*i) *GenData(OPTICS_Ray_Coord,*operation(i+1)) *GenData(OPTICS_Ray_Coord,*operation(i+2)) *GenData(OPTICS_Ray_Coord,*operation(i+3)) *GenData(OPTICS_Ray_Coord,*operation(i+4)) *GenData(OPTICS_Ray_Coord,*operation(i+5)) *GenData(OPTICS_Ray_Coord,*operation(i+6)) 
*end for
*endif 
 

 WAVE_LENGTH=         *GenData(OPTICS_Wave_Length)
 AVG_1D_CN2=          *GenData(OPTICS_Average_1D_CN2), *GenData(OPTICS_Average_Dimension)
 PNTBC:			       *GenData(PNTBC)
END_OUTPUT_&_POST-PROCESS
*endif
