*if(strcasecmp(GenData(NSCOMP_problem),"Off")!=0)
*#####################################################
*#NSCOMP MODULE PREFIXES: nsc NSCOMP *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
  TEMPORAL_DERIVATIVES: *GenData(NSC_temporal_derivatives)
  CONVECTIVE_TERM:      *GenData(NSC_convective_term)  
  VISCOUS_TERM:         *GenData(NSC_viscous_term)  
*if(strcasecmp(GenData(NSC_Gravity_acceleration),"Off")==0) 
 GRAVITY:              NORM: 0.0, GX: 0.0, GY: 0.0,  GZ: 0.0  
*else
 GRAVITY:              NORM: *GenData(NSC_Norm_gravity), \
                       GX:   *GenData(NSC_X_gravity), \
                       GY:   *GenData(NSC_Y_gravity), \
                       GZ:   *GenData(NSC_Z_gravity)  
*endif
*if(strcasecmp(GenData(NSC_Heat_Sources),"Off")==0) 
 SRCES:              SRCE: 0.0  
*else
 SRCES:              SRCE: *GenData(NSC_Value_heat_source)
*endif
*if(strcasecmp(GenData(NSC_Analytical_solution),"On")==0)
 ANALYTICAL_SOLUTION   *GenData(NSC_Function_number) 
*endif
*if(*GenData(NSC_Damping_Zones,int))
*set var N=GenData(NSC_Damping_Coefficients,int)
*set var numP=operation(N/14)
 DAMPING: *\ 
*for(i=1;i<=N;i=i+14)
*if(i==1) 
*numP *\
*endif 
*GenData(NSC_Damping_Coefficients,*i) *\ 
*GenData(NSC_Damping_Coefficients,*operation(i+1)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+2)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+3)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+4)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+5)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+6)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+7)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+8)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+9)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+10)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+11)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+12)) *\
*GenData(NSC_Damping_Coefficients,*operation(i+13)) *\
*end for
*endif
 INCOMPRESSIBLE_RESTART:      *GenData(NSC_Incompressible_Restart)
*if(strcasecmp(GenData(NSC_Incompressible_Restart),"On")==0) 
      SOUND_SPEED=     *GenData(NSC_Sound_Speed)
      MOLAR_MASS=      *GenData(NSC_Molar_Mass)
      DENSITY=         *GenData(NSC_Initial_Density)
*endif
*if(*GenData(NSC_Absorbing_Layer,int))
*set var N=GenData(NSC_Absorbing_Coord,int)
*set var numP=operation(N/3)
 ABSORBING_LAYER: *\
*numP \
*for(i=1;i<=N;i=i+3)
*GenData(NSC_Absorbing_Coord,*i) *\
*GenData(NSC_Absorbing_Coord,*operation(i+1)) *\
*GenData(NSC_Absorbing_Coord,*operation(i+2)) \
*end for 
 END_ABSORBING_LAYER
*endif
*if(strcasecmp(GenData(NSC_Adaptive_Time_Window),"On")==0)
 TIME_WINDOW:     *GenData(NSC_Adaptive_Time_Window)
   DELAY =  *GenData(NSC_Time_Window_Delay_Steps)
   FREQUENCY = *GenData(NSC_Filtering_Frequency)
 END_TIME_WINDOW
*endif
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
  EQNST= 			  *GenData(NSC_Equation_of_state)
  CPHEAT=           *GenData(NSC_Cp_heat)
  CVHEAT=           *GenData(NSC_Cv_heat)  
  VISCOSITY=        *GenData(NSC_Viscosity)  
  THERMAL_COND=     *GenData(NSC_Thermal_conductivity)  
*if(strcasecmp(GenData(NSC_Relative_Thermodynamic_Properties),"Off")==0) 
  RELATIVE_THERMODYNAMIC:             Off  
*else
  RELATIVE_THERMODYNAMIC:             *GenData(NSC_Relative_Thermodynamic_Properties) *GenData(NSC_Relative_Pressure_value) *GenData(NSC_Relative_Temperature_value) 
*endif
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT    
  STABILITY_CONSTANTS=     *GenData(NSC_Tau_1) *GenData(NSC_Tau_2) *GenData(NSC_Tau_3) *GenData(NSC_Tau_4)
  COMPINC_MACH:                  *GenData(NSC_CompIncompressible_Mach_Tau) 
  TAU_MATRIX:                    *GenData(NSC_Stabilization_matrix) 
*if(strcasecmp(GenData(NSC_Type_of_stabilization),"Residual_projection_OSS")==0)
  TYPE_OF_STABILIZATION:         *GenData(NSC_Type_of_stabilization), COMPUTE_PROJECTION_NONLINEAR_ITERATION: *GenData(NSC_Compute_Projection_Each_Nonlinear_Iteration)
*else
  TYPE_OF_STABILIZATION:         *GenData(NSC_Type_of_stabilization)
*endif
  PROJECTION_TYPE=               *GenData(NSC_Projection_Type)
  TEST_FUNCTION_STABILIZATION:   *GenData(NSC_Stabilization_Method)
  JACOBIAN_GRADIENT:   *GenData(NSC_Euler_jacobian_matrix_gradient)
  T1_SCHEME:             *GenData(NSC_Time_integration_type)   
  T1_EULER_STEPS:        *GenData(NSC_Euler_steps) 
  TRACKING_SUBSCALES:    *GenData(NSC_Tracking_subscales)   
  ACCURACY_IN_TIME_SGS:  *GenData(NSC_Time_Accuracy_SGS)
*if(strcasecmp(GenData(NSC_NonLinear_SGS),"Nonlinear")==0)
      SGS_TYPE:       *GenData(NSC_NonLinear_SGS) 
      SGS_ITERATIONS: *GenData(NSC_NonLinearSGS_Iterations) 
      SGS_TOLERANCE:  *GenData(NSC_NonLinearSGS_Tolerance) 
      SGS_RELAXATION: *GenData(NSC_NonLinearSGS_Relaxation)
      SGS_SCHEME:     *GenData(NSC_NonLinearSGS_Iteration_Scheme)
*endif
  EXPLI_TIME_INTEGRATION: *GenData(NSC_Time_integration_explicit_type)   
  SAFETY_FACTOR:         *GenData(NSC_Safety_factor)  
  STEADY_STATE_TOLER:    *GenData(NSC_Steady_state_tolerance)   
  NORM_OF_CONVERGENCE:   *GenData(NSC_Norm_of_convergence)   
*if(strcasecmp(GenData(NSC_Linearization_method),"Picard")==0) 
  LINEARIZATION_METHOD:  Picard   
*else
  LINEARIZATION_METHOD:  *GenData(NSC_Linearization_method), STEPS_PICARD: *GenData(NSC_Picard_Iterations), STAB_TERMS: *GenData(Newton_Rapshon_StabilizationTerms)
*endif
  MAXIMUM_NUMBER_OF_IT:  *GenData(NSC_Number_of_internal_iterations)  
  CONVERGENCE_TOLERANCE: *GenData(NSC_Convergence_tolerance)
*if(strcasecmp(GenData(NSC_Type_Shock_capturing),"Off")!=0) 
  SHOCK_CAPTURING=       *GenData(NSC_Type_Shock_capturing), *GenData(NSC_Shock_capturing), VALUE: *GenData(NSC_Value_sh)  
*endif
*if(strcasecmp(GenData(NSC_Subrelax_strategy),"Off")==0) 
  SUBRELAX_STRATEGY:             Off  
*else
  SUBRELAX_STRATEGY:             *GenData(NSC_Subrelax_strategy) *GenData(NSC_Subrelax_value)  
*endif
*if(strcasecmp(GenData(NSC_Fix_pressure_on_node),"Yes")==0) 
  EPRES:          *GenData(NSC_pres_penalty_value)  
*endif
  ERROR_ESTIMATOR:         *GenData(NSC_Error_Estimator), MAX_ERROR: *GenData(NSC_Error_Limits_Max), MIN_ERROR: *GenData(NSC_Error_Limits_Min), CRITERIA: *GenData(NSC_Error_Criteria)    
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 START_POSTPROCES_AT           STEP =*GenData(NSC_Start_postprocess_at_step)
 POSTPROCESS VELOCITY,         STEPS=*GenData(NSC_Postprocess_velocity)
 POSTPROCESS PRESSURE,         STEPS=*GenData(NSC_Postprocess_pressure)
 POSTPROCESS TEMPERATURE,      STEPS=*GenData(NSC_Postprocess_temperature)
 POSTPROCESS DENSITY,          STEPS=*GenData(NSC_Postprocess_density)
 POSTPROCESS MOMENTUM,         STEPS=*GenData(NSC_Postprocess_momentum)
 POSTPROCESS ENERGY,           STEPS=*GenData(NSC_Postprocess_energy)
 POSTPROCESS STREAMLINES,      STEPS=*GenData(NSC_Postprocess_streamlines)
 POSTPROCESS HEATFLUX,         STEPS=*GenData(NSC_Postprocess_heatflux)
 POSTPROCESS ARTDIFF,          STEPS=*GenData(NSC_Postprocess_shock_diffusivity)
 POSTPROCESS SGSDIFF,          STEPS=*GenData(NSC_Postprocess_sgs_diffusivity)
 POSTPROCESS SUBSCALES,        STEPS=*GenData(NSC_Postprocess_Subscales)
 POSTPROCESS RESIDUAL,         STEPS=*GenData(NSC_Postprocess_Residual)
 POSTPROCESS REPRO,            STEPS=*GenData(NSC_Postprocess_Repro)
 POSTPROCESS STATI,            STEPS=*GenData(NSC_Postprocess_Statistics)
 POSTPROCESS MANUF,            STEPS=*GenData(NSC_Postprocess_Manufactured_Solution) 
 PNTBC:			       *GenData(PNTBC)
*if(strcasecmp(GenData(NSC_Forces_moments),"On")==0) 
 FORCES_AND_MOMENTS: \
 POSTPROCESS FORCES,    STEPS=*GenData(NSC_Postprocess_fields_forces), \
 FX:   *GenData(NSC_X_force_coeff), FY:   *GenData(NSC_Y_force_coeff), FZ:   *GenData(NSC_Z_force_coeff), \
 MX:   *GenData(NSC_X_momen_coeff), MY:   *GenData(NSC_Y_momen_coeff), MZ:   *GenData(NSC_Z_momen_coeff), \
 OX:   *GenData(NSC_X_momen_orig), OY:   *GenData(NSC_Y_momen_orig), OZ:   *GenData(NSC_Z_momen_orig), \
 FQ:   *GenData(NSC_heat_flux_coeff)
*endif
*if(*GenData(NSC_Point_Tracking,int))
*set var N=GenData(NSC_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(NSC_Tracking_Coor,*i) *GenData(NSC_Tracking_Coor,*operation(i+1)) *GenData(NSC_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif
 READ_STRATEGY_BOUNDARY_CONDITION:         *GenData(NSC_Boundary_Conditions_Read_Strategy)
*if(strcasecmp(GenData(NSC_Boundary_Conditions_Read_Strategy),"Manufactured")==0)  
 MANUFACTURED_BOUNDARY_CONDITION:     *GenData(NSC_Manufactured_Boundary_Condition) 
*endif
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
*if(strcasecmp(GenData(LMN_fix_pressure_mode),"Yes")==0)
      FIX_PRESSURE=*GenData(LMN_Fix_pressure_on_node), \
*elseif(strcasecmp(GenData(LMN_fix_pressure_mode),"No")==0)
      DONT_FIX_PRESSURE, \
*endif
      WALL_DISTANCE=*GenData(NSC_Wall_Distance), \
      CONTINUE
 INCLUDE *tcl(FemussProblemName).nsc.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
