*if(strcasecmp(GenData(LMACHN_problem),"On")==0)
*#####################################################
*#LMACHN MODULE PREFIXES: lmn LMACHN *This must be on line 3
*#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\
FUNCTIONS
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond LOWMACH_volume  *nodes
*Add Cond LOWMACH_surface *nodes
*Add Cond LOWMACH_line    *nodes
*Add Cond LOWMACH_point   *nodes

ON_NODES
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_velocity_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_velocity_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_velocity_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_velocity_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_temperature),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(Type_temperature),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %1i%1i%1i %i %i %i"
*NodesNum  *fx*fy*te *tcl(FemussEvalDirichletCondition *cond(Value_velocity_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_y)  *x   *y   *z)  *tcl(FemussEvalDirichletCondition *cond(Value_temperature)  *x   *y   *z)  *tcl(FemussEvalDirichletCondition *cond(Heat_power)  *x   *y   *z)

*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_velocity_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_velocity_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_velocity_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_velocity_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_velocity_z),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(Type_velocity_z),"Fixed")==0)
*set var fz=1
*endif
*if(strcmp(cond(Type_temperature),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(Type_temperature),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %1i%1i%1i%1i %i %i %i %i"
*NodesNum  *fx*fy*fz*te *tcl(FemussEvalDirichletCondition *cond(Value_velocity_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_z)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_temperature)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Heat_power)  *x   *y   *z)
*end
*endif
END_ON_NODES
*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond LMACHN_Boundary_2D *elems
*else
*set Cond LMACHN_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*if(strcmp(cond(1),"Pressure")==0)
*set var ft=cond(6,int)
*iboun *ElemsNnodeFace *globalnodes 2 *cond(2) *ft
*elseif(strcmp(cond(1),"Wall_law")==0)
*iboun *ElemsNnodeFace *globalnodes 3
*elseif(strcmp(cond(1),"Slip_wall")==0)
*iboun *ElemsNnodeFace *globalnodes 4
*elseif(strcmp(cond(1),"No_slip_wall")==0)
*iboun *ElemsNnodeFace *globalnodes 7
*elseif(strcmp(cond(1),"Symmetry")==0)
*iboun *ElemsNnodeFace *globalnodes 4
*elseif(strcmp(cond(1),"Dynamic_pressure")==0)
*iboun *ElemsNnodeFace *globalnodes 5
*elseif(strcmp(cond(1),"Open_flow")==0)
*iboun *ElemsNnodeFace *globalnodes 6
*elseif(strcmp(cond(1),"Atmospheric_stress")==0)
*iboun *ElemsNnodeFace *globalnodes 8 *cond(2)
*elseif(strcmp(cond(1),"Traction")==0)
*iboun *ElemsNnodeFace *globalnodes 9 *cond(8) *cond(9) *cond(10)
*elseif(strcmp(cond(1),"Fixed")==0)
*set var ft=cond(6,int)
*set var x1=NodesCoord(*localnodes(1),1)
*set var y1=NodesCoord(*localnodes(1),2)
*set var x2=NodesCoord(*localnodes(2),1)
*set var y2=NodesCoord(*localnodes(2),2)
*if(ndime==2)
*set var z0
*if(ElemsNNodeFace==2)
*iboun *ElemsNnodeFace *globalnodes 1 *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z) *ft *icode
*else
*set var x3=NodesCoord(*localnodes(3),1)
*set var y3=NodesCoord(*localnodes(3),2)
*iboun *ElemsNnodeFace *globalnodes 1 *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z)   *ft *icode
*endif
*else
*set var x3=NodesCoord(*localnodes(3),1)
*set var y3=NodesCoord(*localnodes(3),2)
*set var z3=NodesCoord(*localnodes(3),3)
*set var z1=NodesCoord(*localnodes(1),3)
*set var z2=NodesCoord(*localnodes(2),3)
*if(ElemsNNodeFace==3)
*iboun *ElemsNnodeFace *globalnodes 1 \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(5)  *x1   *y1   *z1) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(5)  *x2   *y2   *z2) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(5)  *x3   *y3   *z3)  
*elseif(ElemsNNodeFace==4)
*set var x4=NodesCoord(*localnodes(4),1)
*set var y4=NodesCoord(*localnodes(4),2)
*set var z4=NodesCoord(*localnodes(4),3)
*iboun *ElemsNnodeFace *globalnodes 1 \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(5)  *x1   *y1   *z1) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(5)  *x2   *y2   *z2) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(5)  *x3   *y3   *z3) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x4   *y4   *z4) *tcl(FemussEvalDirichletCondition *cond(4)  *x4   *y4   *z4) *tcl(FemussEvalDirichletCondition *cond(5)  *x4   *y4   *z4)  
*elseif(ElemsNNodeFace==9)
*endif
*endif
*if(strcmp(cond(4),"Heat_flux")==0)
*iboun *ElemsNnodeFace *globalnodes 2 *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *ft
*elseif(strcmp(cond(4),"Wall_law")==0)
*iboun *ElemsNnodeFace *globalnodes 3 *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z) *ft
*elseif(strcmp(cond(4),"Robin")==0)
*iboun *ElemsNnodeFace *globalnodes 2 *cond(2) *cond(3) *cond(4) *ft
*endif
*else
*if(strcmp(cond(4),"Heat_flux")==0)
*iboun *ElemsNnodeFace *globalnodes 2 *cond(6) *ft
*elseif(strcmp(cond(4),"Wall_law")==0)
*iboun *ElemsNnodeFace *globalnodes 3 *cond(5) *ft
*elseif(strcmp(cond(4),"Robin")==0)
*iboun *ElemsNnodeFace *globalnodes 2 *cond(2) *cond(3) *cond(4) *ft
*endif
*endif
*end elems
END_ON_BOUNDARIES
*endif
