*if(strcasecmp(GenData(WAVTI_problem),"Off")!=0)
*#####################################################
*#WAVTI MODULE PREFIX: wti WAVTI *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
 TEMPORAL_DERIVATIVES: *GenData(WTI_temporal_derivatives)  
 RESTRICTIONS:  *GenData(WTI_Restrictions)
END_PROBLEM_DEFINITION  
$------------------------------------------------------------
PROPERTIES
  SPEED=          *GenData(WTI_Speed)
  FRICTION=       *GenData(WTI_Friction)
  RESTRICTIONS:  *GenData(WTI_Restrictions)
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT    
  T1_SCHEME                 *GenData(WTI_tesc1) $ {BDF1,BDF2,BDF3,CNOBS,CN}
  T2_SCHEME                 *GenData(WTI_tesc2) $ {BDF1,BDF2,NEWMARK}
  N_EULER_STEPS             *GenData(WTI_neule) $ number of backward euler steps
  SAFETY_FACTOR             *GenData(WTI_safet) $ automatic time step size safety factor
  STEADY_STATE_TOLER:       *GenData(WTI_sstol) $ steady state tolerance
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 START_POSTPROCES_AT           STEP =*GenData(WTI_Start_postprocess_at_step)
 POSTPROCESS PWAVE             STEPS=*GenData(WTI_Postprocess_pwave)
 POSTPROCESS LIGHTHILL         STEPS=*GenData(WTI_Postprocess_Lighthill)
 PNTBC:			       *GenData(PNTBC)
 *if(*GenData(WTI_Point_Tracking,int))
*set var N=GenData(WTI_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(WTI_Tracking_Coor,*i) *GenData(WTI_Tracking_Coor,*operation(i+1)) *GenData(WTI_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif 
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
      CONTINUE
  INCLUDE *tcl(FemussProblemName).wti.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
