*if(strcasecmp(GenData(ALEMOV_problem),"On")==0)
*#####################################################
*#ALEMOV MODULE PREFIX: ale ALE *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\ 
FUNCTIONS
*if(strcasecmp(GenData(ALE_Time_function_1),"Discrete")==0)
  FUNCTION: 1, DISCRETE, NUMBER_OF_DATA=*GenData(ALE_Funpar1_1)
    INCLUDE *tcl(FemussProblemName).ale.fu1
  END_FUNCTION
*else
  FUNCTION: 1,*GenData(ALE_Time_function_1),\
    PARAMETERS=*GenData(ALE_Funpar1_1),*GenData(ALE_Funpar1_2),*GenData(ALE_Funpar1_3),\
               *GenData(ALE_Funpar1_4),*GenData(ALE_Funpar1_5),*GenData(ALE_Funpar1_6)
*endif
*if(strcasecmp(GenData(ALE_Time_function_2),"Discrete")==0)
  FUNCTION: 2, DISCRETE, NUMBER_OF_DATA=*GenData(ALE_Funpar2_1)
    INCLUDE *tcl(FemussProblemName).ale.fu2
  END_FUNCTION
*else
  FUNCTION: 2,*GenData(ALE_Time_function_2),\
    PARAMETERS=*GenData(ALE_Funpar2_1),*GenData(ALE_Funpar2_2),*GenData(ALE_Funpar2_3),\
               *GenData(ALE_Funpar2_4),*GenData(ALE_Funpar2_5),*GenData(ALE_Funpar2_6)
*endif
*if(strcasecmp(GenData(ALE_Time_function_3),"Discrete")==0)
  FUNCTION: 3, DISCRETE, NUMBER_OF_DATA=*GenData(ALE_Funpar3_1)
    INCLUDE *tcl(FemussProblemName).ale.fu3
  END_FUNCTION
*else
  FUNCTION: 3,*GenData(ALE_Time_function_3),\
    PARAMETERS=*GenData(ALE_Funpar3_1),*GenData(ALE_Funpar3_2),*GenData(ALE_Funpar3_3),\
               *GenData(ALE_Funpar3_4),*GenData(ALE_Funpar3_5),*GenData(ALE_Funpar3_6)
*endif
*if(strcasecmp(GenData(ALE_Time_function_4),"Discrete")==0)
  FUNCTION: 4, DISCRETE, NUMBER_OF_DATA=*GenData(ALE_Funpar4_1)
    INCLUDE *tcl(FemussProblemName).ale.fu4
  END_FUNCTION
*else
  FUNCTION: 4,*GenData(ALE_Time_function_4),\
    PARAMETERS=*GenData(ALE_Funpar4_1),*GenData(ALE_Funpar4_2),*GenData(ALE_Funpar4_3),\
               *GenData(ALE_Funpar4_4),*GenData(ALE_Funpar4_5),*GenData(ALE_Funpar4_6)
*endif
*if(strcasecmp(GenData(ALE_Time_function_5),"Discrete")==0)
  FUNCTION: 5, DISCRETE, NUMBER_OF_DATA=*GenData(ALE_Funpar5_1)
    INCLUDE *tcl(FemussProblemName).ale.fu5
  END_FUNCTION
*else
  FUNCTION: 5,*GenData(ALE_Time_function_5),\
    PARAMETERS=*GenData(ALE_Funpar5_1),*GenData(ALE_Funpar5_2),*GenData(ALE_Funpar5_3),\
               *GenData(ALE_Funpar5_4),*GenData(ALE_Funpar5_5),*GenData(ALE_Funpar5_6)
*endif
END_FUNCTIONS
*\
*\ Write conditions
*\ 
ON_NODES
*Set Cond DISPLACEMENT_volume  *nodes
*Add Cond DISPLACEMENT_surface *nodes
*Add Cond DISPLACEMENT_line    *nodes
*Add Cond DISPLACEMENT_point   *nodes
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_surface")==0)
*set var fx=3
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(1),"NotFixed")==0)
*set var fx=0
*elseif(strcmp(cond(1),"Displacement")==0)
*set var fx=4
*endif
*if(strcmp(cond(2),"Free_surface")==0)
*set var fy=3
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(2),"NotFixed")==0)
*set var fy=0
*elseif(strcmp(cond(2),"Displacement")==0)
*set var fy=4
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(7,int)
*if(strcasecmp(cond(8),"GLOBAL")==0)
*set var icode= 0
*elseif(strcasecmp(cond(8),"LOCAL-Femuss")==0)
*set var icode=2
*else
*set var icode=LocalAxesNum
*endif
*format "%i%i%i%i%i"
*NodesNum *fx*fy *tcl(FemussEvalDirichletCondition *cond(4)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z) *ft *icode
*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_surface")==0)
*set var fx=3
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(1),"NotFixed")==0)
*set var fx=0
*elseif(strcmp(cond(1),"Displacement")==0)
*set var fx=4
*endif
*if(strcmp(cond(2),"Free_surface")==0)
*set var fy=3
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(2),"NotFixed")==0)
*set var fy=0
*elseif(strcmp(cond(2),"Displacement")==0)
*set var fy=4
*endif
*if(strcmp(cond(3),"Free_surface")==0)
*set var fz=3
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fz=1
*elseif(strcmp(cond(3),"NotFixed")==0)
*set var fz=0
*elseif(strcmp(cond(3),"Displacement")==0)
*set var fz=4
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(7,int)
*if(strcasecmp(cond(8),"GLOBAL")==0)
*set var icode=0
*elseif(strcasecmp(cond(8),"LOCAL-Femuss")==0)
*set var icode=2
*else
*set var icode=LocalAxesNum    
*endif
*format "%i%i%i%i%i%i"
*NodesNum  *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(4)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *ft *icode
*end
*endif
*\*Set Cond ROTATION_volume  *nodes
*\*Add Cond ROTATION_surface *nodes
*\*Add Cond ROTATION_line    *nodes
*\*Add Cond ROTATION_point   *nodes
*\*loop nodes *OnlyInCond
*\*if(strcmp(cond(1),"Free_surface")==0)
*\*set var fx=3
*\*elseif(strcmp(cond(1),"Fixed")==0)
*\*set var fx=1
*\*elseif(strcmp(cond(1),"NotFixed")==0)
*\*set var fx=0
*\*endif
*\*if(strcmp(cond(2),"Free_surface")==0)
*\*set var fy=3
*\*elseif(strcmp(cond(2),"Fixed")==0)
*\*set var fy=1
*\*elseif(strcmp(cond(2),"NotFixed")==0)
*\*set var fy=0
*\*endif
*\*set var cx=cond(1,real)
*\*set var cy=cond(2,real)
*\*set var cz=cond(3,real)
*\*set var wx=cond(4,real)
*\*set var wy=cond(5,real)
*\*set var wz=cond(6,real)
*\*set var x =NodesCoord(1)
*\*set var y =NodesCoord(2)
*\*set var z =NodesCoord(3)
*\*format "%6i %12.5e%12.5e%12.5e%12.5e%12.5e%12.5e"
*\  *NodesNum  777 *cx *cy *cz *wx *wy *wz
*\*end
END_ON_NODES
*endif
