*if(strcasecmp(GenData(WAVETM_problem),"On")==0)
*#####################################################
*#WAVETM MODULE PREFIX: wtm WAVETM *This must be on line 3
*#####################################################
*realformat "%13.6e"
*intformat "%9i"
*\
*\ On boundaries
*\ All the conditions are on boundary elements, then, depending on the variational form I, II or III
*\ the conditions are translated to nodes inside FEMUSS and deleted
*\ to force conditions on nodal boundary points when there is ambiguity (the node beween
*\ two boundary elements with different condition) use nodal conditions.
ON_BOUNDARIES $ iboun  nnodb  ipoin_1 ... ipoin_n  code  value  time_function  reference_system
*set var iboun=0
*if(ndime==2)
*set Cond WAVETM_Boundary_2D *elems *CanRepeat
*else
*set Cond WAVETM_Boundary_3D *elems *CanRepeat
*endif
*loop elems *OnlyInCond
*set var iboun=iboun+1
*set var code=0
*set var val_p=0.0
*set var val_ux=0.0
*set var val_uy=0.0
*set var val_uz=0.0
*set var ft=0
*set var rs=0
*\set var val_ux=cond(Value_Velocity_x,real)
*\set var val_uy=cond(Value_Velocity_y,real)
*\set var val_uz=cond(Value_Velocity_z,real)
*set var ft=cond(Time_function,int)
*if(strcmp(cond(TypeCnd),"Fixed_p")==0)
*set var code=101
*set var rs=0
*elseif(strcmp(cond(TypeCnd),"Fixed_un")==0)
*set var code=102
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"NRBC")==0)
*set var code=103
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"Impedance")==0)
*set var code=104
*set var rs=-1
*endif
*\format "%9i %4i %9i %13.6e %13.6e %13.6e %4i"
*iboun *ElemsNnodeFace *globalnodes *code *cond(Value_Pressure,real) *cond(Value_Velocity_x,real) *cond(Value_Velocity_y,real) *cond(Value_Velocity_z,real) *ft *rs
*end elems
END_ON_BOUNDARIES
*\
*\ On nodes
*\ use conditions on nodes for initial conditions and on nodes for boundary conditions where there is ambiguity
*Set Cond WAVETM_volume  *nodes
*Add Cond WAVETM_surface *nodes
*Add Cond WAVETM_line    *nodes
*Add Cond WAVETM_point   *nodes
ON_NODES $ node code    p        u_1            u_2 (u_3) time_function coord_system
*\ Initializations
*set var fp=0
*set var fx=0
*set var fy=0
*set var fz=0
*\set var val_p=0.0
*\set var val_x=0.0
*\set var val_y=0.0
*\set var val_z=0.0
*set var ft=0
*set var rs=0
*\
*\ 2D case
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(TypeCnd),"Initial")==0)
*set var fp=0
*set var ft=cond(Time_function,int)
*set var rs=0
*elseif(strcmp(cond(TypeCnd),"Fixed_p")==0)
*set var fp=9
*set var ft=cond(Time_function,int)
*set var rs=0
*elseif(strcmp(cond(TypeCnd),"Fixed_un")==0)
*set var fp=8
*set var ft=cond(Time_function,int)
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"NRBC")==0)
*set var fp=7
*set var ft=cond(Time_function,int)
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"Impedance")==0)
*set var fp=6
*set var ft=cond(Time_function,int)
*set var rs=-1
*endif
*set var fx=0
*set var fy=0
*set var fz=0
*set var x=NodesCoord(1)
*set var y=NodesCoord(2)
*set var z=NodesCoord(3)
*\if(strcasecmp(cond(Type_of_axis),"GLOBAL")==0)
*\set var rs=0
*\elseif(strcasecmp(cond(Type_of_axis),"LOCAL-Femuss")==0)
*\set var rs=-1
*\else
*\set var rs=LocalAxesNum
*\endif
*format "%9i %1i%1i%1i %13.6e %13.6e %13.6e %3i %3i"
*NodesNum  *fp*fx*fy *cond(Value_Pressure) *cond(Value_Velocity_x) *cond(Value_Velocity_y) *ft *rs
*end
*else
*\
*\ 3D case
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(TypeCnd),"Initial")==0)
*set var ft=cond(Time_function,int)
*set var rs=0
*elseif(strcmp(cond(TypeCnd),"Fixed_p")==0)
*set var fp=9
*set var ft=cond(Time_function,int)
*set var rs=0
*elseif(strcmp(cond(TypeCnd),"Fixed_un")==0)
*set var fp=8
*set var ft=cond(Time_function,int)
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"NRBC")==0)
*set var fp=7
*set var ft=cond(Time_function,int)
*set var rs=-1
*elseif(strcmp(cond(TypeCnd),"Impedance")==0)
*set var fp=6
*set var ft=cond(Time_function,int)
*set var rs=-1
*endif
*set var fx=0
*set var fy=0
*set var fz=0
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%9i %1i%1i%1i%i %13.6e %13.6e %13.6e %13.6e %3i %3i"
*NodesNum  *fp*fx*fy*fz *cond(Value_Pressure) *cond(Value_Velocity_x) *cond(Value_Velocity_y) *cond(Value_Velocity_z) *ft *rs
*end
*endif
END_ON_NODES
*endif
