*if(strcasecmp(GenData(WAVETM_problem),"Off")!=0)
*#####################################################
*#WAVETM MODULE PREFIX: wtm WAVETM *This must be on line 3
*#####################################################
#-wtm_log_summary
#-wtm_ksp_view
#-wtm_info
########################## DEFAULT ITERATIVE SOLVER
-wtm_mat_type mpibaij
# richardson chebychev cg bicg gmres fgmres dgmres gcr bcgs cgs tfqmr tcqmr cr lsqr preonly
-wtm_ksp_type gmres
-wtm_ksp_rtol 1e-8
#-wtm_ksp_atol 1e-50
#-wtm_ksp_divtol 1e5
#-wtm_ksp_max_it 1e5
-wtm_ksp_initial_guess_nonzero 1
#-wtm_ksp_pc_side right
#-wtm_ksp_gmres_restart
#-wtm_ksp_gmres_classicalgramschmidt
#-wtm_ksp_gmres_modifiedgramschmidt
#-wtm_ksp_gmres_cgs_refinement_type none,ifneeded,always

# jacobi bjacobi sor eisenstat icc ilu asm gamg ksp composite
-wtm_pc_type bjacobi
#-wtm_pc_asm_type basic, interpolate,restrict, none
#-wtm_pc_asm_local_subdomains
#-wtm_pc_asm_overlap 3
#-wtm_pc_bjacobi_local_blocks
#-wtm_pc_bjacobi_blocks n

#-wtm_sub_ksp_type 

#-wtm_sub_pc_type ilu,sor
#-wtm_sub_pc_type ilu
#-wtm_sub_pc_factor_levels 10
#-wtm_sub_pc_factor_reuse_ordering
#-wtm_sub_pc_factor_reuse_fill
#-wtm_sub_pc_factor_in_place
#-wtm_sub_pc_factor_nonzeros_along_diagonal
#-wtm_sub_pc_factor_diagonal_fill
#-wtm_sub_pc_factor_mat_ordering natural,nd,1wd,rcm,qmd
#-wtm_sub_pc_factor_mat_ordering_type natural,nd,1wd,rcm,qmd
# use -wtm_info to guess this value
#-wtm_sub_pc_ilu_fill 2.17
#-wtm_sub_pc_sor_omega 
#-wtm_sub_pc_sor_its 
#-wtm_sub_pc_sor_lits 
#-wtm_sub_pc_sor_backward
#-wtm_sub_pc_sor_symmetric
#-wtm_sub_pc_sor_local_forward
#-wtm_sub_pc_sor_local_backward
#-wtm_sub_pc_sor_local_symmetric

########################## DIRECT SOLVER
#-wtm_ksp_type preonly
#-wtm_ksp_rtol 1e-12
#-wtm_pc_type lu
#-wtm_pc_factor_fill 2.17
#-wtm_pc_type asm
#-wtm_sub_pc_type lu
#-wtm_mat_type mpibaij

########################## DIRECT SOLVER USING MUMPS
#-wtm_mat_type mpibaij
#-wtm_ksp_type preonly
#-wtm_pc_type lu
#-wtm_pc_factor_mat_solver_type mumps

########################## TRILINOS ML SOLVER
#-wtm_mat_type mpiaij
#-wtm_ksp_type bcgs
#-wtm_ksp_rtol 1e-8
#-wtm_pc_type ml
#-wtm_pc_mg_cycles 2
#-wtm_pc_mg_smoothup 5
#-wtm_pc_mg_smoothdown 1
#-wtm_pc_mg_type multiplicative

*endif
