*if(strcasecmp(GenData(LEVSET_problem),"on")==0)
*#####################################################
*#LEVSET MODULE PREFIX: lev LEVSET *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------
PROBLEM_DEFINITION
  TEMPORAL_DERIVATIVES:   *GenData(LEV_temporal_derivatives) 
  EXACT_LEVELSET:         *GenData(LEV_exact)          
  ADVECTION:         *GenData(LEV_Convective_Term)            
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES:
END_PROPERTIES
$------------------------------------------------------------
END_PHYSICAL_PROBLEM
$------------------------------------------------------------
NUMERICAL_TREATMENT
 STABILITY_CONSTANTS=     *GenData(LEV_Tau_1) *GenData(LEV_Tau_2) *GenData(LEV_Tau_3)
 INIT_REDISTANCE:         *GenData(LEV_InitialRedistance)
 REINITIALIZATION_SCHEME: *GenData(LEV_reinit)
 NSTEPS_REINITIALIZATION: *GenData(LEV_NSTEPS_REINIT)
 MASS_CORRECTION:         *GenData(LEV_MassCorrection)
 ALE_TYPE:			        *GenData(LEV_ALE_Type)
 T1_SCHEME:               *GenData(LEV_Time_integration_type)   
 T1_EULER_STEPS:          *GenData(LEV_Euler_steps) 
 SAFETY_FACTOR:           *GenData(LEV_Safety_factor)  
 STEADY_STATE_TOLER:      *GenData(LEV_Steady_state_tolerance)  
 NORM_OF_CONVERGENCE:     *GenData(LEV_Norm_of_convergence)   
 MAXIMUM_NUMBER_OF_ITER=  *GenData(LEV_Number_of_internal_iterations)  
 CONVERGENCE_TOLERANCE=   *GenData(LEV_Convergence_tolerance) 
 ERROR_ESTIMATOR:         *GenData(Lev_Error_Estimator), PARA1: *GenData(Lev_Error_PARAM1), PARA2: *GenData(Lev_Error_PARAM2), PARA3: *GenData(Lev_Error_PARAM3)
END_NUMERICAL_TREATMENT
$------------------------------------------------------------
OUTPUT_&_POST_PROCESS
 START_POSTPROCES_AT            STEP =*GenData(LEV_Start_postprocess_at_step)
 POSTPROCESS LEVELSET,          STEPS=*GenData(LEV_Postprocess_Levelset)
 BEGSTE_POSTPROCESS:            *GenData(LEV_BEGSTE_POSTPROCESS)
 PNTBC:			       *GenData(PNTBC)
 
*if(*GenData(LEV_HeightGauges,int))
*set var N=GenData(LEV_Height_Coor,int)
*set var numP=operation(N/6)
HEIGHT_GAUGES *operation(numP)
*for(i=1;i<=numP;i=i+1)
   *GenData(LEV_Height_Coor,*operation(6*(i-1)+1)) *GenData(LEV_Height_Coor,*operation(6*(i-1)+2)) *GenData(LEV_Height_Coor,*operation(6*(i-1)+3)) *GenData(LEV_Height_Coor,*operation(6*(i-1)+4)) *GenData(LEV_Height_Coor,*operation(6*(i-1)+5)) *GenData(LEV_Height_Coor,*operation(6*(i-1)+6))
*end for
*endif

END_OUTPUT_&_POST-PROCESS
$------------------------------------------------------------
BOUNDARY_CONDITIONS \
      CONSTANT_BOUNDARY_CONDITIONS
 INCLUDE *tcl(FemussProblemName).lev.fix
END_BOUNDARY_CONDITIONS
$------------------------------------------------------------
*endif
