*if(strcasecmp(GenData(SOLIDS_problem),"Off")!=0)
*#####################################################
*#SOLIDS MODULE PREFIX: sld SOLIDS *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
  TEMPORAL_DERIVATIVES: *GenData(SLD_temporal_derivatives)  
*if(strcasecmp(GenData(SLD_Gravity_acceleration),"Off")==0) 
  GRAVITY:              NORM: 0.0, GX: 0.0, GY: 0.0,  GZ: 0.0  
*else
  GRAVITY:             NORM: *GenData(SLD_Norm_gravity), \
                       GX:   *GenData(SLD_X_gravity), \
                       GY:   *GenData(SLD_Y_gravity), \
                       GZ:   *GenData(SLD_Z_gravity)  
*endif
*if(strcasecmp(GenData(SLD_body_force),"On")==0) 
  BODY_FORCE:              
                       FX:   *GenData(SLD_X_force), \
                       FY:   *GenData(SLD_Y_force), \
                       FZ:   *GenData(SLD_Z_force)  
*endif
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
  SLD_MODEL=        *GenData(SLD_Material_model)  
  DENSITY=          *GenData(SLD_density)  
  YOUNG=            *GenData(SLD_young)  
  POISSON=          *GenData(SLD_poisson)  
*if(strcasecmp(GenData(SLD_temporal_derivatives),"On")==0) 
  DAMPING(%)        *GenData(SLD_damping)
*endif
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT
*if(strcasecmp(GenData(SLD_temporal_derivatives),"On")==0) 
  T2_SCHEME                 *GenData(SLD_Time_integration_2nd_type) $ {NEWMA}
  SAFETY_FACTOR:            *GenData(SLD_Safety_factor)  
*endif
  STEADY_STATE_TOLER:       *GenData(SLD_Steady_state_tolerance)   
  NORM_OF_CONVERGENCE:      *GenData(SLD_Norm_of_convergence)   
  CONVERGENCE_TOLERANCE:    *GenData(SLD_Convergence_tolerance)
  CP_CONVERGENCE_TOLERANCE: *GenData(SLD_CP_Convergence_tolerance)
  MAXIMUM_NUMBER_OF_IT:     *GenData(SLD_Number_of_internal_iterations)
  RELTR:                    *GenData(SLD_Traction_relaxation) $Relaxation factor for tractions (FSI)
  RELDI:                    *GenData(SLD_Disp_relaxation) $Relaxation factor for tractions (FSI)
  RELFO:                    *GenData(SLD_Force_relaxation)    $Relaxation factor for forces (non linearity)
  AITKEN_RELAXATION:        *GenData(SLD_AITKEN)    $Relaxation factor for forces (non linearity)
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 PNTBC = *GenData(SLD_pntBC)
 START_POSTPROCES_AT        STEP =*GenData(SLD_Start_postprocess_at_step)
 POSTPROCESS DISPLACEMENT,  STEPS=*GenData(SLD_Postprocess_displacement)
 POSTPROCESS STRESS,        STEPS=*GenData(SLD_Postprocess_stress)
 POSTPROCESS STRAIN,        STEPS=*GenData(SLD_Postprocess_strain)
 POSTPROCESS VELOCITY,      STEPS=*GenData(SLD_Postprocess_velocity)
 POSTPROCESS INTTRACTION,   STEPS=*GenData(SLD_Postprocess_inttraction)
 POSTPROCESS EXTTRACTION,   STEPS=*GenData(SLD_Postprocess_exttraction)
 POSTPROCESS FLDTRACTION,   STEPS=*GenData(SLD_Postprocess_fldtraction)
 POSTPROCESS PSTRAINS,      STEPS=*GenData(SLD_Postprocess_pstrains)
*if(*GenData(SLD_Point_Tracking,int))
*set var N=GenData(SLD_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(SLD_Tracking_Coor,*i) *GenData(SLD_Tracking_Coor,*operation(i+1)) *GenData(SLD_Tracking_Coor,*operation(i+2)) 
*end for

 END_TRACKING
*endif
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
 CONSTANT_BOUNDARY_CONDITIONS
  INCLUDE *tcl(FemussProblemName).sld.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
