*if(strcasecmp(GenData(SOLIDS_problem),"On")==0)
*#####################################################
*#SOLIDS MODULE PREFIX: sld SOLIDS *This must be on line 3
*#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\
FUNCTIONS
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond SOLIDS_volume  *nodes
*Add Cond SOLIDS_surface *nodes
*Add Cond SOLIDS_line    *nodes
*Add Cond SOLIDS_point   *nodes

ON_NODES
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_displacement_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_displacement_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_displacement_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_displacement_y),"Fixed")==0)
*set var fy=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i%i%i%i%i"
*NodesNum *fx*fy *tcl(FemussEvalDirichletCondition *cond(Value_displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_y)  *x   *y   *z)  
*end 
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_displacement_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_displacement_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_displacement_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_displacement_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_displacement_z),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(Type_displacement_z),"Fixed")==0)
*set var fz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i%i%i%i%i%i%i"
*NodesNum  *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(Value_displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_z)  *x   *y   *z)  
*end
*endif
END_ON_NODES

*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond SLD_Boundary_2D *elems
*else
*set Cond SLD_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*if(strcmp(cond(1),"Traction")==0)
*set var x=NodesCoord(1,1)
*set var y=NodesCoord(1,2)
*set var z=NodesCoord(1,3)
*set var nface = ElemsNnodeFace
*if(nface == 2)
*iboun *nface *globalnodes(1) *globalnodes(2)  2 *cond(Value_Traction_x) *cond(Value_Traction_y)
*elseif(nface== 3)
*iboun *nface *globalnodes(1) *globalnodes(2) *globalnodes(3) 2 *cond(Value_Traction_x) *cond(Value_Traction_y)
*endif
*endif
*end elems
END_ON_BOUNDARIES

*Set Cond SOURCE_point   *nodes
*Add Cond SOURCE_line   *nodes
SOURCE
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_Traction_x),"Free_or_initial")==0)
*set var pfx=0
*elseif(strcmp(cond(Type_Traction_x),"Fixed")==0)
*set var pfx=1
*endif
*if(strcmp(cond(Type_Traction_y),"Free_or_initial")==0)
*set var pfy=0
*elseif(strcmp(cond(Type_Traction_y),"Fixed")==0)
*set var pfy=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i% %i %i"
*NodesNum  *GenData(SLD_constant_Point_force)  *GenData(SLD_Force_duration) *tcl(FemussEvalDirichletCondition *cond(Value_Traction_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Traction_y)  *x   *y   *z) 
*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(Type_Traction_x),"Free_or_initial")==0)
*set var pfx=0
*elseif(strcmp(cond(Type_Traction_x),"Fixed")==0)
*set var pfx=1
*endif
*if(strcmp(cond(Type_Traction_y),"Free_or_initial")==0)
*set var pfy=0
*elseif(strcmp(cond(Type_Traction_y),"Fixed")==0)
*set var pfy=1
*endif
*if(strcmp(cond(Type_Traction_z),"Free_or_initial")==0)
*set var pfz=0
*elseif(strcmp(cond(Type_Traction_z),"Fixed")==0)
*set var pfz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum *pfx*pfy*pfz *tcl(FemussEvalDirichletCondition *cond(Value_Traction_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Traction_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Traction_z)  *x   *y   *z)
*end
*endif
END_SOURCE
*endif
