*if(strcasecmp(GenData(PLCd_problem),"Off")!=0)
#####################################################
*#PLCD MODULE PREFIXES: plcd PLCD *This must be on line 3
#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\ 
FUNCTIONS
*if(strcasecmp(GenData(PLCD_Boundary_function_1),"Discrete")==0)
  FUNCTION: 1, DISCRETE, NUMBER_OF_DATA=*GenData(PLCD_Funpar1_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu1
  END_FUNCTION
*else
  FUNCTION: 1,*GenData(PLCD_Boundary_function_1),\
    PARAMETERS=*GenData(PLCD_Funpar1_1),*GenData(PLCD_Funpar1_2),*GenData(PLCD_Funpar1_3),\
	       *GenData(PLCD_Funpar1_4),*GenData(PLCD_Funpar1_5),*GenData(PLCD_Funpar1_6)
*endif
*if(strcasecmp(GenData(PLCD_Boundary_function_2),"Discrete")==0)
  FUNCTION: 2, DISCRETE, NUMBER_OF_DATA=*GenData(PLCD_Funpar2_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu2
  END_FUNCTION
*else
  FUNCTION: 2,*GenData(PLCD_Boundary_function_2),\
    PARAMETERS=*GenData(PLCD_Funpar2_1),*GenData(PLCD_Funpar2_2),*GenData(PLCD_Funpar2_3),\
	       *GenData(PLCD_Funpar2_4),*GenData(PLCD_Funpar2_5),*GenData(PLCD_Funpar2_6)
*endif
*if(strcasecmp(GenData(PLCD_Boundary_function_3),"Discrete")==0)
  FUNCTION: 3, DISCRETE, NUMBER_OF_DATA=*GenData(PLCD_Funpar3_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu3
  END_FUNCTION
*else
  FUNCTION: 3,*GenData(PLCD_Boundary_function_3),\
    PARAMETERS=*GenData(PLCD_Funpar3_1),*GenData(PLCD_Funpar3_2),*GenData(PLCD_Funpar3_3),\
	       *GenData(PLCD_Funpar3_4),*GenData(PLCD_Funpar3_5),*GenData(PLCD_Funpar3_6)
*endif
*if(strcasecmp(GenData(PLCD_Boundary_function_4),"Discrete")==0)
  FUNCTION: 4, DISCRETE, NUMBER_OF_DATA=*GenData(PLCD_Funpar4_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu4
  END_FUNCTION
*else
  FUNCTION: 4,*GenData(PLCD_Boundary_function_4),\
    PARAMETERS=*GenData(PLCD_Funpar4_1),*GenData(PLCD_Funpar4_2),*GenData(PLCD_Funpar4_3),\
	       *GenData(PLCD_Funpar4_4),*GenData(PLCD_Funpar4_5),*GenData(PLCD_Funpar4_6)
*endif
*if(strcasecmp(GenData(PLCD_Boundary_function_5),"Discrete")==0)
  FUNCTION: 5, DISCRETE, NUMBER_OF_DATA=*GenData(PLCD_Funpar5_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu5
  END_FUNCTION
*else
  FUNCTION: 5,*GenData(PLCD_Boundary_function_5),\
    PARAMETERS=*GenData(PLCD_Funpar5_1),*GenData(PLCD_Funpar5_2),*GenData(PLCD_Funpar5_3),\
	       *GenData(PLCD_Funpar5_4),*GenData(PLCD_Funpar5_5),*GenData(PLCD_Funpar5_6)
*endif
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond PLCd_volume  *nodes
*Add Cond PLCd_surface *nodes
*Add Cond PLCd_line    *nodes
*Add Cond PLCd_point   *nodes

ON_NODES
*for(i=1;i<=GenData(PLCd_Number_of_Stages:,int);i=i+1)
  STAGE *i
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond *canrepeat
*set var N=cond(Stage_of_application,int)
*if(N==i || N==0)
*if(strcmp(cond(Type_displacement_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_displacement_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_displacement_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_displacement_y),"Fixed")==0)
*set var fy=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(BoundaryFunction,int)
*format "%i %i%i %i %i"
*NodesNum  *fx*fy *tcl(FemussEvalDirichletCondition *cond(Value_displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_y)  *x   *y   *z) *ft 
*endif
*end 
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond *canrepeat
*set var N=cond(Stage_of_application,int)
*if(N==i || N==0)
*if(strcmp(cond(Type_displacement_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_displacement_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_displacement_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_displacement_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_displacement_z),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(Type_displacement_z),"Fixed")==0)
*set var fz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(BoundaryFunction,int)
*format "%i %1i%1i%1i %i %i %i"
*NodesNum  *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(Value_displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_displacement_z)  *x   *y   *z)  *ft
*endif
*end
*endif
  END_STAGE
*endfor
  VELOCITY
*if(ndime==2)
*Set Cond PLCD_Initial_Velocity_2D *nodes
*loop nodes *OnlyInCond 
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i %i %i"
*NodesNum *tcl(FemussEvalDirichletCondition *cond(Value_velocity_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_y)  *x   *y   *z)  
*end
*else
*Set Cond PLCD_Initial_Velocity_3D *nodes
*loop nodes *OnlyInCond 
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i %i %i"
*NodesNum *tcl(FemussEvalDirichletCondition *cond(Value_velocity_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_velocity_z)  *x   *y   *z)   
*end
*endif
  END_VELOCITY
END_ON_NODES
*\
*\ On boundaries
*\
ON_BOUNDARIES
*for(i=1;i<=GenData(PLCd_Number_of_Stages:,int);i=i+1)
  STAGE *i
*set var iboun=0
*if(ndime==2)
*set Cond PLCD_Boundary_2D *elems
*else
*set Cond PLCD_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var N=cond(Stage_of_application,int)
*if(N==i || N==0)
*set var iboun=iboun+1
*set var nface = ElemsNnodeFace
*set var tf=cond(Time_function,int)
*set var x =globalnodes(1)
*set var y =globalnodes(2)
*set var z =globalnodes(3)
*set var w =globalnodes(4)
*if(strcmp(cond(1),"Displacement")==0)
*if(nface == 2)
*iboun *nface *x *y    1 *cond(Value_displacement_x) *cond(Value_displacement_y) *cond(Value_displacement_z) *tf 
*elseif(nface== 3)
*iboun *nface *x *y *z    1 *cond(Value_displacement_x) *cond(Value_displacement_y) *cond(Value_displacement_z) *tf 
*elseif(nface== 4)
*iboun *nface *x *y *z *w     1 *cond(Value_displacement_x) *cond(Value_displacement_y) *cond(Value_displacement_z) *tf 
*endif
*elseif(strcmp(cond(1),"Traction")==0)
*if(nface == 2)
*iboun *nface *x *y    2 *cond(Value_Traction_x) *cond(Value_Traction_y) *cond(Value_Traction_z) 
*elseif(nface== 3)
*iboun *nface *x *y *z    2 *cond(Value_Traction_x) *cond(Value_Traction_y) *cond(Value_Traction_z)  
*elseif(nface== 4)
*iboun *nface *x *y *z *w    2 *cond(Value_Traction_x) *cond(Value_Traction_y) *cond(Value_Traction_z) 
*endif
*endif
*endif
*end elems
*if(ndime==2)
*set Cond PLCD_FSI_Boundary_2D *elems
*else
*set Cond PLCD_FSI_Boundary_3D *elems
*endif
*loop elems *onlyincond 
*set var iboun=iboun+1
*set var nface = ElemsNnodeFace
*set var x =globalnodes(1)
*set var y =globalnodes(2)
*set var z =globalnodes(3)
*set var w =globalnodes(4)
*if(nface == 2)
*iboun *nface *x *y    3 
*elseif(nface== 3)
*iboun *nface *x *y *z    3
*elseif(nface== 4)
*iboun *nface *x *y *z *w    3
*endif
*end elems
END_STAGE
*endfor

END_ON_BOUNDARIES

*Set Cond PLCD_SOURCE_point   *nodes
*Add Cond PLCD_SOURCE_line    *nodes

SOURCE
*for(i=1;i<=GenData(PLCd_Number_of_Stages:,int);i=i+1)
  STAGE *i
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond *canrepeat
*set var N=cond(Stage_of_application,int)
*if(N==i || N==0)
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(BoundaryFunction,int)
*format "%i %i%i% %i %i"
*NodesNum *tcl(FemussEvalDirichletCondition *cond(Value_Force_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_y)  *x   *y   *z)  *ft
*endif
*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond *canrepeat
*set var N=cond(Stage_of_application,int)
*if(N==i || N==0)
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(BoundaryFunction,int)
*format "%i %i%i%i %i %i %i"
*NodesNum  *tcl(FemussEvalDirichletCondition *cond(Value_Force_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_z)  *x   *y   *z) *ft
*endif
*end
*endif
  END_STAGE
*endfor
END_SOURCE

*\
*\ On elements
*\
ON_ELEMENTS
*\*loop elems
*\*elemsnum *ElemsMat
*\*end elems
END_ON_ELEMENTS
*endif
