*if(strcasecmp(GenData(PLCd_problem),"Off")!=0)
#####################################################
*#PLCD MODULE PREFIXES: plcd PLCD *This must be on line 3
#####################################################
*if(nmats==0) 
*MessageBox error: No material defined 
*endif
NUMBER OF MATERIALS: *nmats
MATERIALS_PROPERTIES
*loop materials
  BEGIN_MATERIAL
    IDNUMBER:   *MatNum
    MAT_NAME:   *matprop(0)
*if(strcasecmp(matprop(Type_of_Material),"Simple")==0)
*if(strcasecmp(matprop(Law_Type),"Linear_Elastic")==0)  
      TYPELAW:    Lin_Elastic
*elseif(strcasecmp(matprop(Law_Type),"HyperElasticity")==0)
*if(strcasecmp(matprop(Type_of_HyperElastic_Strain_Energy),"Coupled")==0)
*if(strcasecmp(matprop(HyperElastic_Law_Type),"Saint-Venant_Kirchhoff")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Coupled   SVKirchhoff
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Coupled   ToSVKirchhoff
*endif
*elseif(strcasecmp(matprop(HyperElastic_Law_Type),"NeoHookean")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Coupled     NeoHookean
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Coupled     ToNeoHookean
*endif
*elseif(strcasecmp(matprop(HyperElastic_Law_Type),"Mooney-Rivlin")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Coupled     Mooney-Rivlin
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Coupled     ToMooney_Rivlin
*endif
*endif
*elseif(strcasecmp(matprop(Type_of_HyperElastic_Strain_Energy),"Volumetric_Deviatoric_Decomposition")==0)
*if(strcasecmp(matprop(HyperElastic_Deviatoric_Law_Type),"NeoHookean")==0)
      TYPELAW:    HyperElasticity   Decoupled     NeoHookean    
*elseif(strcasecmp(matprop(HyperElastic_Deviatoric_Law_Type),"Mooney-Rivlin")==0)
      TYPELAW:    HyperElasticity   Decoupled     Mooney-Rivlin
      PARAMETERS: *matprop(Mooney_rivlin_alpha=)  *matprop(Mooney_rivlin_beta=)
*endif   
      VOLUMETRIC_LAW:   *matprop(HyperElastic_Volumetric_Law_Type)  
*if(strcasecmp(matprop(HyperElastic_Volumetric_Law_Type),"Ogden")==0)
      BETA_OGDEN:       *matprop(Ogden_beta_parameter)
*endif     
*endif
*else
      TYPELAW:    *matprop(Law_Type)
*endif
*if(strcasecmp(matprop(Law_Type),"Plasticity")==0)  
*tcl(FemussWriteTempeDependentProperty UNIAXIAL_STRESS "Law_Uniaxial_Stress" "Uniaxial_Stress=" "Uniaxial_Stress_Data" "    " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty K_HARDENING "Law_Isotropic_Hardening" "K_Hardening=" "K_Hardening_Data" "    " *matprop(0) )
       H_HARDENING:     *matprop(H_Hardening=)
       Exponential_Hardening:     *matprop(Exponential_Hardening=)
*tcl(FemussWriteTempeDependentProperty D_PARAMETER "Law_D_Parameter" "D_Parameter=" "D_Parameter_Data" "    " *matprop(0) ) 
*tcl(FemussWriteTempeDependentProperty SIGMA_INFINITY "Law_Sigma_Infinity" "Sigma_Infinity=" "Sigma_Infinity_Data" "    " *matprop(0) ) 
*tcl(FemussWriteTempeDependentProperty VISCOSITY "Law_Rate_Dependent_Viscosity" "Rate_Dependent_Viscosity=" "Rate_Dependent_Viscosity_Data" "    " *matprop(0) )
*if(strcasecmp(matprop(Annealing:),"On")==0)    
    ANNEALING TEMPERATURE:    *matprop(Annealing_Temperature=)
    ANNEALING EXPONENTIAL_POWER:    *matprop(Annealing_Exponential_Power=)
    ANNEALING INTERVAL:    *matprop(Annealing_Interval=)
*endif 
*endif
*if(strcasecmp(matprop(Law_Type),"Damage")==0)  
      UNIAXIAL_STRESS: *matprop(Uniaxial_Stress=)
      FRACTURE_ENERGY: *matprop(Fracture_Energy)
      MAX_DAMAGE:      *matprop(Max_Damage=)
      COMPARISON_CRIT: *matprop(ComparisonCriteria)
      TYPE_OF_DAMAGE:  *matprop(Type_Of_Damage)
*endif
*if(strcasecmp(matprop(Mat._Ref._System),"Local")==0)
*if(strcasecmp(matprop(Bidimensional_type),"Does_Not_Apply")==0)
    REF_SYSTEM: Local *matprop(Rot._Z=) *matprop(Rot._X_3D=) *matprop(Rot._Z_3D=)
*else
    REF_SYSTEM: Local *matprop(Rot._Z=)
*endif
*endif
*tcl(FemussWriteTempeDependentProperty DENSITY "Law_Density:" "Density=" "Density_Data" "    " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty THERMAL_EXPANSION_COEFFICIENT "Law_ThermalExpansionCoefficient" "ThermalExpansionCoefficient" "Data_ThermalExpansionCoefficient" "    " *matprop(0) )
    RAYLEIGH_DAMPING: KCOEFF *matprop(Rayleigh_Damping_K_Coeff) MCOEFF *matprop(Rayleigh_Damping_M_Coeff)
    CONST_TEN:  *matprop(Constitutive_Tensor) *matprop(Bidimensional_type)
*if(strcasecmp(matprop(Constitutive_Tensor),"Isotropic")==0)
*tcl(FemussWriteTempeDependentProperty YOUNG "Law_Young's_Modulus" "Young's_Modulus=" "Young's_Modulus_Data" "    " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty POISSON "Law_Poisson's_Ratio" "Poisson's_Ratio=" "Poisson's_Ratio_Data" "    " *matprop(0) )
*elseif(strcasecmp(matprop(Constitutive_Tensor),"Transversely_Isotropic")==0)
      YOUNG TRANSVERSE:   *matprop(Young's_Modulus_"transverse"=)
      YOUNG INPLANE:      *matprop(Young's_Modulus_"in-plane"=)
      SHEAR TRANSVERSE:   *matprop(Shear_Modulus_"transverse"=)
      SHEAR INPLANE:      *matprop(Shear_Modulus_"in-plane"=)	
      POISSON TRANSINPLA: *matprop(Poisson's_Ratio_"transverse_in-plane"=)
*elseif(strcasecmp(matprop(Constitutive_Tensor),"Orthotropic")==0)
      YOUNG DIR11:   *matprop(Young's_Modulus_1=)
      YOUNG DIR22:   *matprop(Young's_Modulus_2=)
      YOUNG DIR33:   *matprop(Young's_Modulus_3=)
      SHEAR DIR12:   *matprop(Shear_Modulus_12=)
      SHEAR DIR13:   *matprop(Shear_Modulus_13=)
      SHEAR DIR23:   *matprop(Shear_Modulus_23=)
      POISSON DIR12: *matprop(Poisson's_Ratio_12=)
      POISSON DIR13: *matprop(Poisson's_Ratio_13=)
      POISSON DIR23: *matprop(Poisson's_Ratio_23=)
*endif
    TANG_TYPE:  *matprop(Tangent_Type)
*if(strcasecmp(matprop(Material_Initial_Tenperature),"On")==0)
    INITIAL TEMPERATURE:    *matprop(Initial_Temperature)
    REFERENCE TEMPERATURE:    *matprop(Reference_Temperature)
*endif
*elseif(strcasecmp(matprop(Type_of_Material),"Composite")==0)
    TYPELAW:    COMPOSITE
    CONST_TEN:  Isotropic Does_Not_Apply
      YOUNG:    240e9
      POISSON:  0.21
*set var N=matprop(Materials_Data_,int)
    NUMBER OF MATERIALS: *operation(N/2)
*if(N==2)
    VOLUME_FRACTIONS: *matprop(Materials_Data_,2)
*elseif(N==4)
    VOLUME_FRACTIONS: *matprop(Materials_Data_,2) *matprop(Materials_Data_,4)
*elseif(N==6)
    VOLUME_FRACTIONS: *matprop(Materials_Data_,2) *matprop(Materials_Data_,4) *matprop(Materials_Data_,6)
*elseif(N==8)
    VOLUME_FRACTIONS: *matprop(Materials_Data_,2) *matprop(Materials_Data_,4) *matprop(Materials_Data_,6) *matprop(Materials_Data_,8)
*else
!!! warning ProblemType does not prepare to work with more than 4 simple materials in the composite !!!
*endif
    MATERIALS_PROPERTIES
*for(i=1;i<=N;i=i+2)
      BEGIN_MATERIAL
        IDNUMBER:   *operation((i+1)/2)
*set var RID=matprop(Materials_Data_,*i,int)
*loop materials *NotUsed
*if(matprop(MatNum,int)==RID)
        MAT_NAME:   *matprop(0)
*if(strcasecmp(matprop(Law_Type),"Linear_Elastic")==0)  
      TYPELAW:    Lin_Elastic
*elseif(strcasecmp(matprop(Law_Type),"HyperElasticity")==0)
*if(strcasecmp(matprop(Type_of_HyperElastic_Strain_Energy),"Coupled")==0)
*if(strcasecmp(matprop(HyperElastic_Law_Type),"Saint-Venant_Kirchhoff")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Compressible   SVKirchhoff
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Compressible   ToSVKirchhoff
*endif
*elseif(strcasecmp(matprop(HyperElastic_Law_Type),"NeoHookean")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Compressible     NeoHookean
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Compressible     ToNeoHookean
*endif
*elseif(strcasecmp(matprop(HyperElastic_Law_Type),"Mooney-Rivlin")==0)
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
      TYPELAW:    HyperElasticity   Compressible     Mooney-Rivlin
*elseif(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0) 
      TYPELAW:    HyperElasticity   Compressible     ToMooney_Rivlin
*endif
*endif
*elseif(strcasecmp(matprop(Type_of_HyperElastic_Strain_Energy),"Volumetric_Deviatoric_Decomposition")==0)
*if(strcasecmp(matprop(HyperElastic_Deviatoric_Law_Type),"NeoHookean")==0)
      TYPELAW:    HyperElasticity   InCompressible     InNeoHookean    
*elseif(strcasecmp(matprop(HyperElastic_Deviatoric_Law_Type),"Mooney-Rivlin")==0)
      TYPELAW:    HyperElasticity   InCompressible     InMooney-Rivlin
*endif   
      VOLUMETRIC_LAW:   *matprop(HyperElastic_Volumetric_Law_Type)  
*if(strcasecmp(matprop(HyperElastic_Volumetric_Law_Type),"Ogden")==0)
      BETA_OGDEN:       *matprop(Ogden_beta_parameter)
*endif     
*endif
*else
      TYPELAW:    *matprop(Law_Type)
*endif
*if(strcasecmp(matprop(Law_Type),"Plasticity")==0)  
          K_HARDENING:     *matprop(K_Hardening=)
          H_HARDENING:     *matprop(H_Hardening=)
          Exponential_Hardening:     *matprop(Exponential_Hardening=) Sigma_Infinity:     *matprop(Sigma_Infinity=) D_Parameter:     *matprop(D_Parameter=)
          Viscosity:     *matprop(Rate_Dependent_Viscosity=)
*tcl(FemussWriteTempeDependentProperty UNIAXIAL_STRESS "Law_Uniaxial_Stress" "Uniaxial_Stress=" "Uniaxial_Stress_Data" "    " *matprop(0) )
*endif
*if(strcasecmp(matprop(Law_Type),"Damage")==0)  
          UNIAXIAL_STRESS: *matprop(Uniaxial_Stress=)
          FRACTURE_ENERGY: *matprop(Fracture_Energy)
          MAX_DAMAGE:      *matprop(Max_Damage=)
          COMPARISON_CRIT: *matprop(ComparisonCriteria)
          TYPE_OF_DAMAGE:  *matprop(Type_Of_Damage)
*endif
        DENSITY:    *matprop(Density=)
        THERMAL_EXPANSION_COEFFICIENT:    *matprop(Thermal_Expansion_Coefficient=)
        RAYLEIGH_DAMPING: KCOEFF *matprop(Rayleigh_Damping_K_Coeff) MCOEFF *matprop(Rayleigh_Damping_M_Coeff)
        CONST_TEN:  *matprop(Constitutive_Tensor) *matprop(Bidimensional_type)
*if(strcasecmp(matprop(Constitutive_Tensor),"Isotropic")==0)
          YOUNG:    *matprop(Young's_Modulus=)
          POISSON:  *matprop(Poisson's_Ratio=)
*elseif(strcasecmp(matprop(Constitutive_Tensor),"Transversely_Isotropic")==0)
          YOUNG TRANSVERSE:   *matprop(Young's_Modulus_"transverse"=)
          YOUNG INPLANE:      *matprop(Young's_Modulus_"in-plane"=)
          SHEAR TRANSVERSE:   *matprop(Shear_Modulus_"transverse"=)
          SHEAR INPLANE:      *matprop(Shear_Modulus_"in-plane"=)	
          POISSON TRANSINPLA: *matprop(Poisson's_Ratio_"transverse_in-plane"=)
*elseif(strcasecmp(matprop(Constitutive_Tensor),"Orthotropic")==0)
          YOUNG DIR11:   *matprop(Young's_Modulus_1=)
          YOUNG DIR22:   *matprop(Young's_Modulus_2=)
          YOUNG DIR33:   *matprop(Young's_Modulus_3=)
          SHEAR DIR12:   *matprop(Shear_Modulus_12=)
          SHEAR DIR13:   *matprop(Shear_Modulus_13=)
          SHEAR DIR23:   *matprop(Shear_Modulus_23=)
          POISSON DIR12: *matprop(Poisson's_Ratio_12=)
          POISSON DIR13: *matprop(Poisson's_Ratio_13=)
          POISSON DIR23: *matprop(Poisson's_Ratio_23=)
*endif
        TANG_TYPE:  *matprop(Tangent_Type)
*endif
*end materials
      END_MATERIAL
*end for
    END_MATERIALS_PROPERTIES
*elseif(strcasecmp(matprop(Type_of_Material),"Composite_SP")==0)
*endif
  END_MATERIAL
*end materials
END_MATERIALS_PROPERTIES
*endif
