*if(strcasecmp(GenData(PLCd_problem),"Off")!=0)
#####################################################
*#PLCD MODULE PREFIXES: plcd PLCD *This must be on line 3
#####################################################

*if(strcasecmp(GenData(PLCd_Algebraic_solver),"Direct")==0)
*if(strcasecmp(GenData(PLCd_Direct_solver),"MUMPS")==0)
-plcd_mat_type mpiaij
-plcd_ksp_type preonly
-plcd_pc_type lu
-plcd_pc_factor_mat_solver_type mumps
-plcd_ksp_diagonal_scale

#-plcd_ksp_type bcgs 
#-plcd_ksp_pc_side right 
#-plcd_ksp_rtol 1e-8 
#-plcd_ksp_max_it 200
#-plcd_pc_type asm 
#-plcd_ksp_diagonal_scale
#-plcd_pc_asm_overlap 3 
#-plcd_sub_pc_type ilu 
#-plcd_sub_pc_factor_mat_ordering rcm 
#-plcd_sub_pc_factor_levels 10 
#-plcd_mat_type mpibaij  

#-plcd_mat_type mpiaij  
#-plcd_ksp_type bcgs
#-plcd_ksp_rtol 1e-8 
#-plcd_pc_type ml
#-plcd_pc_mg_cycles 2
#-plcd_pc_mg_smoothup 5 
#-plcd_pc_mg_smoothdown 1
#-plcd_pc_mg_type multiplicative
#-plcd_ksp_diagonal_scale
*endif
*elseif(strcasecmp(GenData(PLCd_Algebraic_solver),"Iterative")==0)
*if(strcasecmp(GenData(PLCd_Iterative_solver),"BICGS")==0)

#-plcd_mat_type mpiaij
#-plcd_ksp_type preonly
#-plcd_pc_type lu
#-plcd_pc_factor_mat_solver_type mumps
#-plcd_ksp_diagonal_scale

-plcd_ksp_type bcgs 
#-plcd_ksp_pc_side right 
-plcd_ksp_rtol *GenData(PLCd_Solver_tolerance)
-plcd_ksp_max_it *GenData(PLCd_Solver_Max_iterations)
#-plcd_pc_type asm 
-plcd_ksp_diagonal_scale
#-plcd_pc_asm_overlap 3 
#-plcd_sub_pc_type ilu 
#-plcd_sub_pc_factor_mat_ordering rcm 
#-plcd_sub_pc_factor_levels 10 
#-plcd_mat_type mpibaij

#-plcd_mat_type mpiaij  
#-plcd_ksp_type bcgs
#-plcd_ksp_rtol 1e-8 
#-plcd_pc_type ml
#-plcd_pc_mg_cycles 2
#-plcd_pc_mg_smoothup 5 
#-plcd_pc_mg_smoothdown 1
#-plcd_pc_mg_type multiplicative
#-plcd_ksp_diagonal_scale  
*endif

*endif

##################################################
# FOR BUCKLING AND DYNAMIC ANALYSIS
-plcd_eps_nev 5
-plcd_eps_ncv 25
-plcd_eps_max_it 1000
-plcd_eps_tol 1e-3
#-plcd_eps_gen_hermitian
#-plcd_eps_type rqcg
-plcd_eps_target_magnitude
-plcd_eps_target 1
-plcd_st_type cayley
-plcd_st_caley_antishift 0
##################################################
*endif
