*if(strcasecmp(GenData(HELMHZ_problem),"Off")!=0)
*#####################################################
*#HELMHZ MODULE PREFIX: hmz HELMHZ *This must be on line 3
*#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\
FUNCTIONS
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond HELMHOLTZ_surface *nodes
*Add Cond HELMHOLTZ_line    *nodes
*Add Cond HELMHOLTZ_point   *nodes

ON_NODES
*loop nodes *OnlyInCond
*if(strcmp(cond(Type),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type),"Fixed")==0)
*set var fx=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i%i%i%i"
*if(strcmp(cond(Equation_form),"Scalar")==0)
*NodesNum *fx *tcl(FemussEvalDirichletCondition *cond(Value_pressure)  *x   *y   *z)
*endif
*if(strcmp(cond(Equation_form),"Mixed")==0)
*NodesNum *fx *tcl(FemussEvalDirichletCondition *cond(Value_velocity_x)  *x   *y   *z)*tcl(FemussEvalDirichletCondition *cond(Value_velocity_y)  *x   *y   *z)*tcl(FemussEvalDirichletCondition *cond(Value_velocity_z)  *x   *y   *z)
*endif
*end 
END_ON_NODES

*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond HELMHOLTZ_Boundary_2D *elems
*else
*set Cond HELMHOLTZ_Boundary_2D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*if(strcmp(cond(1),"Sommerfeld_for_Scalar_form")==0)
*if(strcmp(cond(2),"Off")==0)
*iboun *ElemsNnodeFace *globalnodes 3  
*endif
*endif
*if(strcmp(cond(1),"Sommerfeld_for_Scalar_form")==0)
*if(strcmp(cond(2),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 4 *cond(3) 
*endif
*endif
*if(strcmp(cond(1),"Sommerfeld_for_Mixed_form")==0)
*if(strcmp(cond(2),"Off")==0)
*iboun *ElemsNnodeFace *globalnodes 5  
*endif
*endif
*if(strcmp(cond(1),"Sommerfeld_for_Mixed_form")==0)
*if(strcmp(cond(2),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 6 *cond(3) 
*endif
*endif
*end elems
END_ON_BOUNDARIES

*Set Cond HELMHOLTZ_SOURCE_point   *nodes
SOURCE
*loop nodes *OnlyInCond *canrepeat
*if(strcmp(cond(1),"Scalar")==0)
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i%i% %i %i"
*NodesNum *tcl(FemussEvalDirichletCondition *cond(Source)  *x   *y   *z)
*elseif(strcmp(cond(1),"Mixed")==0)
*if(strcmp(cond(2),"Pressure")==0)
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var fx =1
*format "%i%i% %i %i"
*NodesNum *fx *tcl(FemussEvalDirichletCondition *cond(3)  *x   *y   *z)
*elseif(strcmp(cond(2),"Velocity")==0)
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var fx =2
*format "%i%i% %i %i"
*NodesNum *fx *tcl(FemussEvalDirichletCondition *cond(3) *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z)
*endif
*endif
*end
END_SOURCE

*\
*\ On elements
*\
ON_ELEMENTS
*\*loop elems
*\*elemsnum *ElemsMat
*\*end elems
END_ON_ELEMENTS
*endif
