*if(strcasecmp(GenData(BEAM_problem),"Off")!=0)
#####################################################
*#BEAM MODULE PREFIXES: beam BEAM *This must be on line 3
#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\ ====================================
*\ ============== 3D CASE =============
*\ ====================================
*if(ndime==3)
*\
*\ FUNCTIONS
*\ 
FUNCTIONS
END_FUNCTIONS

ON_NODES
*\
*\ DISPLACEMENT
*\ 
   DISPLACEMENT
*Set Cond BEAM_Point_Displacements    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Displacement_x),"Free_or_initial")==0)
*set var dx=0
*elseif(strcmp(cond(Type_Displacement_x),"Fixed")==0)
*set var dx=1
*endif
*if(strcmp(cond(Type_Displacement_y),"Free_or_initial")==0)
*set var dy=0
*elseif(strcmp(cond(Type_Displacement_y),"Fixed")==0)
*set var dy=1
*endif
*if(strcmp(cond(Type_Displacement_z),"Free_or_initial")==0)
*set var dz=0
*elseif(strcmp(cond(Type_Displacement_z),"Fixed")==0)
*set var dz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *dx*dy*dz *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_z)  *x   *y   *z)  
*end 
   END_DISPLACEMENT
*\
*\ ROTATIONS
*\ 
   ROTATION
*Set Cond BEAM_Point_Rotations    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Rotation_x),"Free_or_initial")==0)
*set var rx=0
*elseif(strcmp(cond(Type_Rotation_x),"Fixed")==0)
*set var rx=1
*endif
*if(strcmp(cond(Type_Rotation_y),"Free_or_initial")==0)
*set var ry=0
*elseif(strcmp(cond(Type_Rotation_y),"Fixed")==0)
*set var ry=1
*endif
*if(strcmp(cond(Type_Rotation_z),"Free_or_initial")==0)
*set var rz=0
*elseif(strcmp(cond(Type_Rotation_z),"Fixed")==0)
*set var rz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *rx*ry*rz *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_z)  *x   *y   *z)  
*end 
   END_ROTATION
END_ON_NODES
ON_BOUNDARIES
END_ON_BOUNDARIES
SOURCE
*\
*\ FORCES
*\ 
   FORCES
*Set Cond BEAM_Point_Forces   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Force_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_Force_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_Force_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_Force_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_Force_z),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(Type_Force_z),"Fixed")==0)
*set var fz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(Value_Force_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_z)  *x   *y   *z)
*end
   END_FORCES
*\
*\ MOMENT
*\
   MOMENT
*Set Cond BEAM_Point_Moment   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Moment_x),"Free_or_initial")==0)
*set var mx=0
*elseif(strcmp(cond(Type_Moment_x),"Fixed")==0)
*set var mx=1
*endif
*if(strcmp(cond(Type_Moment_y),"Free_or_initial")==0)
*set var my=0
*elseif(strcmp(cond(Type_Moment_y),"Fixed")==0)
*set var my=1
*endif
*if(strcmp(cond(Type_Moment_z),"Free_or_initial")==0)
*set var mz=0
*elseif(strcmp(cond(Type_Moment_z),"Fixed")==0)
*set var mz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum *mx*my*mz *tcl(FemussEvalDirichletCondition *cond(Value_Moment_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Moment_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Moment_z)  *x   *y   *z)
*end
   END_MOMENT
END_SOURCE
ON_ELEMENTS (F/M ElmNumber Rect/Trian Direction ValuesXYZ)
*\
*\ DISTRIBUTED_FORCES
*\ 
*\   DISTRIBUTED_FORCES
*Set Cond BEAM_Line_Forces   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*\set var x = (NodesCoord(1,1) + NodesCoord(2,1))/2
*\set var y = (NodesCoord(1,2) + NodesCoord(2,2))/2
*\set var z = (NodesCoord(1,3) + NodesCoord(2,3))/2
*format "%i %i %i %i %i %i %i %i %i %i"
1 *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_z) *x1 *y1 *z1) *elemsConec(2)  *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_z) *x2 *y2 *z2)
*end
*\   END_DISTRIBUTED_FORCES
*\
*\ DISTRIBUTED_MOMENT
*\
*\   DISTRIBUTED_MOMENT
*Set Cond BEAM_Line_Moment   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*format "%i %i %i %i %i %i %i"
2 *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_x) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_y) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_z) *x1 *y1 *z1) *elemsConec(2)  *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_x) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_y) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_z) *x2 *y2 *z2)
*end
*\   END_DISTRIBUTED_MOMENT
END_ON_ELEMENTS
*endif
*\ ====================================
*\ ============== 2D CASE =============
*\ ====================================
*if(ndime==2)
*\
*\ FUNCTIONS
*\ 
FUNCTIONS
END_FUNCTIONS

ON_NODES
*\
*\ DISPLACEMENT
*\ 
   DISPLACEMENT
*Set Cond BEAM_Point_Displacements    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Displacement_x),"Free_or_initial")==0)
*set var dx=0
*elseif(strcmp(cond(Type_Displacement_x),"Fixed")==0)
*set var dx=1
*endif
*if(strcmp(cond(Type_Displacement_y),"Free_or_initial")==0)
*set var dy=0
*elseif(strcmp(cond(Type_Displacement_y),"Fixed")==0)
*set var dy=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i %i %i"
*NodesNum  *dx*dy *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_y)  *x   *y   *z) 
*end 
   END_DISPLACEMENT
*\
*\ ROTATIONS
*\ 
   ROTATION
*Set Cond BEAM_Point_Rotations    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Rotation_z),"Free_or_initial")==0)
*set var rz=0
*elseif(strcmp(cond(Type_Rotation_z),"Fixed")==0)
*set var rz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i %i"
*NodesNum  *rz *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_z)  *x   *y   *z)  
*end 
   END_ROTATION
END_ON_NODES
ON_BOUNDARIES
END_ON_BOUNDARIES
SOURCE
*\
*\ FORCES
*\ 
   FORCES
*Set Cond BEAM_Point_Forces   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Force_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_Force_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_Force_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_Force_y),"Fixed")==0)
*set var fy=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i %i %i"
*NodesNum *fx*fy *tcl(FemussEvalDirichletCondition *cond(Value_Force_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_y)  *x   *y   *z)
*end
   END_FORCES
*\
*\ MOMENT
*\
   MOMENT
*Set Cond BEAM_Point_Moment   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Moment_z),"Free_or_initial")==0)
*set var mz=0
*elseif(strcmp(cond(Type_Moment_z),"Fixed")==0)
*set var mz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i %i"
*NodesNum *mz *tcl(FemussEvalDirichletCondition *cond(Value_Moment_z)  *x   *y   *z)
*end
   END_MOMENT
END_SOURCE
ON_ELEMENTS (F/M ElmNumber Rect/Trian Direction ValuesXYZ)
*\
*\ DISTRIBUTED_FORCES
*\ 
*\   DISTRIBUTED_FORCES
*Set Cond BEAM_Line_Forces   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*\set var x = (NodesCoord(1,1) + NodesCoord(2,1))/2
*\set var y = (NodesCoord(1,2) + NodesCoord(2,2))/2
*\set var z = (NodesCoord(1,3) + NodesCoord(2,3))/2
*format "%i %i %i %i %i %i %i %i %i %i"
1 *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x1 *y1 *z1) *elemsConec(2)  *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x2 *y2 *z2)
*end
*\   END_DISTRIBUTED_FORCES
*\
*\ DISTRIBUTED_MOMENT
*\
*\   DISTRIBUTED_MOMENT
*Set Cond BEAM_Line_Moment   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*format "%i %i %i %i %i %i %i"
2 *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Moment_z) *x1 *y1 *z1) *elemsConec(2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_z) *x2 *y2 *z2)
*end
*\   END_DISTRIBUTED_MOMENT
END_ON_ELEMENTS
*endif

*endif
