*if(strcasecmp(GenData(BEAM_problem),"Off")!=0)
#####################################################
*#BEAM MODULE PREFIXES: beam BEAM *This must be on line 3
#####################################################
*if(nmats==0) 
*MessageBox error: No material defined 
*endif
NUMBER OF MATERIALS: *nmats
MATERIALS_PROPERTIES
*loop materials
  BEGIN_MATERIAL
    IDNUMBER:   *MatNum
    MAT_NAME:   *matprop(0)
*if(strcasecmp(matprop(Beam_Type_of_Material),"Simple")==0)
*if(strcasecmp(matprop(BeamS_Law_Type),"Linear_Elastic")==0)  
    TYPELAW:    Lin_Elastic
*elseif(strcasecmp(matprop(BeamS_Law_Type),"HyperElasticity")==0)
*else
    TYPELAW:    *matprop(BeamS_Law_Type)
*endif
*if(strcasecmp(matprop(BeamS_Law_Type),"Plasticity")==0)  
*endif
    CONST_TEN:  *matprop(BeamS_Constitutive_Tensor)
*if(strcasecmp(matprop(BeamS_Constitutive_Tensor),"Isotropic")==0)
*tcl(FemussWriteTempeDependentProperty YOUNG "BeamS_Law_Young's_Modulus" "BeamS_Young's_Modulus=" "BeamS_Young's_Modulus_Data" "    " *matprop(0) )
*tcl(FemussWriteTempeDependentProperty POISSON "BeamS_Law_Poisson's_Ratio" "BeamS_Poisson's_Ratio=" "BeamS_Poisson's_Ratio_Data" "    " *matprop(0) )
*elseif(strcasecmp(matprop(BeamS_Constitutive_Tensor),"Transversely_Isotropic")==0)
*elseif(strcasecmp(matprop(BeamS_Constitutive_Tensor),"Orthotropic")==0)
*endif
    *matprop(BEAMS_Cross_Section)
*if(strcasecmp(matprop(BEAMS_Cross_Section),"Rectangle")==0)
    WIDTH              *matprop(BEAMS_Rectangle_Width)
    HEIGHT             *matprop(BEAMS_Rectangle_Height)
    SHEAR_CORRECTION   *matprop(BEAMS_Rectangle_Shear_Correction)
*elseif(strcasecmp(matprop(BEAMS_Cross_Section),"Circle")==0)
    DIAMETER           *matprop(BEAMS_Circle_Diameter)
    SHEAR_CORRECTION   *matprop(BEAMS_Circle_Shear_Correction)
*elseif(strcasecmp(matprop(BEAMS_Cross_Section),"IBeam")==0)
    FLANGE_WIDTH       *matprop(BEAMS_I_Flange_Width)
    I_HEIGHT           *matprop(BEAMS_I_Height)
    WEB_THICKNESS      *matprop(BEAMS_I_Web_Thickness)
    FLA_THICKNESS      *matprop(BEAMS_I_Flange_Thickness)
    SHEAR_CORRECTION   *matprop(BEAMS_I_Shear_Correction)
*endif
*elseif(strcasecmp(matprop(Beam_Type_of_Material),"Composite")==0)
    MATERIALS_PROPERTIES
*for(i=1;i<=N;i=i+2)
      BEGIN_MATERIAL
        IDNUMBER:   *operation((i+1)/2)
*set var RID=matprop(Materials_Data_,*i,int)
*loop materials *NotUsed
*if(matprop(MatNum,int)==RID)
        MAT_NAME:   *matprop(0)
*if(strcasecmp(matprop(BeamC_Law_Type),"Linear_Elastic")==0)  
      TYPELAW:    Lin_Elastic
*elseif(strcasecmp(matprop(BeamC_Law_Type),"HyperElasticity")==0)
*else
      TYPELAW:    *matprop(BeamC_Law_Type)
*endif
*if(strcasecmp(matprop(BeamC_Law_Type),"Plasticity")==0)  
*endif
*if(strcasecmp(matprop(BeamC_Law_Type),"Damage")==0)  
*endif
   CONST_TEN:  *matprop(BeamC_Constitutive_Tensor)
*if(strcasecmp(matprop(BeamC_Constitutive_Tensor),"Isotropic")==0)
          YOUNG:    *matprop(BeamC_Young's_Modulus=)
          POISSON:  *matprop(BeamC_Poisson's_Ratio=)
*elseif(strcasecmp(matprop(BeamC_Constitutive_Tensor),"Transversely_Isotropic")==0)
*elseif(strcasecmp(matprop(BeamC_Constitutive_Tensor),"Orthotropic")==0)
*endif
        THICKNESS:  *matprop(BeamC_Thickness)
*endif
*end materials
      END_MATERIAL
*end for
    END_MATERIALS_PROPERTIES
*elseif(strcasecmp(matprop(Beam_Type_of_Material),"Composite_SP")==0)
*endif
  END_MATERIAL
*end materials
END_MATERIALS_PROPERTIES
*endif
