*if(strcasecmp(GenData(NSTPRI_problem),"On")==0)
*#####################################################
*#NSTPRI MODULE PREFIXES: nsp NSTPRI *This must be on line 3
*#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\
FUNCTIONS
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond Primitive_variables_volume  *nodes
*Add Cond Primitive_variables_surface *nodes
*Add Cond Primitive_variables_line    *nodes
*Add Cond Primitive_variables_point   *nodes
ON_NODES
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var pr=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var pr=1
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(11,int)
*format "%i %1i%1i%1i%1i %i %i %i %i %i"
  *NodesNum  *pr*fx*fy*te *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(7)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(8)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *ft
*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var pr=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var pr=1
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(4),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(4),"Fixed")==0)
*set var fz=1
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(11,int)
*format "%i %1i%1i%1i%1i%1i %i %i %i %i %i %i"
  *NodesNum  *pr*fx*fy*fz*te *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(7)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(8)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(9)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *ft
*end
*endif
END_ON_NODES
*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond NSTPRI_Boundary_2D *elems
*else
*set Cond NSTPRI_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*if(strcmp(cond(1),"On")==0)
*if(strcmp(cond(2),"Free")==0)
*set var fweakx=0
*elseif(strcmp(cond(2),"Weak")==0)
*set var fweakx=1
*endif
*if(strcmp(cond(3),"Free")==0)
*set var fweaky=0
*elseif(strcmp(cond(3),"Weak")==0)
*set var fweaky=1
*endif
*if(strcmp(cond(7),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 15 *fweakx *fweaky *cond(4) *cond(5) *cond(6)
*else
*endif
*elseif(strcmp(cond(7),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 16
*endif
*end elems
END_ON_BOUNDARIES
*endif
