*if(strcasecmp(GenData(NSTPRI_problem),"Off")!=0)
#####################################################
*#NSTPRI MODULE PREFIXES: nsp *This must be on line 3
#####################################################

*if(strcasecmp(GenData(NSTPRI_Algorithm),"Monolithic")==0)
*if(strcasecmp(GenData(NSTPRI_Algebraic_solver),"Direct")==0)
*if(strcasecmp(GenData(NSTPRI_Direct_solver),"MUMPS")==0)
-nsp_mat_type mpiaij
-nsp_ksp_type preonly
-nsp_pc_type lu
-nsp_pc_factor_mat_solver_type mumps
-nsp_ksp_diagonal_scale
*endif
*elseif(strcasecmp(GenData(NSTPRI_Algebraic_solver),"Iterative")==0)
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"HYPRE")==0)
-nsp_mat_type mpiaij  
-nsp_ksp_type bcgs
-nsp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nsp_pc_type hypre
-nsp_ksp_diagonal_scale
*endif
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"TRILINOS")==0)
-nsp_mat_type mpiaij  
-nsp_ksp_type bcgs
-nsp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nsp_pc_type ml
-nsp_pc_mg_cycles 2
-nsp_pc_mg_smoothup 5 
-nsp_pc_mg_smoothdown 1
-nsp_pc_mg_type multiplicative
*endif
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"BICGS")==0)
-nsp_ksp_type bcgs 
-nsp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nsp_ksp_max_it *GenData(NSTPRI_Solver_Max_iterations)
-nsp_pc_type asm 
-nsp_mat_type mpibaij  
-nsp_sub_pc_type ilu 
#-nsc_ksp_pc_side right 
#-nsp_pc_asm_overlap 3 
#-nsc_sub_pc_type ilu 
#-nsp_sub_pc_factor_mat_ordering rcm 
#-nsp_sub_pc_factor_levels 10 
*endif
*endif
*elseif(strcasecmp(GenData(NSTPRI_Algorithm),"Fractional_Step")==0)

######################################################
#FRACTIONAL STEP MODULE: VELOCITY system PREFIX: nspu_
#                        PRESSURE system PREFIX: nspp_
#                        TEMPERATURE system PREFIX: nspt_
######################################################
*if(strcasecmp(GenData(NSTPRI_Algebraic_solver),"Direct")==0)
*if(strcasecmp(GenData(NSTPRI_Direct_solver),"MUMPS")==0)
-nspfu_mat_type mpiaij
-nspfu_ksp_type preonly
-nspfu_pc_type lu
-nspfu_pc_factor_mat_solver_type mumps
-nspfu_ksp_diagonal_scale
*endif
*elseif(strcasecmp(GenData(NSTPRI_Algebraic_solver),"Iterative")==0)
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"HYPRE")==0)
-nspfu_mat_type mpiaij  
-nspfu_ksp_type bcgs
-nspfu_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfu_pc_type hypre
-nspfu_ksp_diagonal_scale

-nspfp_mat_type mpiaij  
-nspfp_ksp_type bcgs
-nspfp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfp_pc_type hypre
-nspfp_ksp_diagonal_scale

-nspft_mat_type mpiaij  
-nspft_ksp_type bcgs
-nspft_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspft_pc_type hypre
-nspft_ksp_diagonal_scale
*endif
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"TRILINOS")==0)
-nspfu_mat_type mpiaij  
-nspfu_ksp_type bcgs
-nspfu_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfu_pc_type ml
-nspfu_pc_mg_cycles 2
-nspfu_pc_mg_smoothup 5 
-nspfu_pc_mg_smoothdown 1
-nspfu_pc_mg_type multiplicative

-nspfp_mat_type mpiaij  
-nspfp_ksp_type bcgs
-nspfp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfp_pc_type ml
-nspfp_pc_mg_cycles 2
-nspfp_pc_mg_smoothup 5 
-nspfp_pc_mg_smoothdown 1
-nspfp_pc_mg_type multiplicative

-nspft_mat_type mpiaij  
-nspft_ksp_type bcgs
-nspft_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspft_pc_type ml
-nspft_pc_mg_cycles 2
-nspft_pc_mg_smoothup 5 
-nspft_pc_mg_smoothdown 1
-nspft_pc_mg_type multiplicative
*endif
*if(strcasecmp(GenData(NSTPRI_Iterative_solver),"BICGS")==0)
-nspfu_ksp_type bcgs 
-nspfu_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfu_ksp_max_it *GenData(NSTPRI_Solver_Max_iterations)
-nspfu_pc_type asm 
-nspfu_mat_type mpibaij  
-nspfu_sub_pc_type ilu 
#-nspfu_ksp_pc_side right 
#-nspfu_pc_asm_overlap 3 
#-nspfu_sub_pc_type ilu 
#-nspfu_sub_pc_factor_mat_ordering rcm 
#-nspfu_sub_pc_factor_levels 10 

-nspfp_ksp_type bcgs 
-nspfp_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspfp_ksp_max_it *GenData(NSTPRI_Solver_Max_iterations)
-nspfp_pc_type asm 
-nspfp_mat_type mpibaij  
-nspfp_sub_pc_type ilu 
#-nspfp_ksp_pc_side right 
#-nspfp_pc_asm_overlap 3 
#-nspfp_sub_pc_type ilu 
#-nspfp_sub_pc_factor_mat_ordering rcm 
#-nspfp_sub_pc_factor_levels 10 

-nspft_ksp_type bcgs 
-nspft_ksp_rtol *GenData(NSTPRI_Solver_tolerance)
-nspft_ksp_max_it *GenData(NSTPRI_Solver_Max_iterations)
-nspft_pc_type asm 
-nspft_mat_type mpibaij  
-nspft_sub_pc_type ilu 
#-nspft_ksp_pc_side right 
#-nspft_pc_asm_overlap 3 
#-nspft_sub_pc_type ilu 
#-nspft_sub_pc_factor_mat_ordering rcm 
#-nspft_sub_pc_factor_levels 10 
*endif
*endif
*endif
*endif
