*if(strcasecmp(GenData(PLAT_problem),"Off")!=0)
#####################################################
*#PLAT MODULE PREFIXES: plat PLAT *This must be on line 3
#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\ ====================================
*\ ============== 2D CASE =============
*\ ====================================
*\
*\ FUNCTIONS
*\ 
FUNCTIONS
END_FUNCTIONS

ON_NODES
*\
*\ DISPLACEMENT
*\ 
   DISPLACEMENT
*Set Cond PLAT_Point_Displacements    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Displacement_x),"Free_or_initial")==0)
*set var dx=0
*elseif(strcmp(cond(Type_Displacement_x),"Fixed")==0)
*set var dx=1
*endif
*if(strcmp(cond(Type_Displacement_y),"Free_or_initial")==0)
*set var dy=0
*elseif(strcmp(cond(Type_Displacement_y),"Fixed")==0)
*set var dy=1
*endif
*if(strcmp(cond(Type_Displacement_z),"Free_or_initial")==0)
*set var dz=0
*elseif(strcmp(cond(Type_Displacement_z),"Fixed")==0)
*set var dz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *dx*dy*dz *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Displacement_z)  *x   *y   *z)  
*end 
*Set Cond PLAT_Line_Displacements    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Line_Displacement_x),"Free_or_initial")==0)
*set var dx=0
*elseif(strcmp(cond(Type_Line_Displacement_x),"Fixed")==0)
*set var dx=1
*endif
*if(strcmp(cond(Type_Line_Displacement_y),"Free_or_initial")==0)
*set var dy=0
*elseif(strcmp(cond(Type_Line_Displacement_y),"Fixed")==0)
*set var dy=1
*endif
*if(strcmp(cond(Type_Line_Displacement_z),"Free_or_initial")==0)
*set var dz=0
*elseif(strcmp(cond(Type_Line_Displacement_z),"Fixed")==0)
*set var dz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *dx*dy*dz *tcl(FemussEvalDirichletCondition *cond(Value_Line_Displacement_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Displacement_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Displacement_z)  *x   *y   *z)  
*end 
   END_DISPLACEMENT
*\
*\ ROTATIONS
*\ 
   ROTATION
*Set Cond PLAT_Point_Rotations    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Rotation_x),"Free_or_initial")==0)
*set var rx=0
*elseif(strcmp(cond(Type_Rotation_x),"Fixed")==0)
*set var rx=1
*endif
*if(strcmp(cond(Type_Rotation_y),"Free_or_initial")==0)
*set var ry=0
*elseif(strcmp(cond(Type_Rotation_y),"Fixed")==0)
*set var ry=1
*endif
*if(strcmp(cond(Type_Rotation_z),"Free_or_initial")==0)
*set var rz=0
*elseif(strcmp(cond(Type_Rotation_z),"Fixed")==0)
*set var rz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *rx*ry*rz *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Rotation_z)  *x   *y   *z)  
*end 
*Set Cond PLAT_Line_Rotations    *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Line_Rotation_x),"Free_or_initial")==0)
*set var rx=0
*elseif(strcmp(cond(Type_Line_Rotation_x),"Fixed")==0)
*set var rx=1
*endif
*if(strcmp(cond(Type_Line_Rotation_y),"Free_or_initial")==0)
*set var ry=0
*elseif(strcmp(cond(Type_Line_Rotation_y),"Fixed")==0)
*set var ry=1
*endif
*if(strcmp(cond(Type_Line_Rotation_z),"Free_or_initial")==0)
*set var rz=0
*elseif(strcmp(cond(Type_Line_Rotation_z),"Fixed")==0)
*set var rz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum  *rx*ry*rz *tcl(FemussEvalDirichletCondition *cond(Value_Line_Rotation_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Rotation_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Rotation_z)  *x   *y   *z)  
*end 
   END_ROTATION
END_ON_NODES
ON_BOUNDARIES
*\
*\ LINE_FORCES
*\ 
*\   LINE_FORCES
*Set Cond PLAT_Line_Forces   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*\set var x = (NodesCoord(1,1) + NodesCoord(2,1))/2
*\set var y = (NodesCoord(1,2) + NodesCoord(2,2))/2
*\set var z = (NodesCoord(1,3) + NodesCoord(2,3))/2
*set var nface = ElemsNnodeFace
*format "%i %i %i %i %i %i %i %i %i %i %i"
1 *nface *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_z) *x1 *y1 *z1) *elemsConec(2)  *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_x) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_y) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Force_z) *x2 *y2 *z2)
*end
*\   END_LINE_FORCES
*\
*\ LINE_MOMENT
*\
*\   LINE_MOMENT
*Set Cond PLAT_Line_Moment   *elems
*loop elems *OnlyInCond *canrepeat
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*set var nface = ElemsNnodeFace
*format "%i %i %i %i %i %i %i %i"
2 *nface *elemsnum *elemsConec(1) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Moment_x) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Moment_y) *x1 *y1 *z1) *tcl(FemussEvalDirichletCondition *cond(Value_Line_Moment_z) *x1 *y1 *z1) *elemsConec(2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_x) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_y) *x2 *y2 *z2) *tcl(FemussEvalDirichletCondition  *cond(Value_Line_Moment_z) *x2 *y2 *z2)
*end
*\   END_LINE_MOMENT
END_ON_BOUNDARIES
SOURCE
*\
*\ FORCES
*\ 
   FORCES 
*Set Cond PLAT_Point_Forces   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Force_x),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(Type_Force_x),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(Type_Force_y),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(Type_Force_y),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(Type_Force_z),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(Type_Force_z),"Fixed")==0)
*set var fz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(Value_Force_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Force_z)  *x   *y   *z)
*end
   END_FORCES
*\
*\ MOMENT
*\
   MOMENT
*Set Cond PLAT_Point_Moment   *nodes
*loop nodes *OnlyInCond 
*if(strcmp(cond(Type_Moment_x),"Free_or_initial")==0)
*set var mx=0
*elseif(strcmp(cond(Type_Moment_x),"Fixed")==0)
*set var mx=1
*endif
*if(strcmp(cond(Type_Moment_y),"Free_or_initial")==0)
*set var my=0
*elseif(strcmp(cond(Type_Moment_y),"Fixed")==0)
*set var my=1
*endif
*if(strcmp(cond(Type_Moment_z),"Free_or_initial")==0)
*set var mz=0
*elseif(strcmp(cond(Type_Moment_z),"Fixed")==0)
*set var mz=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*format "%i %i%i%i %i %i %i"
*NodesNum *mx*my*mz *tcl(FemussEvalDirichletCondition *cond(Value_Moment_x)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Moment_y)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(Value_Moment_z)  *x   *y   *z)
*end
   END_MOMENT
END_SOURCE
ON_ELEMENTS
*\
*\ SURFACE_FORCES
*\ 
*\   SURFACE_FORCES
*Set Cond PLAT_Surface_Forces   *elems
*loop elems *OnlyInCond *canrepeat
*if(elemsNnode==4) 
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*set var x3 = NodesCoord(3,1)
*set var y3 = NodesCoord(3,2)
*set var z3 = NodesCoord(3,3)
*set var x4 = NodesCoord(4,1)
*set var y4 = NodesCoord(4,2)
*set var z4 = NodesCoord(4,3)
*set var Cx = (x1+x2+x3+x4)/4
*set var Cy = (y1+y2+y3+y4)/4
*set var Cz = (z1+z2+z3+z4)/4
*format "%i %i %i %i %i"
1 *elemsnum *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_x) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_y) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_z) *Cx *Cy *Cz)
*endif
*if(elemsNnode==3) 
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*set var x3 = NodesCoord(3,1)
*set var y3 = NodesCoord(3,2)
*set var z3 = NodesCoord(3,3)
*set var Cx = (x1+x2+x3)/3
*set var Cy = (y1+y2+y3)/3
*set var Cz = (z1+z2+z3)/3
*format "%i %i %i %i %i"
1 *elemsnum *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_x) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_y) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Force_z) *Cx *Cy *Cz)
*endif
*end
*\   END_SURFACE_FORCES
*\
*\ SURFACE_MOMENT
*\
*\   SURFACE_MOMENT
*Set Cond PLAT_Surface_Moment   *elems
*loop elems *OnlyInCond *canrepeat
*if(elemsNnode==4) 
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*set var x3 = NodesCoord(3,1)
*set var y3 = NodesCoord(3,2)
*set var z3 = NodesCoord(3,3)
*set var x4 = NodesCoord(4,1)
*set var y4 = NodesCoord(4,2)
*set var z4 = NodesCoord(4,3)
*set var Cx = (x1+x2+x3+x4)/4
*set var Cy = (y1+y2+y3+y4)/4
*set var Cz = (z1+z2+z3+z4)/4
*format "%i %i %i %i %i"
2 *elemsnum *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_x) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_y) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_z) *Cx *Cy *Cz)
*elseif(elemsNnode==3)
*set var x1 = NodesCoord(1,1)
*set var y1 = NodesCoord(1,2)
*set var z1 = NodesCoord(1,3)
*set var x2 = NodesCoord(2,1)
*set var y2 = NodesCoord(2,2)
*set var z2 = NodesCoord(2,3)
*set var x3 = NodesCoord(3,1)
*set var y3 = NodesCoord(3,2)
*set var z3 = NodesCoord(3,3)
*set var x4 = NodesCoord(4,1)
*set var y4 = NodesCoord(4,2)
*set var z4 = NodesCoord(4,3)
*set var Cx = (x1+x2+x3+x4)/4
*set var Cy = (y1+y2+y3+y4)/4
*set var Cz = (z1+z2+z3+z4)/4
*format "%i %i %i %i %i"
2 *elemsnum *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_x) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_y) *Cx *Cy *Cz) *tcl(FemussEvalDirichletCondition  *cond(Value_Surface_Moment_z) *Cx *Cy *Cz)
*endif 
*end
*\   END_SURFACE_MOMENT
END_ON_ELEMENTS
*endif
