#!/bin/bash

name="$1"
directory="$2"
ProblemType="$3"
input="data"
output="results"
post="post"
rst="rst"

#rem -------------------------------------------------------------------
#rem   Creates the directory for Femuss and mvs the .bas files into it
#rem -------------------------------------------------------------------

if [ ! -d $output ]; then
    mkdir $output
fi

if [ ! -d $post ]; then
    mkdir $post
fi

if [ ! -d $rst ]; then
    mkdir $rst
fi

if [ ! -d $input ]; then
    mkdir $input
fi

if [ -s $directory/$name.dat ];   then 
mv $directory/$name.dat     $directory/$input/$name.dat
else
rm $directory/$name.dat
fi

count=1

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-1.dat   $directory/$input/$name.dom.dat
else
rm $directory/$name-1.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat   $directory/$input/$name.dom.fix
else
rm $directory/$name-$count.dat   
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat   $directory/$input/$name.geo.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat   $directory/$input/$name.dom.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsi.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsi.fix
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ]  && [ ! -f $directory/$input/$name.nsi.sol ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsi.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.tem.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.tem.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.tem.sol ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.tem.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] ;   then 
mv $directory/$name-$count.dat    $directory/$input/$name.opt.dat
else
rm $directory/$name-$count.dat 
fi

count=$((count+1))
 
if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsc.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsc.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.nsc.sol ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsc.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.lmn.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.lmn.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ]&& [ ! -f $directory/$input/$name.lmn.sol ];  then
mv $directory/$name-$count.dat    $directory/$input/$name.lmn.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.wti.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.wti.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.wti.sol ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.wti.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.ale.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.ale.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.ale.sol ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.ale.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.wtm.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.wtm.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.wtm.fun
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ]  && [ ! -f $directory/$input/$name.wtm.sol ];     then
mv $directory/$name-$count.dat    $directory/$input/$name.wtm.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.int.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.int.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.lev.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.lev.fix
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.lev.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.sld.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.sld.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.sld.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plcd.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plcd.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plcd.mat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.plcd.sol ]; then
mv $directory/$name-$count.dat    $directory/$input/$name.plcd.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] ; then
mv $directory/$name-$count.dat    $directory/$input/$name.sea.dat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] ; then
mv $directory/$name-$count.dat    $directory/$input/$name.sea.com
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.hmz.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.hmz.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.hmz.sol ]; then
mv $directory/$name-$count.dat    $directory/$input/$name.hmz.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.beam.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.beam.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.beam.mat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.beam.sol ]; then
mv $directory/$name-$count.dat    $directory/$input/$name.beam.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))


if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsp.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsp.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then 
mv $directory/$name-$count.dat    $directory/$input/$name.nsp.sol
else
rm $directory/$name-$count.dat 
fi
count=$((count+1))


if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plat.dat
else
rm $directory/$name-$count.dat    
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plat.fix
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ];   then
mv $directory/$name-$count.dat    $directory/$input/$name.plat.mat
else
rm $directory/$name-$count.dat
fi
count=$((count+1))

if [ -s $directory/$name-$count.dat ] && [ ! -f $directory/$input/$name.plat.sol ]; then
mv $directory/$name-$count.dat    $directory/$input/$name.plat.sol
else
rm $directory/$name-$count.dat
fi
count=$((count+1))
