*if(strcasecmp(GenData(NSTINC_problem),"On")==0)
*#####################################################
*#NAVIERSTOKES MODULE PREFIXES: nsi NSTINC *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\ 
FUNCTIONS
*if(strcasecmp(GenData(NSI_Time_function_1),"Discrete")==0)
  FUNCTION: 1, DISCRETE, NUMBER_OF_DATA=*GenData(NSI_Funpar1_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu1
  END_FUNCTION
*else
  FUNCTION: 1,*GenData(NSI_Time_function_1),\
    PARAMETERS=*GenData(NSI_Funpar1_1),*GenData(NSI_Funpar1_2),*GenData(NSI_Funpar1_3),\
	       *GenData(NSI_Funpar1_4),*GenData(NSI_Funpar1_5),*GenData(NSI_Funpar1_6)
*endif
*if(strcasecmp(GenData(NSI_Time_function_2),"Discrete")==0)
  FUNCTION: 2, DISCRETE, NUMBER_OF_DATA=*GenData(NSI_Funpar2_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu2
  END_FUNCTION
*else
  FUNCTION: 2,*GenData(NSI_Time_function_2),\
    PARAMETERS=*GenData(NSI_Funpar2_1),*GenData(NSI_Funpar2_2),*GenData(NSI_Funpar2_3),\
	       *GenData(NSI_Funpar2_4),*GenData(NSI_Funpar2_5),*GenData(NSI_Funpar2_6)
*endif
*if(strcasecmp(GenData(NSI_Time_function_3),"Discrete")==0)
  FUNCTION: 3, DISCRETE, NUMBER_OF_DATA=*GenData(NSI_Funpar3_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu3
  END_FUNCTION
*else
  FUNCTION: 3,*GenData(NSI_Time_function_3),\
    PARAMETERS=*GenData(NSI_Funpar3_1),*GenData(NSI_Funpar3_2),*GenData(NSI_Funpar3_3),\
	       *GenData(NSI_Funpar3_4),*GenData(NSI_Funpar3_5),*GenData(NSI_Funpar3_6)
*endif
*if(strcasecmp(GenData(NSI_Time_function_4),"Discrete")==0)
  FUNCTION: 4, DISCRETE, NUMBER_OF_DATA=*GenData(NSI_Funpar4_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu4
  END_FUNCTION
*else
  FUNCTION: 4,*GenData(NSI_Time_function_4),\
    PARAMETERS=*GenData(NSI_Funpar4_1),*GenData(NSI_Funpar4_2),*GenData(NSI_Funpar4_3),\
	       *GenData(NSI_Funpar4_4),*GenData(NSI_Funpar4_5),*GenData(NSI_Funpar4_6)
*endif
*if(strcasecmp(GenData(NSI_Time_function_5),"Discrete")==0)
  FUNCTION: 5, DISCRETE, NUMBER_OF_DATA=*GenData(NSI_Funpar5_1)
    INCLUDE *tcl(FemussProblemName).nsi.fu5
  END_FUNCTION
*else
  FUNCTION: 5,*GenData(NSI_Time_function_5),\
    PARAMETERS=*GenData(NSI_Funpar5_1),*GenData(NSI_Funpar5_2),*GenData(NSI_Funpar5_3),\
	       *GenData(NSI_Funpar5_4),*GenData(NSI_Funpar5_5),*GenData(NSI_Funpar5_6)
*endif
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond VELOCITY_volume  *nodes
*Add Cond VELOCITY_surface *nodes
*Add Cond VELOCITY_line    *nodes
*Add Cond VELOCITY_point   *nodes
*Add Cond STRESS_VELOCITY_surface *nodes
*Add Cond STRESS_VELOCITY_line    *nodes
*Add Cond STRESS_VELOCITY_point   *nodes
*Add Cond STRESS_VELOCITY_surface_3D *nodes
*Add Cond STRESS_VELOCITY_line_3D   *nodes
*Add Cond STRESS_VELOCITY_point_3D  *nodes
ON_NODES
*\
*\ 2D case 
*\
*if(ndime==2)
*if(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Constant")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Carreau")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Power_Law")==0)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(1),"Temporarily_free")==0)
*set var fx=2
*elseif(strcmp(cond(1),"Switch_off")==0)
*set var fx=3
*elseif(strcmp(cond(1),"Fixed_inflow")==0)
*set var fx=4
*elseif(strcmp(cond(1),"Fix_Compression_Only")==0)
*set var fx=5
*elseif(strcmp(cond(1),"Elastic_Boundary")==0)
*set var fx=6
*elseif(strcmp(cond(1),"PML")==0)
*set var fx=8
*elseif(strcmp(cond(1),"Weak")==0)
*set var fx=9
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(2),"Temporarily_free")==0)
*set var fy=2
*elseif(strcmp(cond(2),"Switch_off")==0)
*set var fy=3
*elseif(strcmp(cond(2),"Fixed_inflow")==0)
*set var fy=4
*elseif(strcmp(cond(2),"Fix_Compression_Only")==0)
*set var fy=5
*elseif(strcmp(cond(2),"Elastic_Boundary")==0)
*set var fy=6
*elseif(strcmp(cond(2),"PML")==0)
*set var fy=8
*elseif(strcmp(cond(2),"Weak")==0)
*set var fy=9
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(7,int)
*if(strcasecmp(cond(8),"GLOBAL")==0)
*set var icode= 0
*elseif(strcasecmp(cond(8),"LOCAL-Femuss")==0)
*set var icode=-1
*else
*set var icode=LocalAxesNum
*endif
*format "%i%1i%1i%i%i"
*NodesNum  *fx*fy *tcl(FemussEvalDirichletCondition *cond(4)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z) *ft *icode
*end
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Giesekus")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"PTT")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Oldroyd_B")==0)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var fxx=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fxx=1
*elseif(strcmp(cond(1),"Temporarily_free")==0)
*set var fxx=2
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fyy=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fyy=1
*elseif(strcmp(cond(2),"Temporarily_free")==0)
*set var fyy=2
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fxy=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fxy=1
*elseif(strcmp(cond(3),"Temporarily_free")==0)
*set var fxy=2
*endif
*if(strcmp(cond(4),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(4),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(4),"Temporarily_free")==0)
*set var fx=2
*elseif(strcmp(cond(4),"Weak")==0)
*set var fx=9
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(5),"Temporarily_free")==0)
*set var fy=2
*elseif(strcmp(cond(4),"Weak")==0)
*set var fy=9
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(11,int)
*if(strcasecmp(cond(12),"GLOBAL")==0)
*set var icode= 0
*elseif(strcasecmp(cond(12),"LOCAL-Femuss")==0)
*set var icode=-1
*else
*set var icode=LocalAxesNum
*endif
*format "%i%1i%1i%1i%1i%1i%i%i"
*NodesNum  *fxx*fyy*fxy*fx*fy *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(7)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(8)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(9)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *ft *icode
*end
*endif
*else
*\
*\ 3D case 
*\
*if(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Constant")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Power_Law")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Carreau")==0)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(1),"Temporarily_free")==0)
*set var fx=2
*elseif(strcmp(cond(1),"Switch_off")==0)
*set var fx=3
*elseif(strcmp(cond(1),"Fix_Compression_Only")==0)
*set var fx=5
*elseif(strcmp(cond(1),"Elastic_Boundary")==0)
*set var fx=6
*elseif(strcmp(cond(1),"PML")==0)
*set var fx=8
*elseif(strcmp(cond(1),"Fixed_inflow")==0)
*set var fx=4
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(2),"Temporarily_free")==0)
*set var fy=2
*elseif(strcmp(cond(2),"Switch_off")==0)
*set var fy=3
*elseif(strcmp(cond(2),"Fixed_inflow")==0)
*set var fy=4
*elseif(strcmp(cond(2),"Fix_Compression_Only")==0)
*set var fy=5
*elseif(strcmp(cond(2),"Elastic_Boundary")==0)
*set var fy=6
*elseif(strcmp(cond(2),"PML")==0)
*set var fy=8
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fz=1
*elseif(strcmp(cond(3),"Temporarily_free")==0)
*set var fz=2
*elseif(strcmp(cond(3),"Switch_off")==0)
*set var fz=3
*elseif(strcmp(cond(3),"Fixed_inflow")==0)
*set var fz=4
*elseif(strcmp(cond(3),"Fix_Compression_Only")==0)
*set var fz=5
*elseif(strcmp(cond(3),"Elastic_Boundary")==0)
*set var fz=6
*elseif(strcmp(cond(3),"PML")==0)
*set var fz=8
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(7,int)
*if(strcasecmp(cond(8),"GLOBAL")==0)
*set var icode=0
*elseif(strcasecmp(cond(8),"LOCAL-Femuss")==0)
*set var icode=-1
*else
*set var icode=LocalAxesNum    
*endif
*format "%i%1i%1i%1i%i%i"
*NodesNum  *fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(4)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(5)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *ft *icode
*end
*elseif(strcasecmp(GenData(NSI_F1_Law_Viscosity),"Giesekus")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"PTT")==0 || strcasecmp(GenData(NSI_F1_Law_Viscosity),"Oldroyd_B")==0)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var fxx=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var fxx=1
*elseif(strcmp(cond(1),"Temporarily_free")==0)
*set var fxx=2
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fyy=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fyy=1
*elseif(strcmp(cond(2),"Temporarily_free")==0)
*set var fyy=2
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fzz=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fzz=1
*elseif(strcmp(cond(3),"Temporarily_free")==0)
*set var fzz=2
*endif
*if(strcmp(cond(4),"Free_or_initial")==0)
*set var fyz=0
*elseif(strcmp(cond(4),"Fixed")==0)
*set var fyz=1
*elseif(strcmp(cond(4),"Temporarily_free")==0)
*set var fyz=2
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var fxz=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var fxz=1
*elseif(strcmp(cond(5),"Temporarily_free")==0)
*set var fxz=2
*endif
*if(strcmp(cond(6),"Free_or_initial")==0)
*set var fxy=0
*elseif(strcmp(cond(6),"Fixed")==0)
*set var fxy=1
*elseif(strcmp(cond(6),"Temporarily_free")==0)
*set var fxy=2
*endif
*if(strcmp(cond(7),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(7),"Fixed")==0)
*set var fx=1
*elseif(strcmp(cond(7),"Temporarily_free")==0)
*set var fx=2
*elseif(strcmp(cond(8),"Weak")==0)
*set var fx=9
*endif
*if(strcmp(cond(8),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(8),"Fixed")==0)
*set var fy=1
*elseif(strcmp(cond(8),"Temporarily_free")==0)
*set var fy=2
*elseif(strcmp(cond(8),"Weak")==0)
*set var fy=9
*endif
*if(strcmp(cond(9),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(9),"Fixed")==0)
*set var fz=1
*elseif(strcmp(cond(9),"Temporarily_free")==0)
*set var fz=2
*elseif(strcmp(cond(8),"Weak")==0)
*set var fz=9
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(19,int)
*if(strcasecmp(cond(19),"GLOBAL")==0)
*set var icode=0
*elseif(strcasecmp(cond(19),"LOCAL-Femuss")==0)
*set var icode=-1
*else
*set var icode=LocalAxesNum    
*endif
*format "%i%1i%1i%1i%1i%1i%1i%1i%1i%1i%i%i"
*NodesNum  *fxx*fyy*fzz*fyz*fxz*fxy*fx*fy*fz *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(11)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(12)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(13)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(14)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(15)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(16)  *x   *y   *z)  *tcl(FemussEvalDirichletCondition *cond(17)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(18)  *x   *y   *z)  *ft *icode
*end
*endif
*endif
END_ON_NODES
*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond NSTINC_Boundary_2D *elems
*else
*set Cond NSTINC_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*set var nface = ElemsNnodeFace
*if(strcmp(cond(1),"Pressure")==0)
*set var ft=cond(6,int)
*if(nface == 2)
*iboun *nface *globalnodes(1) *globalnodes(2)  2 *cond(2) *ft 
*elseif(nface== 3)
*iboun *nface *globalnodes(1) *globalnodes(2) *globalnodes(3) 2 *cond(2) *ft 
*endif
*elseif(strcmp(cond(1),"Wall_law")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) 3 *cond(11)
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 3 *cond(11)
*endif
*elseif(strcmp(cond(1),"Slip_wall")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  4
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 4
*endif
*elseif(strcmp(cond(1),"Symmetry")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  4
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 4
*endif
*elseif(strcmp(cond(1),"Dynamic_pressure")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  5
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 5
*endif
*elseif(strcmp(cond(1),"Open_flow")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  6
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 6
*endif
*elseif(strcmp(cond(1),"No_slip_wall")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  7
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 7
*endif
*elseif(strcmp(cond(1),"Atmospheric_stress")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  8 *cond(2)
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 8 *cond(2)
*endif
*elseif(strcmp(cond(1),"Traction")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  9 *cond(8) *cond(9) *cond(10)
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 9 *cond(8) *cond(9) *cond(10)
*endif
*elseif(strcmp(cond(1),"weak_Pressure")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  10
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 10
*endif
*elseif(strcmp(cond(1),"OpenFlow_sup")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  11
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 11
*endif
*elseif(strcmp(cond(1),"weakpressure_sup")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  12
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 12
*endif
*elseif(strcmp(cond(1),"Neumann_sup")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  13
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 13
*endif
*elseif(strcmp(cond(1),"NRBC_open")==0)
*if(ndime==2)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  15
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 15
*endif
*else
*iboun *ElemsNnodeFace *globalnodes 15
*endif
*elseif(strcmp(cond(1),"NR_True")==0)
*if(ndime==2)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  20
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 20
*endif
*else
*iboun *ElemsNnodeFace *globalnodes 20
*endif
*elseif(strcmp(cond(1),"FSI_Boundary")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  17
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 17
*endif
*elseif(strcmp(cond(1),"ForceOutFlow")==0)
*if(nface == 2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  19
*elseif(nface== 3)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) *globalnodes(3) 19
*endif
*elseif(strcmp(cond(1),"Fixed")==0)
*set var ft=cond(6,int)
*if(strcasecmp(cond(7),"GLOBAL")==0)
*set var icode=0
*elseif(strcasecmp(cond(7),"LOCAL-Femuss")==0)
*set var icode=-1
*endif
*set var x1=NodesCoord(*localnodes(1),1)
*set var y1=NodesCoord(*localnodes(1),2)
*set var x2=NodesCoord(*localnodes(2),1)
*set var y2=NodesCoord(*localnodes(2),2)
*if(ndime==2)
*set var z=0
*if(ElemsNNodeFace==2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2)  1 *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z) *ft *icode
*else
*set var x3=NodesCoord(*localnodes(3),1)
*set var y3=NodesCoord(*localnodes(3),2)
*iboun *ElemsNnodeFace *globalnodes 1 *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z) *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z)   *ft *icode
*endif
*else
*set var x3=NodesCoord(*localnodes(3),1)
*set var y3=NodesCoord(*localnodes(3),2)
*set var z3=NodesCoord(*localnodes(3),3)
*set var z1=NodesCoord(*localnodes(1),3)
*set var z2=NodesCoord(*localnodes(2),3)
*if(ElemsNNodeFace==3)
*iboun *ElemsNnodeFace *globalnodes 1 \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(5)  *x1   *y1   *z1) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(5)  *x2   *y2   *z2) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(5)  *x3   *y3   *z3)  
*elseif(ElemsNNodeFace==4)
*set var x4=NodesCoord(*localnodes(4),1)
*set var y4=NodesCoord(*localnodes(4),2)
*set var z4=NodesCoord(*localnodes(4),3)
*iboun *ElemsNnodeFace *globalnodes 1 \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(4)  *x1   *y1   *z1) *tcl(FemussEvalDirichletCondition *cond(5)  *x1   *y1   *z1) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(4)  *x2   *y2   *z2) *tcl(FemussEvalDirichletCondition *cond(5)  *x2   *y2   *z2) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(4)  *x3   *y3   *z3) *tcl(FemussEvalDirichletCondition *cond(5)  *x3   *y3   *z3) \
       *tcl(FemussEvalDirichletCondition *cond(3)  *x4   *y4   *z4) *tcl(FemussEvalDirichletCondition *cond(4)  *x4   *y4   *z4) *tcl(FemussEvalDirichletCondition *cond(5)  *x4   *y4   *z4)  
*elseif(ElemsNNodeFace==9)
*endif
*endif
*elseif(strcmp(cond(1),"Weak_Velocity")==0)
*if(strcmp(cond(12),"Free_or_initial")==0)
*set var fweakx=0
*elseif(strcmp(cond(12),"Weak")==0)
*set var fweakx=1
*endif
*if(strcmp(cond(13),"Free_or_initial")==0)
*set var fweaky=0
*elseif(strcmp(cond(13),"Weak")==0)
*set var fweaky=1
*endif
*set var ft=cond(6,int)
*if(strcmp(cond(7),"GLOBAL")==0)
*set var icode=0
*elseif(strcasecmp(cond(7),"LOCAL-Femuss")==0)
*set var icode=-1
*endif
*if(ndime==2)
*if(ElemsNNodeFace==2)
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) 16 *fweakx *fweaky *cond(3) *cond(4) *icode
*else
*iboun *ElemsNnodeFace *globalnodes(1) *globalnodes(2) globalnodes(3) 16 *fweakx *fweaky *cond(3) *cond(4) *icode
*endif
*else
*if(strcmp(cond(14),"Free_or_initial")==0)
*set var fweakz=0
*elseif(strcmp(cond(14),"Weak")==0)
*set var fweakz=1
*endif
*if(ElemsNNodeFace==3)
*iboun *ElemsNnodeFace *globalnodes 16 *fweakx *fweaky *fweakz *cond(3) *cond(4) *cond(5) *icode
*elseif(ElemsNNodeFace==4)
*iboun *ElemsNnodeFace *globalnodes 16 *fweakx *fweaky *fweakz *cond(3) *cond(4) * cond(5) *icode
*elseif(ElemsNNodeFace==9)
*endif
*endif
*endif
*end elems
END_ON_BOUNDARIES
*endif
