*if(strcasecmp(GenData(NSCOMP_problem),"On")==0)
*#####################################################
*#NSCOMP MODULE PREFIXES: nsc NSCOMP *This must be on line 3
*#####################################################
*\
*\ Write File
*\
*realformat "%16.6f"
*intformat "%8i"
*\
*\ Write Functions
*\
FUNCTIONS
*if(strcasecmp(GenData(NSC_Time_function_1),"Discrete")==0)
  FUNCTION: 1, DISCRETE, NUMBER_OF_DATA=*GenData(NSC_Funpar1_1)
    INCLUDE *tcl(FemussProblemName).nsc.fu1
  END_FUNCTION
*else
  FUNCTION: 1,*GenData(NSC_Time_function_1),\
    PARAMETERS=*GenData(NSC_Funpar1_1),*GenData(NSC_Funpar1_2),*GenData(NSC_Funpar1_3),\
               *GenData(NSC_Funpar1_4),*GenData(NSC_Funpar1_5),*GenData(NSC_Funpar1_6)
*endif
END_FUNCTIONS
*\
*\ Write conditions
*\ 
*Set Cond NSCOMPRESSIBLE_volume  *nodes
*Add Cond NSCOMPRESSIBLE_surface *nodes
*Add Cond NSCOMPRESSIBLE_line    *nodes
*Add Cond NSCOMPRESSIBLE_point   *nodes
ON_NODES
*\
*\ 2D case 
*\
*if(ndime==2)
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var ro=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var ro=1
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(11,int)
*format "%i %1i%1i%1i%1i %i %i %i %i %i"
  *NodesNum  *ro*fx*fy*te *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(7)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(8)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *ft
*end
*else
*\
*\ 3D case 
*\
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"Free_or_initial")==0)
*set var ro=0
*elseif(strcmp(cond(1),"Fixed")==0)
*set var ro=1
*endif
*if(strcmp(cond(2),"Free_or_initial")==0)
*set var fx=0
*elseif(strcmp(cond(2),"Fixed")==0)
*set var fx=1
*endif
*if(strcmp(cond(3),"Free_or_initial")==0)
*set var fy=0
*elseif(strcmp(cond(3),"Fixed")==0)
*set var fy=1
*endif
*if(strcmp(cond(4),"Free_or_initial")==0)
*set var fz=0
*elseif(strcmp(cond(4),"Fixed")==0)
*set var fz=1
*endif
*if(strcmp(cond(5),"Free_or_initial")==0)
*set var te=0
*elseif(strcmp(cond(5),"Fixed")==0)
*set var te=1
*endif
*set var x =NodesCoord(1)
*set var y =NodesCoord(2)
*set var z =NodesCoord(3)
*set var ft=cond(11,int)
*format "%i %1i%1i%1i%1i%1i %i %i %i %i %i %i"
  *NodesNum  *ro*fx*fy*fz*te *tcl(FemussEvalDirichletCondition *cond(6)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(7)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(8)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(9)  *x   *y   *z) *tcl(FemussEvalDirichletCondition *cond(10)  *x   *y   *z) *ft
*end
*endif
END_ON_NODES
*\
*\ On boundaries
*\
ON_BOUNDARIES
*set var iboun=0
*if(ndime==2)
*set Cond NSCOMP_Boundary_2D *elems
*else
*set Cond NSCOMP_Boundary_3D *elems
*endif
*loop elems *onlyincond *canrepeat
*set var iboun=iboun+1
*if(strcmp(cond(1),"Wall_law")==0)
*iboun *ElemsNnodeFace *globalnodes 8 
*elseif(strcmp(cond(1),"Reverse_flow_penalty")==0)
*iboun *ElemsNnodeFace *globalnodes 9 *cond(5)
*elseif(strcmp(cond(1),"Neumann")==0)
*if(strcmp(cond(6),"Neumann")==0)
*iboun *ElemsNnodeFace *globalnodes 4 *cond(2) *cond(3) *cond(4) *cond(8)
*elseif(strcmp(cond(6),"Robin")==0)
*iboun *ElemsNnodeFace *globalnodes 5 *cond(2) *cond(3) *cond(4) *cond(8) *cond(7) *cond(9) 
*elseif(strcmp(cond(6),"Fixed")==0)
*iboun *ElemsNnodeFace *globalnodes 3 *cond(2) *cond(3) *cond(4)
*endif
*endif
*if(strcmp(cond(1),"Fixed")==0)
*if(strcmp(cond(6),"Neumann")==0)
*iboun *ElemsNnodeFace *globalnodes 6 *cond(8)
*elseif(strcmp(cond(6),"Robin")==0)
*iboun *ElemsNnodeFace *globalnodes 7 *cond(8) *cond(7) *cond(9)
*endif
*endif
*if(strcmp(cond(10),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 10 *cond(11) *cond(12) *cond(13)
*endif
*if(strcmp(cond(14),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 12  
*endif
*if(strcmp(cond(15),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 11 *cond(16) *cond(17) *cond(18) *cond(19)
*endif
*if(strcmp(cond(20),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 13 *cond(21) 
*endif
*if(strcmp(cond(22),"On")==0)
*if(strcmp(cond(23),"Free")==0)
*set var fweakx=0
*elseif(strcmp(cond(23),"Weak")==0)
*set var fweakx=1
*endif
*if(strcmp(cond(24),"Free")==0)
*set var fweaky=0
*elseif(strcmp(cond(24),"Weak")==0)
*set var fweaky=1
*endif
*if(strcmp(cond(28),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 15 *fweakx *fweaky *cond(25) *cond(26) *cond(27)
*else
*endif
*elseif(strcmp(cond(28),"On")==0)
*iboun *ElemsNnodeFace *globalnodes 16
*endif
*end elems
END_ON_BOUNDARIES
*endif
