*if(strcasecmp(GenData(ALEMOV_problem),"Off")!=0)
*#####################################################
*#ALEMOV MODULE PREFIX: ale ALE *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION
END_PROBLEM_DEFINITION 
PROPERTIES 
*if(strcasecmp(GenData(ALEMOV_Relax_Displacements),"On")==0)
*if(strcasecmp(GenData(ALEMOV_Displacement_Relaxation_scheme),"Heuristic")==0)
DISPLACEMENTS	RELAX	HEURISTIC
INITIAL RELAX:  *GenData(ALEMOV_Initial_relaxation_parameter)
KAPPA INCREASE: *GenData(ALEMOV_Kappa_Increase)
KAPPA POWER:    *GenData(ALEMOV_Kappa_Power)
KAPPA MINIM:    *GenData(ALEMOV_Kappa_Minim)
KAPPA MAXIM:    *GenData(ALEMOV_Kappa_Maxim)
END_HEURISTIC
*elseif(strcasecmp(GenData(ALEMOV_Displacement_Relaxation_scheme),"Heuristic_PointWise")==0)
DISPLACEMENTS	RELAX	HEUR_POINTWISE
INITIAL RELAX:  *GenData(ALEMOV_Initial_relaxation_parameter)
KAPPA INCREASE: *GenData(ALEMOV_Kappa_Increase)
KAPPA POWER:    *GenData(ALEMOV_Kappa_Power)
KAPPA MINIM:    *GenData(ALEMOV_Kappa_Minim)
KAPPA MAXIM:    *GenData(ALEMOV_Kappa_Maxim)
END_HEURISTIC
*elseif(strcasecmp(GenData(ALEMOV_Displacement_Relaxation_scheme),"Aitken")==0)
DISPLACEMENTS	RELAX	AITKEN
INITIAL RELAX:  *GenData(ALEMOV_Initial_relaxation_parameter)
END_AITKEN
*elseif(strcasecmp(GenData(ALEMOV_Displacement_Relaxation_scheme),"Aitken_PointWise")==0)
DISPLACEMENTS	RELAX	AITK_POINTWISE
INITIAL RELAX:  *GenData(ALEMOV_Initial_relaxation_parameter)
END_AITKEN
*elseif(strcasecmp(GenData(ALEMOV_Displacement_Relaxation_scheme),"Constant")==0)
DISPLACEMENTS	RELAX	CONSTANT
RELAXATION_PARAMETER	*GenData(ALEMOV_Relaxation_Parameter)
END_CONSTANT
*endif
*endif
*if(strcasecmp(GenData(ALEMOV_algorithm),"Solid")==0)
YOUNG=              *GenData(ALEMOV_SLDYoung)
POISSON=            *GenData(ALEMOV_SLDPoisson) $Poisson for attached solid module 
RELDI  =            *GenData(ALEMOV_SLDRELDI)   $Relaxation param for mesh disp
SLDVEL =            *GenData(ALEMOV_SLDVEL)     $Override ALE integration scheme and use Newmark
DISTORTION_ALGORITHM = *GenData(ALEMOV_SLDDistortion_Algorithm)
*endif
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT    
  FIXED_MESH_FROM:          *GenData(ALE_CUT_MESH_FROM)
  T1_SCHEME                 *GenData(ALE_tesc1) $ {BDF,BDF2,BDF3,CNOBS,CN}
  N_EULER_STEPS             *GenData(ALE_neule) $ number of backward euler steps   
  SAFETY_FACTOR:            *GenData(ALE_Safety_factor)  
  STEADY_STATE_TOLER:       *GenData(ALE_Steady_state_tolerance)   
  CP_CONVERGENCE_TOLERANCE: *GenData(ALE_CP_Convergence_tolerance)
*if(strcasecmp(GenData(ALE_Direct_solver),"LDU")==0)  
  ALGEBRAIC_SOLVER:       Direct
*else
  ALGEBRAIC_SOLVER:       MUMPS
*endif
  REMESHING_CRITERIA:    *GenData(ALE_Remeshing_Criteria)
$------------------------------------------------------------
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 PNTBC = *GenData(ALE_pntBC)
 START_POSTPROCES_AT           STEP =*GenData(ALE_Start_postprocess_at_step)
 POSTPROCESS ALEDISPL,         STEPS=*GenData(ALE_Postprocess_ALEdispl)
 POSTPROCESS ALEVELOC,         STEPS=*GenData(ALE_Postprocess_ALEveloc)
 POSTPROCESS PSTRAINS,         STEPS=*GenData(ALE_Postprocess_PStrains)
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
   CONTINUE
 INCLUDE *tcl(FemussProblemName).ale.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
