*if(strcasecmp(GenData(PLCd_problem),"Off")!=0)
#####################################################
*#PLCD MODULE PREFIXES: plcd PLCD *This must be on line 3
#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
NUMBER OF STAGES: *GenData(PLCd_Number_of_Stages:)
*for(i=1;i<=GenData(PLCd_Number_of_Stages:,int);i=i+1)
BEGIN STAGE
*set var N=GenData(PLCd_Substages_Data,int)
      NUMBER OF SUBSTAGES: *operation(N/4)
*for(j=1;j<=N;j=j+4)
   BEGIN SUBSTAGE
      Initial_Load_Factor:   *GenData(PLCd_Substages_Data,*j)
      Final_Load_Factor:     *GenData(PLCd_Substages_Data,*operation(j+1))
      Time_Step:             *GenData(PLCd_Substages_Data,*operation(j+2))
      Time_Interval:         *GenData(PLCd_Substages_Data,*operation(j+3))
      Maximum_NonLinear_Iterations: *GenData(PLCd_Maximum_Iterations:)
      Iterations_Tolerance:         *GenData(PLCd_Iterations_Tolerance:)
   END_SUBSTAGE
*end for
END_STAGE
*end for
*if(strcasecmp(GenData(PLCD_Analytical_solution),"On")==0)
ANALYTICAL_SOLUTION   *GenData(PLCD_Function_number) 
*endif
*if(strcasecmp(GenData(PLCD_Large_Strains),"Updated_formulation")==0)
FORMULATION: UPDATED
*endif
*if(strcasecmp(GenData(PLCD_Large_Strains),"Total_formulation")==0)
FORMULATION: TOTAL  
*endif
*if(strcasecmp(GenData(PLCD_Topology_Optimization),"SIMP")==0)

TOPOLOGY_OPTIMIZATION: SIMP
   P:                *GenData(PLCD_SIMP_P)
   ETA:              *GenData(PLCD_SIMP_ETA)
   XI:               *GenData(PLCD_SIMP_XI)
   CHIMIN:           *GenData(PLCD_SIMP_CHIMIN)
   CHIMAX:           *GenData(PLCD_SIMP_CHIMAX)
   VOLUME_FRACTION:  *GenData(PLCD_SIMP_VOLUME_FRACTION)
   CHI_SPACE:        *GenData(PLCD_SIMP_CHI_SPACE)
END_TOPOLOGY_OPTIMIZATION

*endif
*if(strcasecmp(GenData(PLCD_Topology_Optimization),"TopologicalDerivative")==0)
*if(strcasecmp(GenData(PLCD_STOCHASTIC_TOPOPT),"On")==0)
TOPOLOGY_OPTIMIZATION: TOPOLOGICAL_DERIVATIVE STOCHASTIC
      ALPHA: *GenData(PLCD_STOCHASTIC_ALPHA)
      LEVEL: *GenData(PLCD_STOCHASTIC_LEVEL)
*set var N=GenData(PLCd_STO_FORCES_Data,int)
      FUNCTION_FORCES  
*for(j=1;j<=N;j=j+11)
       *GenData(PLCd_STO_FORCES_Data,*j)  *GenData(PLCd_STO_FORCES_Data,*operation(j+1)) *GenData(PLCd_STO_FORCES_Data,*operation(j+2)) *GenData(PLCd_STO_FORCES_Data,*operation(j+3)) *GenData(PLCd_STO_FORCES_Data,*operation(j+4)) *GenData(PLCd_STO_FORCES_Data,*operation(j+5)) *GenData(PLCd_STO_FORCES_Data,*operation(j+6)) *GenData(PLCd_STO_FORCES_Data,*operation(j+7)) *GenData(PLCd_STO_FORCES_Data,*operation(j+8)) *GenData(PLCd_STO_FORCES_Data,*operation(j+9)) *GenData(PLCd_STO_FORCES_Data,*operation(j+10)) 
*end for      
      END_FUNCTION_FORCES
      SIMULTANEOUS_LOADS: *GenData(PLCd_STO_SimultaenousLoads)
   END_STOCHASTIC_DATA
*else
TOPOLOGY_OPTIMIZATION: TOPOLOGICAL_DERIVATIVE
*endif
   CHIMIN:           *GenData(PLCD_SIMP_CHIMIN)
   CHIMAX:           *GenData(PLCD_SIMP_CHIMAX)
   VOLUME_FRACTION:  *GenData(PLCD_SIMP_VOLUME_FRACTION)
   CHI_SPACE:        *GenData(PLCD_SIMP_CHI_SPACE)
   KPLUS    :        *GenData(PLCD_TD_KPLUS)
   KMINUS    :        *GenData(PLCD_TD_KMINUS)
   KPOWER    :        *GenData(PLCD_TD_KPOWER)
   ITE_VOLUME:        *GenData(PLCD_TD_ITER_VOLUME)
   TOL_VOLUME:        *GenData(PLCD_TD_TOLER_VOLUME)
   PRO_VOLUME:        *GenData(PLCD_TD_PROGRESSIVE_VOLUME)
   FREQUENCY:         *GenData(PLCD_TD_FREQUENCY)
END_TOPOLOGY_OPTIMIZATION
*endif
*if(strcasecmp(GenData(PLCD_BucklingAnalysis),"On")==0) 

BUCKLING ANALYSIS: ON
   NEIGEN: *GenData(PLCD_NEIGEN)
   MODIFY_BUCKLING: *GenData(PLCD_MODIFY_BUCKLING)
   EIGEN VALUE LIMITS: *GenData(PLCD_MB_VALUELIMITS)
   EIGEN VECTOR LIMIT: *GenData(PLCD_MB_VECTORLIMIT)
END_BUCKLING_ANALYSIS
*endif
*if(strcasecmp(GenData(PLCD_Gravity_acceleration),"On")==0) 
 GRAVITY:	  GX:   *GenData(PLCD_X_gravity) GY:   *GenData(PLCD_Y_gravity) GZ:   *GenData(PLCD_Z_gravity)     
*endif
FRAME_OF_REFERENCE:   *GenData(PLCD_FrameOfReference_acceleration)   FUNTY: *GenData(PLCD_FOR_Funty) *GenData(PLCD_FOR_PARA1) *GenData(PLCD_FOR_PARA2) *GenData(PLCD_FOR_PARA3) *GenData(PLCD_FOR_PARA4) *GenData(PLCD_FOR_PARA5) *GenData(PLCD_FOR_PARA6)  ACCELERATION: *GenData(PLCD_X_FOR) *GenData(PLCD_Y_FOR) *GenData(PLCD_Z_FOR)
*if(strcasecmp(GenData(PLCD_Rotating_frame_of_reference),"On")==0) 
ANG_VELOCITY: *GenData(PLCD_X_angular_velocity) *GenData(PLCD_Y_angular_velocity) *GenData(PLCD_Z_angular_velocity)                  
*endif

*if(strcasecmp(GenData(PLCD_Coarse_Mesh_Training),"On")==0)
COARSE_MESH_TRAINING: 1
   L2_Projection: *GenData(PLCD_CM_L2PROJECTION)
   MODEL: *GenData(PLCD_CM_MODEL)
   INPUT: *GenData(PLCD_CM_INPUT_DOFS)
   OUTPUT: *GenData(PLCD_CM_OUTPUT_DOFS)
   TRAINING BOX: *GenData(PLCD_CM_TRAINING_BOX)
   DELAY: *GenData(PLCD_CM_DELAY)
 END_CM_TRAINING  
*endif

*if(strcasecmp(GenData(PLCD_Plane_State_Assumption),"PLANE_STRESS")==0)
PLANE STRES
*elseif(strcasecmp(GenData(PLCD_Plane_State_Assumption),"PLANE_STRAIN")==0)
PLANE STRAI
*endif

END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
INCLUDE *tcl(FemussProblemName).plcd.mat
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT
   RELAXATION_PARAMETER: *GenDAta(PLCd_RelaxationParameter)  
*if(strcasecmp(GenData(PLCd_Start_NonLinearity_From_0),"ON")==0)
   START NON_LINEARITY_FROM_0
*endif 
*if(strcasecmp(GenData(PLCd_Stabilization),"VMS")==0)
   STABILIZATION: *GenData(PLCd_Type_of_stabilization) 
      RESIDUAL_TYPE: *GenData(PLCd_Residual_type)
      ADJOINT_OPERATOR_TYPE: *GenData(PLCd_Adjoint_Operator_type)
      TRANSIENT_SUBSCALES: *GenData(PLCd_Transient_Subscales)
*if(strcasecmp(GenData(PLCd_Type_of_stabilization),"OSS")==0)
*if(strcasecmp(GenData(PLCd_When_Compute_FE_Projection),"Previous_Nonlinear_Iteration")==0)
      COMPUTE_FINITE_ELEMENT_PROJECTION: Iteration
*elseif(strcasecmp(GenData(PLCd_When_Compute_FE_Projection),"Previous_Time_Step")==0)
      COMPUTE_FINITE_ELEMENT_PROJECTION: Time_Step
*endif      
      OSS_RELAXATION_SCHEME: *GenData(PLCd_Relaxation_scheme_OSS)   *GenData(PLCd_Relaxation_Parameter_OSS)
*endif 
   END_STABILIZATION 
   PROJECTION_TYPE: *GenData(PLCd_Projection_type) 
   STA_CONSTANTS: *GenData(PLCd_Stability_Algorithm_Coefficient_Displacement_Subscale) *GenData(PLCd_Stability_Algorithm_Coefficient_Pressure_Subscale) *GenData(PLCd_Stability_Algorithm_Coefficient_Strain_Subscale)
   CHARACTERISTIC_LENGTH: *GenData(characteristic_length_of_problem)
   H_COMPUTATION: *GenData(h_computation_for_stabiliaztion_parameters)
*endif
   SMOOTH_DISPLACEMENT_GRADIENTS:  *GenData(PLCd_Smooth_Displacement_Gradients)
   MIXED_FORMULATION: *GenData(PLCd_Use_Mixed_Formulation)
*if(strcasecmp(GenData(PLCD_Use_Line_Search),"ON")==0)
   LINE_SEARCH:   
      METHOD: *GenData(PLCD_Line_Search_Method)  
      CONVERGENCE_CRITERIA: *GenData(PLCD_Line_Search_Convergence_Criteria)   
      TOLERANCE: *GenData(PLCD_Line_Search_Tolerance)  
      RADIUS_OF_CONVERGENCE: *GenData(PLCD_Line_Search_Radius_Of_Convergence) 	
      MAX_ITERATIONS: *GenData(PLCD_Line_Search_Max_Iterations)
   END_LINE_SEARCH
*endif 
*if(strcasecmp(GenData(PLCD_Error_Estimator),"LAYERS")==0) 
ERROR_ESTIMATOR:         *GenData(PLCD_Error_Estimator), GENERAL: *GenData(PLCD_Error_LAYER_GENERAL), INTERFACE: *GenData(PLCD_Error_LAYER_INTERFACE), NLAYERS: *GenData(PLCD_Error_LAYER_NLAYERS)  
*else
 ERROR_ESTIMATOR:         *GenData(PLCD_Error_Estimator), MAX_ERROR: *GenData(PLCD_Error_Limits_Max), MIN_ERROR: *GenData(PLCD_Error_Limits_Min), CRITERIA: *GenData(PLCD_Error_Criteria)
 ERR_SUBSCALES_TYPE:      *GenData(PLCD_Error_SubsType)
*endif
*if(strcasecmp(GenData(PLCD_Transient_Problem),"ON")==0)
TRANSIENT_PROBLEM  
DYNAMIC EIGENPROBLEM ANALYSIS: *GenData(PLCD_DynamicEigenProblemAnalysis)
   NEIGEN: *GenData(PLCD_DynamicEigenNumberOfEigenValues)
END_DYNAMIC_EIGENPROBLEM
INITIAL STATIC STEP:          *GenData(PLCD_Initial_Static_Step)  
COMPUTE_INITIAL_ACCELERATION:	*GenData(PLCD_Compute_Initial_Acceleration)
*if(strcasecmp(GenData(PLCD_Time_integration),"Alpha_Generalized_Method")==0)
   T1_SCHEME:                          ALPHA
   T1_EULER_STEPS:                     0         
   T2_SCHEME:                          ALPHA
   T2_EULER_STEPS:                     0
   PARAMETERS_ALPHA_SCHEME:          *GenData(PLCD_Beta)   *GenData(PLCD_Gamma)   *GenData(PLCD_Alpha_F)   *GenData(PLCD_Alpha_M)   
   ESTIMATION_DISPLACEMENT_ORDER:      *GenData(PLCD_Initial_Estimation_Displacement_Next_Time_Step)   ALPHA
*elseif(strcasecmp(GenData(PLCD_Time_integration),"BDF")==0)
   T1_SCHEME:                          *GenData(PLCD_Time_integration_velocity)
   T1_EULER_STEPS:                     *GenData(PLCD_Euler_steps_velocity)          
   T2_SCHEME:                          *GenData(PLCD_Time_integration_acceleration)
   T2_EULER_STEPS:                     *GenData(PLCD_Euler_steps_acceleration)
   ESTIMATION_DISPLACEMENT_ORDER:      *GenData(PLCD_Initial_Estimation_Displacement_Next_Time_Step)   BDF
*endif                   
*endif
*if(strcasecmp(GenData(PLCD_Criteria_Convergence),"Unknowns")==0)
CONVERGENCE_CRITERIA:                  *GenData(PLCD_Criteria_Convergence) 
*else
CONVERGENCE_CRITERIA:                  *GenData(PLCD_Criteria_Convergence)	*GenData(PLCD_Forces_Criteria)	
*endif
NORM_OF_CONVERGENCE:                   *GenData(PLCD_Norm_of_Convergence)   
*if(strcasecmp(GenData(PLCD_Coupling_Problem),"ON")==0)
CP_CRITERIA_CONVERGE:  		       *GenData(PLCd_CP_Criteria_convergence)
CP_CONVERGENCE_TOLERANCE:              *GenData(PLCD_CP_Convergence_tolerance)   
CP_REGION:			       *GenData(PLCd_CP_Convergence_region) 
FSI_TRANSMISSION_CONDITIONS:	       *GenData(PLCd_CP_Transmission_Conditions_Method)	*GenData(PLCd_CP_Transmission_Conditions_Strategy)	*GenData(PLCd_CP_Penalization_Parameter)	
*if(strcasecmp(GenData(PLCd_CP_Relax_Tractions),"ON")==0)
*if(strcasecmp(GenData(PLCd_CP_Traction_Relaxation_Scheme),"Heuristic")==0)
TRACTION	RELAX	ON	HEURISTIC
INITIAL RELAX:  *GenData(PLCD_CP_Initial_relaxation_parameter)
KAPPA INCREASE: *GenData(PLCD_CP_Kappa_Increase)
KAPPA POWER:    *GenData(PLCD_CP_Kappa_Power)
KAPPA MINIM:    *GenData(PLCD_CP_Kappa_Minim)
KAPPA MAXIM:    *GenData(PLCD_CP_Kappa_Maxim)
END_HEURISTIC
*elseif(strcasecmp(GenData(PLCd_CP_Traction_Relaxation_Scheme),"Heuristic_PointWise")==0)
TRACTION	RELAX	ON	HEUR_POINTWISE
INITIAL RELAX:  *GenData(PLCD_CP_Initial_relaxation_parameter)
KAPPA INCREASE: *GenData(PLCD_CP_Kappa_Increase)
KAPPA POWER:    *GenData(PLCD_CP_Kappa_Power)
KAPPA MINIM:    *GenData(PLCD_CP_Kappa_Minim)
KAPPA MAXIM:    *GenData(PLCD_CP_Kappa_Maxim)
END_HEURISTIC
*elseif(strcasecmp(GenData(PLCd_CP_Traction_Relaxation_Scheme),"Aitken")==0)
TRACTION	RELAX	ON	AITKEN
INITIAL RELAX:  *GenData(PLCD_CP_Initial_relaxation_parameter)
END_AITKEN
*elseif(strcasecmp(GenData(PLCD_CP_Traction_Relaxation_scheme),"Aitken_PointWise")==0)
TRACTION	RELAX	ON	AITK_POINTWISE
INITIAL RELAX:  *GenData(PLCD_CP_Initial_relaxation_parameter)
END_AITKEN
*elseif(strcasecmp(GenData(PLCD_CP_Traction_Relaxation_scheme),"Constant")==0)
TRACTION	RELAX	ON	CONSTANT
RELAXATION_PARAMETER	*GenData(PLCD_CP_Relaxation_Parameter)
END_CONSTANT
*endif	
*endif
*endif
COARSENING CORRECTION FORCES: *GenData(PLCD_COARSENING_CORRECTION_FORCES)
COMPATIBILITY THERMAL STRAINS: *GenData(PLCD_COMPATIBILITY_THERMAL_STRAINS)
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 START_POSTPROCES_AT                STEP =*GenData(PLCD_Start_postprocess_at_step)
 POSTPROCESS DISPLACEMENT,          STEPS=*GenData(PLCD_Postprocess_Displacement)
 POSTPROCESS VELOCITIY,             STEPS=*GenData(PLCD_Postprocess_Velocity)
 POSTPROCESS ACCELERATION,          STEPS=*GenData(PLCD_Postprocess_Acceleration)
 POSTPROCESS STRESS,                STEPS=*GenData(PLCD_Postprocess_Stresses)
 POSTPROCESS STRAIN,                STEPS=*GenData(PLCD_Postprocess_Strains)
 POSTPROCESS MAT_DATA,              STEPS=*GenData(PLCD_Postprocess_MaterialData)
 POSTPROCESS MAT_DATA, ITERATIONS:  *GenData(PLCD_Postprocess_MatData_Iteration)
 POSTPROCESS SUBSCALES,             STEPS=*GenData(PLCD_Postprocess_Subscales) 
 POSTPROCESS TOPOL_DERIVATIVE:      STEPS=*GenData(PLCD_Postprocess_TopologicalDerivative)
 POSTPROCESS FSI_TRACTIONS:         STEPS=*GenData(PLCD_Postprocess_FSI_Tractions)
 POSTPROCESS DISPLACEMENT, ITERATIONS: *GenData(PLCD_Postprocess_Displ_Iteration)
 POSTPROCESS BUCKLING:              STEPS=*GenData(PLCD_Postprocess_Buckling)
 POSTPROCESS SEA:              STEPS=*GenData(PLCD_Postprocess_SEA)
 PNTBC:			       *GenData(PNTBC)
*if(*GenData(PLCD_Point_Tracking,int))
*set var N=GenData(PLCD_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(PLCD_Tracking_Coor,*i) *GenData(PLCD_Tracking_Coor,*operation(i+1)) *GenData(PLCD_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif
 PNTBC: *GenData(PLCD_Postprocess_BoundaryConditions)
 
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
*if(strcasecmp(GenData(PLCD_fix_pressure_mode),"Yes")==0)
      FIX_PRESSURE=*GenData(PLCD_Fix_pressure_on_node)
*elseif(strcasecmp(GenData(PLCD_fix_pressure_mode),"No")==0)
      DONT_FIX_PRESSURE
*endif
  INCLUDE *tcl(FemussProblemName).plcd.fix
END_BOUNDARY_CONDITIONS  
*endif
