*if(strcasecmp(GenData(HELMHZ_problem),"on")==0)
*#####################################################
*#HELMHZ MODULE PREFIXES: hmz HELMHZ *this must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------
PROBLEM_DEFINITION
  EQUATION_FORM= 	*GenData(HELMHZ_Equation_form)
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Mixed")==0)
  VARIATIONAL_FORM=	*GenData(HELMHZ_Variational_Form)
*endif
  EXTERNAL_SOURCE=	*GenData(HELMHZ_External_Source)
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
*if(strcasecmp(GenData(HELMHZ_External_Source),"Lighthill")==0)
  FOURIER_TRANSFORM_FREQUENCY= *GenData(HELMHZ_Fourier_Transform_Frequency)
*endif
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Scalar")==0)
  WAVENUMBER=             *GenData(HELMHZ_Wavenumber) 
*endif
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Mixed")==0)
  ANGULAR_FREQUENCY=	     *GenData(HELMHZ_Angular_Frequency)
  MU_U=			  *GenData(HELMHZ_MU_U)
  MU_P=			  *GenData(HELMHZ_MU_P)
*endif
END_PROPERTIES

$------------------------------------------------------------
END_PHYSICAL_PROBLEM
$------------------------------------------------------------
NUMERICAL_TREATMENT
  
  TYPE_OF_STABILIZATION= *GenData(HELMHZ_Type_of_Stabilization)
  FACES_STABILIZATION= *GenData(HELMHZ_Faces_Stabilization)
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Scalar")==0)
  TAU_CALCULATION= *GenData(Tau_Calculation)
*if(strcasecmp(GenData(Tau_Calculation),"Constant_Tau")==0)
  TAU_VALUE= *GenData(Tau_Value)
*endif
*endif
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Mixed")==0)
  TAU_U_CALCULATION= *GenData(Tau_u_Calculation)
*if(strcasecmp(GenData(Tau_u_Calculation),"Constant_Tau_u")==0)
  TAU_U_VALUE= *GenData(Tau_u_Value)
*endif
  TAU_P_CALCULATION= *GenData(Tau_p_Calculation)
*if(strcasecmp(GenData(Tau_p_Calculation),"Constant_Tau_p")==0)
  TAU_P_VALUE= *GenData(Tau_p_Value)
*endif
  CHARACTERISTICAL_LENGTH= *GenData(Characteristical_Lenght)
*endif
*if(strcasecmp(GenData(HELMHZ_Faces_Stabilization),"On")==0)
  DEL_CALCULATION= *GenData(Delta0_Calculation)
*if(strcasecmp(GenData(Delta0_Calculation),"Constant_Delta0")==0)
  DEL_VALUE= *GenData(Delta0_Value)
*endif
*endif
 MAXIMUM_NUMBER_OF_ITER=  *GenData(HMZ_Number_of_internal_iterations)  
 CONVERGENCE_TOLERANCE=   *GenData(HMZ_Convergence_tolerance)  
  
END_NUMERICAL_TREATMENT

$------------------------------------------------------------
OUTPUT_&_POST_PROCESS_&_INPUT_STRATEGY
 START_POSTPROCES_AT  STEP =*GenData(HMZ_Start_Postprocess_at_step)
 POSTPROCESS ACPRESS,     STEPS=*GenData(HMZ_Postprocess_Acpress)
END_OUTPUT_&_POST-PROCESS
$------------------------------------------------------------
BOUNDARY_CONDITIONS \
      CONSTANT_BOUNDARY_CONDITIONS
 INCLUDE *tcl(FemussProblemName).hmz.fix
END_BOUNDARY_CONDITIONS
$------------------------------------------------------------
*endif
