*if(strcasecmp(GenData(BEAM_problem),"Off")!=0)
#####################################################
*#BEAM MODULE PREFIXES: beam BEAM *This must be on line 3
#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION    
*if(strcasecmp(GenData(BEAM_TypeStabilization),"Implicit_OSS")==0)
 INCREASE NDOFN       *GenData(BEAM_TypeImplicit)
*endif
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
INCLUDE *tcl(FemussProblemName).beam.mat
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT
 STABILIZATION        *GenData(BEAM_Stabilization)
  STABILIZATION TYPE  *GenData(BEAM_TypeStabilization)
*if(strcasecmp(GenData(BEAM_TypeStabilization),"none")==0) 
*else
*if(strcasecmp(GenData(BEAM_TypeStabilization),"OSS")==0)
   PROJECTION TERMS   *GenData(BEAM_ProjTerms)
   PROJECTION TYPE    *GenData(BEAM_ProjectionType)
   PROJECT BC         *GenData(BEAM_ProjectBC)
   RELAX OSS          *GenData(BEAM_RelaxOSS) *GenData(BEAM_RelaxParameterOSS)
*elseif(strcasecmp(GenData(BEAM_TypeStabilization),"Implicit_OSS")==0)
   PROJECTION TERMS   *GenData(BEAM_ProjTerms)
*endif
   C1_Bending         *GenData(BEAM_C1_Bending)
   C2_Rotation        *GenData(BEAM_C2_Rotation)
   C3_Rotation        *GenData(BEAM_C3_Rotation)
*endif
  FACES_STABILIZATION *GenData(BEAM_Face_Stabilization)
   Delta              *GenData(BEAM_Face_Delta)
 END_STABILIZATION
 MAXIMUM_NUMBER_OF_ITERATIONS *GenData(BEAM_Number_of_internal_iterations)
  CONVERGENCE_TOLERANCE       *GenData(BEAM_Convergence_tolerance)
 DEBUGGING               
*if(strcasecmp(GenData(BEAM_DEBUGGING),"On")==0)
  MATLAB                 *GenData(BEAM_Matlab_Matrix)
  EXAER                  *GenData(BEAM_Exact_Error) *GenData(BEAM_Exaerr_Type)
  EXACSO                 *GenData(BEAM_Exact_Solution)
  CHECK EQUATION SYSTEM  *GenData(BEAM_CHECK_EQUATION_SYSTEM)
   SHOW_AFTER DIRICHLET  *GenData(SHOW_AFTER_DIRICHLET)
   SHOW_IN LOCAL_COORD   *GenData(BEAM_SHOW_IN_LOCAL_COORD)
   SHOW_SPECIFIC ELEMENT *GenData(SHOW_SPECIFIC_ELEMENT)
   SYMMETRY              *GenData(BEAM_CHECK_SYMMETRY)
   FORCE_SMALL_TO_ZERO   *GenData(BEAM_FORCE_TO_ZERO)
  CHECK FACE_OPERATIONS  *GenData(BEAM_CHECK_FACE_OPERATIONS)
*endif
 END_DEBUGGING
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 POSTPROCESS DISPLACEMENT        , STEPS=*GenData(BEAM_Postprocess_Displacement)
 POSTPROCESS ROTATION            , STEPS=*GenData(BEAM_Postprocess_Rotation)
 POSTPROCESS STRESS              , STEPS=*GenData(BEAM_Postprocess_Stresses)
 POSTPROCESS STRAIN              , STEPS=*GenData(BEAM_Postprocess_Strains)
 POSTPROCESS RESIDUAL            , STEPS=*GenData(BEAM_Postprocess_Residual)
 POSTPROCESS PROJECTION_RESIDUAL , STEPS=*GenData(BEAM_Postprocess_ProjectionResidual)
 POSTPROCESS FORCES              , STEPS=*GenData(BEAM_Postprocess_Forces)
 POSTPROCESS IMPLICIT_RESIDUAL   , STEPS=*GenData(BEAM_Postprocess_ImplicitResidual)
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS
  INCLUDE *tcl(FemussProblemName).beam.fix
END_BOUNDARY_CONDITIONS  
*endif
