*if(strcasecmp(GenData(PLAT_problem),"on")==0)
*#####################################################
*#PLAT MODULE PREFIXES: plat PLAT *this must be on line 3
*#####################################################
#PLAT MODULE PREFIX: plat_

*if(strcasecmp(GenData(plat_Algebraic_solver),"Direct")==0)
##########################################################################
#################################### DIRECT SOLVER 
*if(strcasecmp(GenData(plat_Direct_solver),"MUMPS")==0)
#################################### MUMPS
##########################################################################
-plat_mat_type mpiaij
-plat_ksp_type preonly
-plat_pc_type lu
-plat_pc_factor_mat_solver_type mumps
-plat_ksp_diagonal_scale

#-plat_ksp_type bcgs 
#-plat_ksp_pc_side right 
#-plat_ksp_rtol 1e-8 
#-plat_ksp_max_it 200
#-plat_pc_type asm 
#-plat_ksp_diagonal_scale
#-plat_pc_asm_overlap 3 
#-plat_sub_pc_type ilu 
#-plat_sub_pc_factor_mat_ordering rcm 
#-plat_sub_pc_factor_levels 10 
#-plat_mat_type mpibaij  

#-plat_mat_type mpiaij  
#-plat_ksp_type bcgs
#-plat_ksp_rtol 1e-8 
#-plat_pc_type ml
#-plat_pc_mg_cycles 2
#-plat_pc_mg_smoothup 5 
#-plat_pc_mg_smoothdown 1
#-plat_pc_mg_type multiplicative
#-plat_ksp_diagonal_scale
*endif


*elseif(strcasecmp(GenData(plat_Algebraic_solver),"Iterative")==0)
##########################################################################
#################################### ITERATIVE SOLVER
*if(strcasecmp(GenData(plat_Iterative_solver),"BICGS")==0)
#################################### BICGS
##########################################################################

#-plat_mat_type mpiaij
#-plat_ksp_type preonly
#-plat_pc_type lu
#-plat_pc_factor_mat_solver_type mumps
#-plat_ksp_diagonal_scale

-plat_ksp_type bcgs 
-plat_ksp_pc_side right 
-plat_ksp_rtol *GenData(plat_Solver_tolerance)
-plat_ksp_max_it *GenData(plat_Solver_Max_iterations)
-plat_pc_type asm 
-plat_ksp_diagonal_scale
#-plat_pc_asm_overlap 3 
-plat_sub_pc_type ilu 
#-plat_sub_pc_factor_mat_ordering rcm 
#-plat_sub_pc_factor_levels 10 
#-plat_mat_type mpibaij

#-plat_mat_type mpiaij  
#-plat_ksp_type bcgs
#-plat_ksp_rtol 1e-8 
#-plat_pc_type ml
#-plat_pc_mg_cycles 2
#-plat_pc_mg_smoothup 5 
#-plat_pc_mg_smoothdown 1
#-plat_pc_mg_type multiplicative
#-plat_ksp_diagonal_scale  
*endif
*endif
###########################################################################
*endif
